"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const layout_1 = __importDefault(require("./components/layout"));
const auth_context_1 = require("./features/authentication/context/auth.context");
const auth_page_1 = __importDefault(require("./features/authentication/pages/auth.page"));
const loading_bar_1 = __importDefault(require("./components/loading-bar"));
const settings_1 = require("./context/settings");
const react_file_type_icons_1 = require("@fluentui/react-file-type-icons");
const react_experiments_1 = require("@fluentui/react-experiments");
require("react-ace");
require("ace-builds/src-noconflict/theme-github");
require("ace-builds/src-noconflict/mode-javascript");
require("ace-builds/src-noconflict/mode-typescript");
require("ace-builds/src-noconflict/mode-css");
require("ace-builds/src-noconflict/mode-html");
require("ace-builds/src-noconflict/mode-json");
require("ace-builds/src-noconflict/mode-xml");
require("ace-builds/src-noconflict/mode-text");
require("ace-builds/src-noconflict/mode-sql");
require("ace-builds/src-noconflict/mode-yaml");
require("ace-builds/src-noconflict/mode-markdown");
require("ace-builds/src-noconflict/mode-sh");
(0, react_file_type_icons_1.initializeFileTypeIcons)();
(0, react_experiments_1.initializeFolderCovers)();
const App = () => {
    const { user, loading } = (0, auth_context_1.useAuth)();
    if (loading) {
        return react_1.default.createElement(loading_bar_1.default, null);
    }
    if (!user) {
        return react_1.default.createElement(auth_page_1.default, null);
    }
    return (react_1.default.createElement(settings_1.SettingsContextProvider, null,
        react_1.default.createElement(layout_1.default, null)));
};
exports.default = App;
