"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importDefault(require("react"));
const empty_folder_v2_svg_1 = __importDefault(require("../assets/svg/empty_folder_v2.svg"));
const empty_sharedwithme_svg_1 = __importDefault(require("../assets/svg/empty_sharedwithme.svg"));
const classNames = (0, react_1.mergeStyleSets)({
    root: {
        textAlign: 'center',
        paddingTop: 52,
        paddingBottom: 104
    },
    imageContainer: {
        margin: '0px auto',
        height: 208,
        width: 208
    },
    imageContainerCompact: {
        margin: '0px auto',
        height: 158,
        width: 158
    },
    rootCompact: {
        textAlign: 'center',
        paddingTop: 10,
        paddingBottom: 24
    },
    image: {
        width: '100%',
        height: '100%'
    },
    title: {
        padding: '16px 16px 0px',
        fontSize: 18,
        fontWeight: 600,
        maxWidth: 400,
        margin: '0px auto',
        color: '#323130'
    },
    subtitle: {
        fontSize: 14,
        fontWeight: 400,
        maxWidth: 400,
        color: '#605e5c',
        margin: '0 auto',
        padding: '8px 16px 0'
    }
});
const images = {
    files: empty_folder_v2_svg_1.default,
    contentTypes: empty_sharedwithme_svg_1.default
};
const Empty = ({ title, image, subtitle, compact }) => {
    return (react_2.default.createElement("div", { className: compact ? classNames.rootCompact : classNames.root },
        image && images[image] && (react_2.default.createElement("div", { className: compact
                ? classNames.imageContainerCompact
                : classNames.imageContainer },
            react_2.default.createElement("img", { className: classNames.image, src: images[image], alt: '' }))),
        title && react_2.default.createElement("div", { className: classNames.title }, title),
        subtitle && react_2.default.createElement("div", { className: classNames.subtitle }, subtitle)));
};
exports.default = Empty;
