"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const auth_context_1 = require("../features/authentication/context/auth.context");
const react_2 = require("@fluentui/react");
const react_router_1 = require("react-router");
const misc_1 = require("../helpers/misc");
const useStyles = (0, react_2.makeStyles)((theme) => ({
    header: {
        position: 'relative',
        display: 'flex',
        background: react_2.CommunicationColors.primary,
        width: '100%'
    },
    menu: {
        display: 'flex',
        alignItems: 'center',
        width: '100%'
    },
    dropdownRight: {
        right: '0 !important',
        left: 'auto !important'
    },
    divider: {
        flexGrow: 1
    },
    button: {
        color: `${theme.palette.white} !important`
    }
}));
const Header = () => {
    const { user, logOut } = (0, auth_context_1.useAuth)();
    const history = (0, react_router_1.useHistory)();
    const styles = useStyles();
    return (react_1.default.createElement("header", { className: styles.header },
        react_1.default.createElement(react_2.Stack, { horizontal: true, horizontalAlign: 'space-between', style: { width: '100%' } },
            react_1.default.createElement(react_2.Stack, { horizontal: true },
                react_1.default.createElement(react_2.PrimaryButton, { className: styles.button, menuIconProps: { style: { display: 'none' } }, style: { height: 48 }, href: '/admin' }, "Burdy")),
            react_1.default.createElement(react_2.Stack, { horizontal: true },
                react_1.default.createElement(react_2.PrimaryButton, { className: styles.button, menuIconProps: { style: { display: 'none' } }, style: { height: 48 }, href: 'https://burdy.io/docs', target: '_blank' }, "Docs"),
                react_1.default.createElement(react_2.PrimaryButton, { menuIconProps: { style: { display: 'none' } }, style: { height: 48, minWidth: 0, padding: '0 12px' }, onRenderIcon: () => (react_1.default.createElement(react_2.Persona, { size: react_2.PersonaSize.size32, initialsColor: react_2.PersonaInitialsColor.rust, text: (0, misc_1.userPersonaText)(user), hidePersonaDetails: true })), menuProps: {
                        items: [
                            {
                                key: 'profile',
                                text: 'Profile',
                                onClick: () => {
                                    history.push(`/users/edit/${user.id}`);
                                }
                            },
                            {
                                key: 'logout',
                                text: 'Log Out',
                                onClick: () => {
                                    logOut.execute();
                                }
                            }
                        ]
                    } })))));
};
exports.default = Header;
