"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const rhf_components_1 = require("./rhf-components");
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const InsertLinkDialog = ({ isOpen, onDismiss, onInsert, }) => {
    const { control, handleSubmit, reset } = (0, react_hook_form_1.useForm)({
        mode: 'all',
        defaultValues: {
            target: '_self',
        }
    });
    (0, react_2.useEffect)(() => {
        if (isOpen) {
            reset({
                target: '_self',
            });
        }
    }, [isOpen]);
    return (react_2.default.createElement(react_1.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_1.DialogType.close,
            title: 'Insert link',
        }, modalProps: {
            styles: { main: { maxWidth: 450 } },
        } },
        react_2.default.createElement(react_1.Stack, { tokens: {
                childrenGap: 8,
            } },
            react_2.default.createElement(rhf_components_1.ControlledTextField, { name: "url", label: "URL", control: control }),
            react_2.default.createElement(rhf_components_1.ControlledCombobox, { control: control, name: "target", label: "Target", options: [{
                        key: '_self',
                        text: 'Self',
                    }, {
                        key: '_blank',
                        text: 'Blank',
                    }] })),
        react_2.default.createElement(react_1.DialogFooter, null,
            react_2.default.createElement(react_1.DefaultButton, { onClick: onDismiss, text: "Cancel" }),
            react_2.default.createElement(react_1.PrimaryButton, { onClick: () => {
                    handleSubmit((data) => {
                        onInsert(data);
                    })();
                }, text: "Insert" }))));
};
exports.default = InsertLinkDialog;
