"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_2 = require("@fluentui/react");
const useStyles = (0, react_2.makeStyles)({
    loadingWrapper: {
        display: 'flex !important',
        justifyContent: 'center',
        alignItems: 'center',
        top: 0,
        left: 0,
        right: 0,
        bottom: 0,
    },
});
const LoadingBar = ({ loading = true, children, isFixed = false, }) => {
    const styles = useStyles();
    return loading ? (react_1.default.createElement(react_2.Spinner, { size: react_2.SpinnerSize.large, className: styles.loadingWrapper, style: { position: isFixed ? 'fixed' : 'absolute' } })) : (children);
};
exports.default = LoadingBar;
