import { Control, UseControllerProps } from 'react-hook-form';
import { ICheckboxProps, IChoiceGroup, IColorPickerProps, IComboBoxProps, IDatePickerProps, IDropdownProps, ITextFieldProps } from '@fluentui/react';
import React from 'react';
export interface HookFormProps {
    control: Control<any>;
    name: string;
    label?: string;
    rules?: UseControllerProps['rules'];
    defaultValue?: any;
    disabled?: boolean;
}
declare const ControlledTextField: React.FC<HookFormProps & ITextFieldProps>;
interface ExtendedCheckbox {
    defaultCheckedValue?: any;
}
declare const ControlledCheckbox: React.FC<HookFormProps & ICheckboxProps & ExtendedCheckbox>;
declare const ControlledDropdown: React.FC<HookFormProps & IDropdownProps>;
declare const ControlledDatePicker: React.FC<HookFormProps & IDatePickerProps>;
declare const ControlledColorPicker: React.FC<HookFormProps & IColorPickerProps>;
declare const ControlledCombobox: React.FC<HookFormProps & IComboBoxProps>;
declare const ControlledChoiceGroup: React.FC<HookFormProps & IChoiceGroup>;
export { ControlledTextField, ControlledCheckbox, ControlledCombobox, ControlledDropdown, ControlledDatePicker, ControlledChoiceGroup, ControlledColorPicker, };
