"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const hoc_1 = require("../helpers/hoc");
const content_types_context_1 = require("../features/content-types/context/content-types.context");
const loading_bar_1 = __importDefault(require("../components/loading-bar"));
const dynamic_group_1 = __importDefault(require("./dynamic-group"));
const rhf_components_1 = require("../components/rhf-components");
const dynamic_form_1 = require("./dynamic-form");
const utility_1 = require("../helpers/utility");
const posts_context_1 = require("../features/posts/context/posts.context");
const uuid_1 = require("uuid");
const DynamicComponent = ({ field, name }) => {
    var _a;
    const { getSingleContentType } = (0, content_types_context_1.useContentTypes)();
    const { setLoadingContent } = (0, posts_context_1.usePosts)();
    const { disabled, control, watch } = (0, dynamic_form_1.useExtendedFormContext)();
    (0, react_1.useEffect)(() => {
        if (field === null || field === void 0 ? void 0 : field.component) {
            getSingleContentType.execute({ name: field === null || field === void 0 ? void 0 : field.component });
        }
    }, [field === null || field === void 0 ? void 0 : field.component]);
    (0, react_1.useEffect)(() => {
        const id = (0, uuid_1.v4)();
        setLoadingContent(id, getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.loading);
        return () => {
            setLoadingContent(id, false);
        };
    }, [getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.loading]);
    const enabled = watch(`${name}_$enabled`);
    const displayComponent = (0, react_1.useMemo)(() => {
        if (!(0, utility_1.isTrue)(field === null || field === void 0 ? void 0 : field.allowToggle))
            return true;
        return (0, utility_1.isTrue)(enabled);
    }, [enabled, field === null || field === void 0 ? void 0 : field.allowToggle]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", null,
            react_1.default.createElement(react_2.Stack, { horizontal: true, horizontalAlign: "space-between", verticalAlign: "center", tokens: { childrenGap: 8 } },
                react_1.default.createElement(react_2.Label, null, ((_a = field === null || field === void 0 ? void 0 : field.label) === null || _a === void 0 ? void 0 : _a.length) > 0 ? field === null || field === void 0 ? void 0 : field.label : field === null || field === void 0 ? void 0 : field.name),
                (0, utility_1.isTrue)(field === null || field === void 0 ? void 0 : field.allowToggle) && (react_1.default.createElement(rhf_components_1.ControlledCheckbox, { disabled: disabled, control: control, label: "Enable", name: `${name}_$enabled` }))),
            react_1.default.createElement(react_2.Separator, null)),
        react_1.default.createElement(loading_bar_1.default, { loading: getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.loading }, displayComponent && (react_1.default.createElement(dynamic_group_1.default, { field: getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.result, name: name })))));
};
exports.default = (0, hoc_1.composeWrappers)({
    contentTypesContext: content_types_context_1.ContentTypesContextProvider,
})(DynamicComponent);
