"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormHelperContextProvider = exports.useExtendedFormContext = void 0;
const react_1 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const dynamic_group_1 = __importDefault(require("./dynamic-group"));
const FormHelperContext = (0, react_1.createContext)({});
const FormHelperContextProvider = ({ disabled: propsDisabled, narrow: propsNarrow, children, }) => {
    const [disabled, setDisabled] = (0, react_1.useState)(propsDisabled);
    const [narrow, setNarrow] = (0, react_1.useState)(propsNarrow);
    const formContext = (0, react_hook_form_1.useFormContext)();
    (0, react_1.useEffect)(() => {
        setDisabled(propsDisabled);
    }, [propsDisabled]);
    return (react_1.default.createElement(FormHelperContext.Provider, { value: Object.assign({ disabled,
            setDisabled,
            narrow,
            setNarrow }, formContext) }, children));
};
exports.FormHelperContextProvider = FormHelperContextProvider;
const useExtendedFormContext = () => (0, react_1.useContext)(FormHelperContext);
exports.useExtendedFormContext = useExtendedFormContext;
const DynamicForm = (0, react_1.forwardRef)(({ field, name, defaultValues, onChange, disabled = false, narrow = false }, ref) => {
    const methods = (0, react_hook_form_1.useForm)({
        mode: 'all',
        shouldUnregister: true,
        defaultValues,
    });
    (0, react_1.useEffect)(() => {
        methods.watch((val) => {
            if (onChange) {
                onChange(val);
            }
        });
    }, []);
    (0, react_1.useImperativeHandle)(ref, () => ({
        getForm() {
            return methods;
        },
    }), []);
    return (react_1.default.createElement(react_hook_form_1.FormProvider, Object.assign({}, methods),
        react_1.default.createElement(FormHelperContextProvider, { disabled: disabled, narrow: narrow },
            react_1.default.createElement(dynamic_group_1.default, { name: name, field: field }))));
});
exports.default = DynamicForm;
