"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const react_2 = require("@fluentui/react");
const react_beautiful_dnd_1 = require("react-beautiful-dnd");
const dynamic_group_1 = __importDefault(require("./dynamic-group"));
const dynamic_form_1 = require("./dynamic-form");
const theme = (0, react_2.getTheme)();
const styles = (0, react_2.mergeStyleSets)({
    headingWrapper: {
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'center',
        justifyContent: 'space-between',
    },
    draggable: {
        padding: 20,
        marginBottom: 15,
        border: `1px solid ${theme.palette.neutralLight}`,
    },
});
const DynamicRepeatable = ({ field, name, }) => {
    var _a;
    const { control, disabled } = (0, dynamic_form_1.useExtendedFormContext)();
    const { fields, append, remove, move } = (0, react_hook_form_1.useFieldArray)({
        control,
        name,
    });
    const getItemStyle = (isDragging, draggableStyle) => {
        if (isDragging) {
            return Object.assign({ backgroundColor: theme.palette.neutralLighterAlt, boxShadow: theme.effects.elevation8, userSelect: 'none' }, draggableStyle);
        }
        return Object.assign({}, draggableStyle);
    };
    const maxElements = (0, react_1.useMemo)(() => {
        let max = 0;
        try {
            max = parseInt(field === null || field === void 0 ? void 0 : field.max, 10);
        }
        catch (err) {
            //
        }
        return max;
    }, [field === null || field === void 0 ? void 0 : field.max]);
    const onDragEnd = (result) => {
        var _a, _b;
        // dropped outside the list
        if (!result.destination) {
            return;
        }
        move((_a = result === null || result === void 0 ? void 0 : result.source) === null || _a === void 0 ? void 0 : _a.index, (_b = result === null || result === void 0 ? void 0 : result.destination) === null || _b === void 0 ? void 0 : _b.index);
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        ((_a = field === null || field === void 0 ? void 0 : field.label) === null || _a === void 0 ? void 0 : _a.length) > 0 && react_1.default.createElement(react_2.Label, null, field === null || field === void 0 ? void 0 : field.label),
        react_1.default.createElement(react_beautiful_dnd_1.DragDropContext, { onDragEnd: onDragEnd },
            react_1.default.createElement(react_beautiful_dnd_1.Droppable, { droppableId: name }, (provided) => (react_1.default.createElement("div", Object.assign({}, provided.droppableProps, { ref: provided.innerRef }),
                react_1.default.createElement(react_2.Stack, { tokens: { childrenGap: 10 } },
                    fields.map((formField, index) => (react_1.default.createElement(react_beautiful_dnd_1.Draggable, { isDragDisabled: disabled, key: formField.id, draggableId: formField.id, index: index }, (provided, snapshot) => {
                        var _a;
                        return (react_1.default.createElement("div", Object.assign({ ref: provided.innerRef }, provided.draggableProps, provided.dragHandleProps, { style: getItemStyle(snapshot.isDragging, provided.draggableProps.style), className: styles.draggable }),
                            react_1.default.createElement("div", { className: styles.headingWrapper },
                                ((_a = field === null || field === void 0 ? void 0 : field.label) === null || _a === void 0 ? void 0 : _a.length) > 0 && (react_1.default.createElement(react_2.Label, null, `${field === null || field === void 0 ? void 0 : field.label} [${index}]`)),
                                react_1.default.createElement(react_2.Stack, { horizontal: true, tokens: { childrenGap: 8 } },
                                    react_1.default.createElement(react_2.IconButton, { disabled: disabled || index === 0, onClick: () => move(index, index - 1), iconProps: { iconName: 'Up' }, title: "Move Up", ariaLabel: "Move Up" }),
                                    react_1.default.createElement(react_2.IconButton, { disabled: disabled || index >= (fields === null || fields === void 0 ? void 0 : fields.length) - 1, onClick: () => move(index, index + 1), iconProps: { iconName: 'Down' }, title: "Move Down", ariaLabel: "Move Down" }),
                                    react_1.default.createElement(react_2.IconButton, { iconProps: { iconName: 'Delete' }, disabled: disabled, title: "Delete", ariaLabel: "Delete", onClick: () => remove(index) }))),
                            react_1.default.createElement(dynamic_group_1.default, { name: `${name || ''}[${index}]`, field: {
                                    fields: field === null || field === void 0 ? void 0 : field.fields,
                                } })));
                    }))),
                    provided.placeholder))))),
        react_1.default.createElement(react_2.Separator, { style: { marginTop: 10 } },
            react_1.default.createElement(react_2.ActionButton, { disabled: disabled || (maxElements && (fields === null || fields === void 0 ? void 0 : fields.length) >= maxElements), iconProps: {
                    iconName: 'Add',
                }, onClick: () => {
                    append({});
                } }, "Add item"))));
};
exports.default = DynamicRepeatable;
