"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const draft_js_1 = require("draft-js");
const dynamic_richtext_context_1 = __importDefault(require("./dynamic-richtext.context"));
const assets_context_1 = require("../features/assets/context/assets.context");
require("draft-js/dist/Draft.css");
const richtext_1 = __importDefault(require("./richtext/richtext"));
const draft_link_inline_1 = require("./richtext/inline/draft-link-inline");
const react_hook_form_1 = require("react-hook-form");
const DynamicRichText = ({ field, name, control }) => {
    return (react_1.default.createElement(react_hook_form_1.Controller, { name: name, control: control, render: ({ field: controllerField }) => {
            const defaultEditorState = (0, react_1.useMemo)(() => {
                let value = {};
                try {
                    // eslint-disable-next-line no-underscore-dangle
                    value = JSON.parse(controllerField.value);
                }
                catch (err) {
                    //
                }
                if (!(value === null || value === void 0 ? void 0 : value.entityMap)) {
                    value.entityMap = {};
                }
                if (!value.blocks) {
                    value.blocks = [];
                }
                try {
                    return draft_js_1.EditorState.createWithContent((0, draft_js_1.convertFromRaw)(value), (0, draft_link_inline_1.createLinkDecorator)());
                }
                catch (e) {
                    return draft_js_1.EditorState.createEmpty();
                }
            }, []);
            return (react_1.default.createElement(dynamic_richtext_context_1.default, { defaultEditorState: defaultEditorState },
                react_1.default.createElement(assets_context_1.AssetsContextProvider, null,
                    react_1.default.createElement(richtext_1.default, { field: field, name: name, onChange: (val) => {
                            controllerField.onChange(val);
                        } }))));
        } }));
};
exports.default = DynamicRichText;
