"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const hoc_1 = require("../helpers/hoc");
const content_types_context_1 = require("../features/content-types/context/content-types.context");
const loading_bar_1 = __importDefault(require("../components/loading-bar"));
const react_beautiful_dnd_1 = require("react-beautiful-dnd");
const react_hook_form_1 = require("react-hook-form");
// eslint-disable-next-line max-len
const content_types_components_select_panel_1 = __importDefault(require("../features/content-types/components/content-types-components-select-panel"));
const dynamic_group_1 = __importDefault(require("./dynamic-group"));
const dynamic_form_1 = require("./dynamic-form");
const classnames_1 = __importDefault(require("classnames"));
const back_panel_1 = __importDefault(require("../components/back-panel"));
const posts_context_1 = require("../features/posts/context/posts.context");
const uuid_1 = require("uuid");
const theme = (0, react_2.getTheme)();
const styles = (0, react_2.mergeStyleSets)({
    headingWrapper: {
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'center',
        justifyContent: 'space-between'
    },
    draggable: {
        padding: 20,
        border: `1px solid ${theme.palette.neutralLight}`
    },
    draggableMargin: {
        marginBottom: 15
    },
    component: {
        position: 'relative'
    }
});
const DynamicZoneComponentImpl = ({ name, component, onDelete, disableDown, disableUp, onMove }) => {
    var _a, _b, _c, _d;
    const { control, disabled, narrow } = (0, dynamic_form_1.useExtendedFormContext)();
    const [panelOpened, setPanelOpened] = (0, react_1.useState)(false);
    const { setLoadingContent } = (0, posts_context_1.usePosts)();
    const { getSingleContentType } = (0, content_types_context_1.useContentTypes)();
    (0, react_1.useEffect)(() => {
        if (component) {
            getSingleContentType.execute({ name: component });
        }
    }, [component]);
    (0, react_1.useEffect)(() => {
        const id = (0, uuid_1.v4)();
        setLoadingContent(id, getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.loading);
        return () => {
            setLoadingContent(id, false);
        };
    }, [getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.loading]);
    return (react_1.default.createElement("div", { className: styles.component },
        react_1.default.createElement("div", { className: styles.headingWrapper },
            react_1.default.createElement(react_2.Label, { style: { overflow: 'hidden' } }, (_a = getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.result) === null || _a === void 0 ? void 0 : _a.name),
            react_1.default.createElement(react_2.Stack, { horizontal: true, tokens: { childrenGap: 8 } },
                narrow && react_1.default.createElement(react_2.IconButton, { onClick: () => {
                        setPanelOpened(true);
                    }, iconProps: { iconName: 'Edit' }, title: 'Edit', ariaLabel: 'Edit' }),
                react_1.default.createElement(react_2.IconButton, { disabled: disabled || disableUp, onClick: () => onMove(-1), iconProps: { iconName: 'Up' }, title: 'Move Up', ariaLabel: 'Move Up' }),
                react_1.default.createElement(react_2.IconButton, { disabled: disabled || disableDown, onClick: () => onMove(1), iconProps: { iconName: 'Down' }, title: 'Move Down', ariaLabel: 'Move Down' }),
                react_1.default.createElement(react_2.IconButton, { iconProps: { iconName: 'Delete' }, disabled: disabled, title: 'Delete', ariaLabel: 'Delete', onClick: () => onDelete() }))),
        react_1.default.createElement(loading_bar_1.default, { loading: getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.loading },
            react_1.default.createElement(react_hook_form_1.Controller, { name: `${name}.component`, control: control, defaultValue: (_b = getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.result) === null || _b === void 0 ? void 0 : _b.name, render: ({ field }) => {
                    (0, react_1.useEffect)(() => {
                        var _a;
                        field.onChange((_a = getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.result) === null || _a === void 0 ? void 0 : _a.name);
                    }, []);
                    return null;
                } }),
            react_1.default.createElement(react_hook_form_1.Controller, { name: `${name}.component_name`, control: control, defaultValue: (_c = getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.result) === null || _c === void 0 ? void 0 : _c.name, render: ({ field }) => {
                    (0, react_1.useEffect)(() => {
                        var _a;
                        field.onChange((_a = getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.result) === null || _a === void 0 ? void 0 : _a.name);
                    }, []);
                    return null;
                } }),
            !narrow && react_1.default.createElement(dynamic_group_1.default, { field: getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.result, name: name }),
            narrow && react_1.default.createElement(back_panel_1.default, { isOpen: panelOpened, headerText: (_d = getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.result) === null || _d === void 0 ? void 0 : _d.name, isBlocking: false, isFooterAtBottom: true, isHiddenOnDismiss: true, onBack: () => setPanelOpened(false), onDismiss: () => setPanelOpened(false), type: react_2.PanelType.custom, customWidth: 400 },
                react_1.default.createElement(dynamic_group_1.default, { field: getSingleContentType === null || getSingleContentType === void 0 ? void 0 : getSingleContentType.result, name: name })))));
};
const DynamicZoneComponent = (0, hoc_1.composeWrappers)({
    contentTypesContext: content_types_context_1.ContentTypesContextProvider
})(DynamicZoneComponentImpl);
const DynamicZone = ({ field, name }) => {
    var _a;
    const [addComponentOpen, setAddComponentOpen] = (0, react_1.useState)(false);
    const { control, disabled, narrow } = (0, dynamic_form_1.useExtendedFormContext)();
    const { fields, append, remove, move } = (0, react_hook_form_1.useFieldArray)({
        control,
        name
    });
    const getItemStyle = (isDragging, draggableStyle) => {
        if (isDragging) {
            return Object.assign({ backgroundColor: theme.palette.neutralLighterAlt, boxShadow: theme.effects.elevation8, userSelect: 'none' }, draggableStyle);
        }
        return Object.assign({}, draggableStyle);
    };
    const onDragEnd = (result) => {
        var _a, _b;
        // dropped outside the list
        if (!result.destination) {
            return;
        }
        move((_a = result === null || result === void 0 ? void 0 : result.source) === null || _a === void 0 ? void 0 : _a.index, (_b = result === null || result === void 0 ? void 0 : result.destination) === null || _b === void 0 ? void 0 : _b.index);
    };
    return (react_1.default.createElement("div", null,
        ((_a = field === null || field === void 0 ? void 0 : field.label) === null || _a === void 0 ? void 0 : _a.length) > 0 && react_1.default.createElement(react_2.Label, null, field === null || field === void 0 ? void 0 : field.label),
        react_1.default.createElement(react_beautiful_dnd_1.DragDropContext, { onDragEnd: onDragEnd },
            react_1.default.createElement(react_beautiful_dnd_1.Droppable, { droppableId: name }, (provided) => (react_1.default.createElement("div", Object.assign({}, provided.droppableProps, { ref: provided.innerRef }),
                react_1.default.createElement(react_2.Stack, { tokens: { childrenGap: 10 } },
                    (fields || []).map((formField, index) => (react_1.default.createElement(react_beautiful_dnd_1.Draggable, { isDragDisabled: disabled, key: formField.id, draggableId: formField.id, index: index }, (provided, snapshot) => {
                        var _a;
                        return (react_1.default.createElement("div", Object.assign({ ref: provided.innerRef }, provided.draggableProps, provided.dragHandleProps, { style: getItemStyle(snapshot.isDragging, provided.draggableProps.style), className: (0, classnames_1.default)([styles.draggable, !narrow && styles.draggableMargin]) }),
                            react_1.default.createElement(DynamicZoneComponent, { onDelete: () => {
                                    remove(index);
                                }, onMove: (offset) => {
                                    move(index, index + offset);
                                }, disableDown: index >= (fields === null || fields === void 0 ? void 0 : fields.length) - 1, disableUp: index === 0, name: `${name}[${index}]`, component: (_a = formField) === null || _a === void 0 ? void 0 : _a.component, field: {
                                    fields: field === null || field === void 0 ? void 0 : field.fields
                                } })));
                    }))),
                    provided.placeholder))))),
        react_1.default.createElement(react_2.Separator, { style: { marginTop: 30 } },
            react_1.default.createElement(react_2.ActionButton, { disabled: disabled, iconProps: {
                    iconName: 'Add'
                }, onClick: () => {
                    setAddComponentOpen(true);
                } }, "Add component")),
        react_1.default.createElement(content_types_components_select_panel_1.default, { isOpen: addComponentOpen, filter: {
                name: field === null || field === void 0 ? void 0 : field.components
            }, onDismiss: () => setAddComponentOpen(false), onSubmit: (e) => {
                append({
                    component: e === null || e === void 0 ? void 0 : e[0].name
                });
                setAddComponentOpen(false);
            } })));
};
exports.default = DynamicZone;
