"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_ace_1 = __importDefault(require("react-ace"));
const uuid_1 = require("uuid");
const dynamic_richtext_context_1 = require("../../dynamic-richtext.context");
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const use_debounce_1 = require("use-debounce");
const useStyles = (0, react_1.makeStyles)((theme) => ({
    editorWrapper: {
        overflowX: 'auto',
        marginLeft: 0,
        marginRight: 0,
    },
    editor: {
        width: '100%',
        borderTop: `1px solid ${theme.palette.neutralLight}`,
        borderBottom: `1px solid ${theme.palette.neutralLight}`,
    },
}));
const DraftAceBlock = (props) => {
    const classes = useStyles();
    const contentState = props.contentState;
    const contentBlock = props.block;
    const entityKey = contentBlock.getEntityAt(0);
    const { mode, value } = contentState.getEntity(entityKey).getData();
    const { setEditorProps, editorProps, forceUpdate } = (0, dynamic_richtext_context_1.useRichtext)();
    const id = (0, react_2.useMemo)(() => (0, uuid_1.v4)(), []);
    const setReadOnly = (readOnly) => {
        setEditorProps(Object.assign(Object.assign({}, editorProps), { readOnly }));
    };
    const debounced = (0, use_debounce_1.useDebouncedCallback)((value) => {
        contentState.mergeEntityData(entityKey, { value });
        forceUpdate();
    }, 500);
    return (react_2.default.createElement("div", { className: classes.editorWrapper },
        react_2.default.createElement(react_1.Label, null, mode),
        react_2.default.createElement(react_ace_1.default, { className: classes.editor, name: id, readOnly: false, mode: mode, style: {
                marginLeft: 0,
                marginRight: 0,
                width: '100%',
            }, defaultValue: value, theme: "github", onChange: (e) => {
                debounced(e);
            }, onFocus: () => {
                setReadOnly(true);
            }, onBlur: () => {
                setReadOnly(false);
            }, height: "250px", editorProps: { $blockScrolling: true }, setOptions: {
                useWorker: false,
            } })));
};
exports.default = DraftAceBlock;
