"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const react_2 = require("@fluentui/react");
const rhf_components_1 = require("../../../components/rhf-components");
const InsertAceDialog = ({ isOpen, onDismiss, onInsert, }) => {
    const { control, handleSubmit, reset } = (0, react_hook_form_1.useForm)({
        mode: 'all',
        defaultValues: {
            mode: 'json',
        },
    });
    (0, react_1.useEffect)(() => {
        if (isOpen) {
            reset({
                mode: 'json',
            });
        }
    }, [isOpen]);
    return (react_1.default.createElement(react_2.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_2.DialogType.close,
            title: 'Insert Ace Editor',
        }, modalProps: {
            styles: { main: { maxWidth: 450 } },
        } },
        react_1.default.createElement(react_2.Stack, { tokens: {
                childrenGap: 8,
            } },
            react_1.default.createElement(rhf_components_1.ControlledCombobox, { control: control, name: "mode", label: "Mode", options: [
                    {
                        key: 'json',
                        text: 'Json',
                    },
                    {
                        key: 'xml',
                        text: 'Xml',
                    },
                    {
                        key: 'yaml',
                        text: 'Yaml',
                    },
                    {
                        key: 'javascript',
                        text: 'Javascript',
                    },
                    {
                        key: 'typescript',
                        text: 'Typescript',
                    },
                    {
                        key: 'markdown',
                        text: 'Markdown',
                    },
                    {
                        key: 'text',
                        text: 'Plain Text',
                    },
                    {
                        key: 'html',
                        text: 'Html',
                    },
                    {
                        key: 'css',
                        text: 'Css',
                    },
                    {
                        key: 'sql',
                        text: 'Sql',
                    },
                    {
                        key: 'sh',
                        text: 'Shell',
                    }
                ] })),
        react_1.default.createElement(react_2.DialogFooter, null,
            react_1.default.createElement(react_2.DefaultButton, { onClick: onDismiss, text: "Cancel" }),
            react_1.default.createElement(react_2.PrimaryButton, { onClick: () => {
                    handleSubmit((data) => {
                        onInsert(data);
                    })();
                }, text: "Insert" }))));
};
exports.default = InsertAceDialog;
