"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DialogContextProvider = exports.useDialog = void 0;
const react_async_hook_1 = require("react-async-hook");
const defer_promise_1 = __importDefault(require("defer-promise"));
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const DialogContext = (0, react_1.createContext)({});
const DialogContextProvider = ({ children }) => {
    const [deferred, setDeferred] = (0, react_1.useState)(undefined);
    const [title, setTitle] = (0, react_1.useState)('');
    const [message, setMessage] = (0, react_1.useState)('');
    const [open, setOpen] = (0, react_1.useState)(false);
    // eslint-disable-next-line @typescript-eslint/no-shadow
    const confirm = (0, react_async_hook_1.useAsyncCallback)((title, message) => __awaiter(void 0, void 0, void 0, function* () {
        try {
            const deferrer = (0, defer_promise_1.default)();
            setDeferred(deferrer);
            setTitle(title);
            setMessage(message);
            setOpen(true);
            yield deferrer.promise;
        }
        finally {
            setOpen(false);
        }
    }));
    return (react_1.default.createElement(DialogContext.Provider, { value: {
            confirm: confirm.execute,
        } },
        react_1.default.createElement(react_2.Dialog, { hidden: !open, title: title, type: react_2.DialogType.close, onDismiss: () => deferred === null || deferred === void 0 ? void 0 : deferred.reject('cancelled'), styles: {
                main: {
                    minHeight: 0,
                },
            } },
            message,
            react_1.default.createElement(react_2.DialogFooter, null,
                react_1.default.createElement(react_2.PrimaryButton, { "data-cy": "dialog-confirm", onClick: () => deferred === null || deferred === void 0 ? void 0 : deferred.resolve() }, "Confirm"),
                react_1.default.createElement(react_2.DefaultButton, { "data-cy": "dialog-cancel", onClick: () => deferred === null || deferred === void 0 ? void 0 : deferred.reject('cancelled') }, "Cancel"))),
        children));
};
exports.DialogContextProvider = DialogContextProvider;
const useDialog = () => (0, react_1.useContext)(DialogContext);
exports.useDialog = useDialog;
