"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSettings = exports.SettingsContextProvider = void 0;
const react_1 = __importStar(require("react"));
const api_1 = __importStar(require("../helpers/api"));
const hooks_1 = require("../helpers/hooks");
const SettingsContext = (0, react_1.createContext)({});
const SettingsContextProvider = ({ children }) => {
    const [open, setOpen] = (0, react_1.useState)(false);
    const settingsState = (0, hooks_1.useModelState)([]);
    const getContentTypes = (0, api_1.useApiCallback)((params) => __awaiter(void 0, void 0, void 0, function* () {
        return api_1.default.get('/content-types', {
            params,
        });
    }));
    const getSettings = (0, api_1.useApiCallback)(() => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.get('/settings');
        settingsState.update((response === null || response === void 0 ? void 0 : response.data) || []);
        return response;
    }));
    const updateSettings = (0, api_1.useApiCallback)((key, value) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.post('/settings', {
            key,
            value
        });
        settingsState.update([response.data]);
        return response;
    }));
    return (react_1.default.createElement(SettingsContext.Provider, { value: {
            open,
            setOpen,
            getContentTypes,
            getSettings,
            updateSettings,
            settingsState,
            settingsArray: settingsState === null || settingsState === void 0 ? void 0 : settingsState.arrayState
        } }, children));
};
exports.SettingsContextProvider = SettingsContextProvider;
const useSettings = () => (0, react_1.useContext)(SettingsContext);
exports.useSettings = useSettings;
