"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SnackbarContextProvider = exports.useSnackbar = void 0;
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const lodash_1 = require("lodash");
const styles = (0, react_2.mergeStyleSets)({
    root: {
        position: 'fixed',
        top: 0,
        left: 0,
        right: 0,
        width: 300,
        maxWidth: '90%',
        margin: '8px auto',
        zIndex: 1100,
        display: 'flex',
        flexDirection: 'column',
        alignItems: 'center',
        justifyContent: 'center',
    },
    message: {
        width: '100%',
        '&:not(:last-child)': {
            marginBottom: 10,
        },
    },
});
const Message = ({ onDismiss, message, id, messageBarType, duration }) => {
    (0, react_1.useEffect)(() => {
        const timer = setTimeout(() => {
            onDismiss(id);
        }, duration || 3000);
        return () => clearTimeout(timer);
    }, []);
    return (react_1.default.createElement(react_2.MessageBar, { messageBarType: messageBarType, onDismiss: () => onDismiss(id), dismissButtonAriaLabel: "Close" }, message));
};
const SnackbarContext = (0, react_1.createContext)({});
const SnackbarContextProvider = ({ children }) => {
    const [messages, setMessages] = (0, react_1.useState)([]);
    const closeSnackbar = (id) => {
        setMessages((messages) => messages.filter((message) => (message === null || message === void 0 ? void 0 : message.id) !== id));
    };
    const openSnackbar = ({ message, messageBarType, duration = 6000 }) => {
        const id = (0, lodash_1.uniqueId)();
        const messageBar = Object.assign({
            messageBarType: react_2.MessageBarType.info,
        }, {
            id,
            messageBarType,
            message,
            duration,
        });
        setMessages([...messages, messageBar]);
        return id;
    };
    return (react_1.default.createElement(SnackbarContext.Provider, { value: {
            openSnackbar,
            closeSnackbar,
        } },
        (messages === null || messages === void 0 ? void 0 : messages.length) > 0 && (react_1.default.createElement("div", { className: styles.root }, messages.map((message) => (react_1.default.createElement("div", { key: message.id, className: styles.message },
            react_1.default.createElement(Message, Object.assign({ onDismiss: (id) => closeSnackbar(id) }, message))))))),
        children));
};
exports.SnackbarContextProvider = SnackbarContextProvider;
const useSnackbar = () => (0, react_1.useContext)(SnackbarContext);
exports.useSnackbar = useSnackbar;
