"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const api_security_context_1 = require("../context/api-security.context");
const access_tokens_delete_dialog_1 = __importDefault(require("./access-tokens-delete-dialog"));
const access_tokens_generate_dialog_1 = __importDefault(require("./access-tokens-generate-dialog"));
const AccessTokensCommandBar = () => {
    const { selectedAccessTokens } = (0, api_security_context_1.useApiSecurity)();
    const [openGenerate, setOpenGenerate] = (0, react_2.useState)(false);
    const [openDelete, setOpenDelete] = (0, react_2.useState)(false);
    const toolbarItems = (0, react_2.useMemo)(() => [
        {
            key: 'generate',
            text: 'Generate',
            iconProps: {
                iconName: 'Add',
            },
            onClick: () => {
                setOpenGenerate(true);
            },
        },
        {
            key: 'delete',
            text: 'Delete',
            iconProps: {
                iconName: 'Delete',
            },
            disabled: !((selectedAccessTokens === null || selectedAccessTokens === void 0 ? void 0 : selectedAccessTokens.length) > 0),
            onClick: () => {
                setOpenDelete(true);
            },
        },
    ], [selectedAccessTokens]);
    return (react_2.default.createElement("div", null,
        react_2.default.createElement(react_1.CommandBar, { items: toolbarItems, style: { borderBottom: `1px solid ${react_1.NeutralColors.gray30}` } }),
        react_2.default.createElement(access_tokens_delete_dialog_1.default, { isOpen: openDelete, onDismiss: () => setOpenDelete(false), onDeleted: () => setOpenDelete(false) }),
        react_2.default.createElement(access_tokens_generate_dialog_1.default, { isOpen: openGenerate, onDismiss: () => setOpenGenerate(false), onGenerate: () => {
                setOpenGenerate(false);
            } })));
};
exports.default = AccessTokensCommandBar;
