"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const api_security_context_1 = require("../context/api-security.context");
const react_hook_form_1 = require("react-hook-form");
const rhf_components_1 = require("../../../components/rhf-components");
const AccessTokensGenerateDialog = ({ isOpen, onDismiss, onGenerate }) => {
    var _a;
    const { generateAccessToken } = (0, api_security_context_1.useApiSecurity)();
    const { control, handleSubmit, reset } = (0, react_hook_form_1.useForm)({
        mode: 'all',
        defaultValues: {
            name: '',
        },
    });
    (0, react_2.useEffect)(() => {
        if (generateAccessToken === null || generateAccessToken === void 0 ? void 0 : generateAccessToken.result) {
            onGenerate(generateAccessToken === null || generateAccessToken === void 0 ? void 0 : generateAccessToken.result);
            reset({
                name: '',
            });
        }
    }, [generateAccessToken === null || generateAccessToken === void 0 ? void 0 : generateAccessToken.result]);
    return (react_2.default.createElement(react_1.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_1.DialogType.close,
            title: 'Generate access token',
        }, modalProps: {
            styles: { main: { maxWidth: 450 } },
        } },
        react_2.default.createElement(react_1.Stack, { tokens: { childrenGap: 8 } },
            ((_a = generateAccessToken.error) === null || _a === void 0 ? void 0 : _a.message) && (react_2.default.createElement(react_1.MessageBar, { messageBarType: react_1.MessageBarType.error }, generateAccessToken.error.message)),
            react_2.default.createElement(rhf_components_1.ControlledTextField, { control: control, name: "name", label: "Name" })),
        react_2.default.createElement(react_1.DialogFooter, null,
            react_2.default.createElement(react_1.DefaultButton, { onClick: onDismiss, text: "Cancel", "data-cy": "dialog-cancel" }),
            react_2.default.createElement(react_1.PrimaryButton, { onClick: () => {
                    handleSubmit((val) => {
                        generateAccessToken.execute(val === null || val === void 0 ? void 0 : val.name);
                    })();
                }, text: "Generate", disabled: generateAccessToken === null || generateAccessToken === void 0 ? void 0 : generateAccessToken.loading, "data-cy": "dialog-confirm" }))));
};
exports.default = AccessTokensGenerateDialog;
