"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const api_security_context_1 = require("../context/api-security.context");
const copy_text_to_clipboard_1 = __importDefault(require("copy-text-to-clipboard"));
const useStyles = (0, react_1.makeStyles)({
    accessTokensList: {
        ':global(.ms-DetailsRow-fields)': {
            alignItems: 'center !important',
        },
        ':global(.ms-DetailsRow-check)': {
            height: '100% !important',
        },
    },
});
const AccessTokensList = () => {
    const { selection, listAccessTokens, accessTokens } = (0, api_security_context_1.useApiSecurity)();
    const styles = useStyles();
    (0, react_2.useEffect)(() => {
        listAccessTokens.execute();
    }, []);
    const columns = [
        {
            key: 'name',
            name: 'Name',
            fieldName: 'name',
            minWidth: 120,
        },
        {
            key: 'token',
            name: 'Token',
            minWidth: 300,
            onRender: (item) => {
                return (react_2.default.createElement(react_1.TextField, { readOnly: true, id: `${item === null || item === void 0 ? void 0 : item.token}`, value: item === null || item === void 0 ? void 0 : item.token, type: "text", styles: {
                        suffix: {
                            padding: 0,
                        },
                        fieldGroup: {
                            borderRight: 'none',
                        },
                    }, onRenderSuffix: () => (react_2.default.createElement(react_1.Stack, { horizontal: true },
                        react_2.default.createElement(react_1.DefaultButton, { iconProps: { iconName: 'Copy' }, style: { minWidth: 0, padding: '0 4px' }, onClick: () => {
                                (0, copy_text_to_clipboard_1.default)(item === null || item === void 0 ? void 0 : item.token);
                            } }))) }));
            },
        },
        {
            key: 'createdAt',
            name: 'Created At',
            fieldName: 'createdAt',
            minWidth: 120,
        },
    ];
    return (react_2.default.createElement("div", { className: styles.accessTokensList },
        react_2.default.createElement(react_1.MarqueeSelection, { selection: selection, isDraggingConstrainedToRoot: true },
            react_2.default.createElement(react_1.ShimmeredDetailsList, { enableShimmer: listAccessTokens === null || listAccessTokens === void 0 ? void 0 : listAccessTokens.loading, selection: selection, selectionMode: selection.mode, setKey: "multiple", selectionPreservedOnEmptyClick: true, items: accessTokens !== null && accessTokens !== void 0 ? accessTokens : [], columns: columns }))));
};
exports.default = AccessTokensList;
