"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const rhf_components_1 = require("../../../components/rhf-components");
const react_hook_form_1 = require("react-hook-form");
const utility_1 = require("../../../helpers/utility");
const settings_1 = require("../../../context/settings");
const lodash_1 = __importDefault(require("lodash"));
const ApiAccessSettings = () => {
    const { updateSettings, settingsArray } = (0, settings_1.useSettings)();
    const defaultValues = (0, react_2.useMemo)(() => {
        const apiAccess = (0, utility_1.findSettingsValue)(settingsArray, 'apiAccess');
        return {
            apiAccess: apiAccess || 'public',
        };
    }, [JSON.stringify(settingsArray)]);
    const { control, watch, handleSubmit } = (0, react_hook_form_1.useForm)({
        defaultValues,
    });
    const [values, setValues] = (0, react_2.useState)(defaultValues);
    (0, react_2.useEffect)(() => {
        watch((val) => {
            setValues(val);
        });
    }, []);
    return (react_2.default.createElement(react_1.Stack, { tokens: { childrenGap: 8, maxWidth: 600 } },
        react_2.default.createElement(rhf_components_1.ControlledDropdown, { control: control, name: "apiAccess", options: [
                {
                    key: 'public',
                    text: 'Public - Requires access token for drafts and search',
                },
                {
                    key: 'private',
                    text: 'Private - Requires access token for all post content requests',
                },
            ] }),
        react_2.default.createElement(react_1.Stack, { horizontal: true, horizontalAlign: 'end' },
            react_2.default.createElement(react_1.PrimaryButton, { disabled: lodash_1.default.isEqual(values, defaultValues), onClick: () => {
                    handleSubmit((val) => {
                        updateSettings.execute('apiAccess', val === null || val === void 0 ? void 0 : val.apiAccess);
                    })();
                } }, "Update"))));
};
exports.default = ApiAccessSettings;
