import React from 'react';
import { UseAsyncReturn } from 'react-async-hook';
import { IAccessToken } from '@shared/interfaces/model';
import ExtendedSelection from '@admin/helpers/selection';
import { ModelState } from '@admin/helpers/hooks';
export interface IApiSecurityContext {
    selection: ExtendedSelection<IAccessToken>;
    accessTokensState: ModelState<IAccessToken>;
    accessTokens: IAccessToken[];
    selectedAccessTokens: IAccessToken[];
    listAccessTokens: UseAsyncReturn<IAccessToken[], []>;
    generateAccessToken: UseAsyncReturn<IAccessToken, [name: string]>;
    deleteAccessTokens: UseAsyncReturn<number[], [ids: number[]]>;
}
export interface IApiSecurityContextProviderProps {
}
declare const ApiSecurityContextProvider: React.FC<IApiSecurityContextProviderProps>;
declare const useApiSecurity: () => IApiSecurityContext;
export { ApiSecurityContextProvider, useApiSecurity };
