"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useApiSecurity = exports.ApiSecurityContextProvider = void 0;
const react_1 = __importStar(require("react"));
const api_1 = __importStar(require("../../../helpers/api"));
const selection_1 = require("../../../helpers/selection");
const hooks_1 = require("../../../helpers/hooks");
const ApiSecurityContext = (0, react_1.createContext)({});
const ApiSecurityContextProvider = ({ children }) => {
    const [selectedAccessTokens, setSelectedAccessTokens] = (0, react_1.useState)([]);
    const selection = (0, selection_1.useSelection)({
        onSelectionChanged: () => {
            setSelectedAccessTokens(selection.getSelection());
        },
        getKey: (backup) => backup.id,
    });
    const accessTokensState = (0, hooks_1.useModelState)([], (a, b) => {
        return b.id - a.id;
    });
    (0, react_1.useEffect)(() => {
        // Refresh selection
        selection.setItems(accessTokensState.arrayState, false);
        setSelectedAccessTokens(selection.getSelection());
    }, [accessTokensState.arrayState]);
    const listAccessTokens = (0, api_1.useApiCallback)(() => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.get('/access-tokens');
        accessTokensState.setArrayState(response.data);
        return response;
    }));
    const generateAccessToken = (0, api_1.useApiCallback)((name) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.post(`/access-tokens`, {
            name,
        });
        accessTokensState.create([response === null || response === void 0 ? void 0 : response.data]);
        return response;
    }));
    const deleteAccessTokens = (0, api_1.useApiCallback)((ids) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.delete(`/access-tokens`, {
            data: ids
        });
        accessTokensState.delete(ids);
        return response;
    }));
    return (react_1.default.createElement(ApiSecurityContext.Provider, { value: {
            listAccessTokens,
            deleteAccessTokens,
            generateAccessToken,
            selection,
            accessTokensState,
            accessTokens: accessTokensState.arrayState,
            selectedAccessTokens,
        } }, children));
};
exports.ApiSecurityContextProvider = ApiSecurityContextProvider;
const useApiSecurity = () => (0, react_1.useContext)(ApiSecurityContext);
exports.useApiSecurity = useApiSecurity;
