"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const assets_context_1 = require("../context/assets.context");
const react_2 = __importStar(require("react"));
const classnames_1 = __importDefault(require("classnames"));
const useStyles = (0, react_1.makeStyles)({
    progress: {
        '& .ms-ProgressIndicator-itemProgress': {
            padding: 0
        }
    },
    inactive: {
        '& .ms-ProgressIndicator-itemProgress': {
            visibility: 'hidden'
        }
    }
});
const AssetProgressIndicator = () => {
    const { uploads } = (0, assets_context_1.useAssets)();
    const classes = useStyles();
    const progressPercent = (0, react_2.useMemo)(() => {
        const progressInstances = Object.values(uploads).map((upload) => { var _a; return (_a = upload === null || upload === void 0 ? void 0 : upload.progress) !== null && _a !== void 0 ? _a : 100; });
        const totalProgress = progressInstances.reduce((acc, value) => value + acc, 0) / progressInstances.length;
        return totalProgress / 100;
    }, [uploads]);
    const isActive = (0, react_2.useMemo)(() => Object.keys(uploads !== null && uploads !== void 0 ? uploads : {}).length > 0, [uploads]);
    return (react_2.default.createElement(react_1.ProgressIndicator, { className: (0, classnames_1.default)(classes.progress, { [classes.inactive]: !isActive }), percentComplete: progressPercent }));
};
exports.default = AssetProgressIndicator;
