"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const utility_1 = require("../../../helpers/utility");
const auth_context_1 = require("../../authentication/context/auth.context");
const use_debounce_1 = require("use-debounce");
const assets_context_1 = require("../context/assets.context");
const snackbar_1 = require("../../../context/snackbar");
const asset_progress_indicator_1 = __importDefault(require("./asset-progress-indicator"));
const AssetsCommandBar = (_a) => {
    var { visibleColumns = [
        'new',
        'upload',
        'details',
        'rename',
        'download',
        'delete',
        'copy',
        'refresh',
        'view',
    ] } = _a, props = __rest(_a, ["visibleColumns"]);
    const { openFileDialog, openFolderDialog, view, params, setParams, getAssets, setView, selectedAssets, setStateData, stateData, } = (0, assets_context_1.useAssets)();
    const { openSnackbar } = (0, snackbar_1.useSnackbar)();
    const debounced = (0, use_debounce_1.useDebouncedCallback)((val) => __awaiter(void 0, void 0, void 0, function* () {
        setParams(Object.assign(Object.assign({}, (params || {})), { search: val, parentId: null }));
        getAssets.execute(Object.assign(Object.assign({}, (params || {})), { search: val, parentId: null }));
    }), 500);
    const { filterPermissions } = (0, auth_context_1.useAuth)();
    const commandItems = (0, react_2.useMemo)(() => {
        var _a;
        return filterPermissions([
            {
                key: 'new',
                text: 'New',
                'data-cy': 'assets-commandBar-new',
                iconProps: { iconName: 'Add' },
                permissions: ['assets_create'],
                subMenuProps: {
                    items: [
                        {
                            key: 'folder',
                            text: 'Folder',
                            'data-cy': 'assets-commandBar-new-folder',
                            onClick: () => setStateData('newFolderOpen', true),
                        },
                    ],
                },
            },
            {
                key: 'upload',
                text: 'Upload',
                'data-cy': 'assets-commandBar-upload',
                iconProps: { iconName: 'Upload' },
                permissions: ['assets_create'],
                subMenuProps: {
                    items: [
                        {
                            key: 'folder',
                            text: 'Folder',
                            onClick: openFolderDialog,
                        },
                        {
                            key: 'file',
                            text: 'Files',
                            onClick: openFileDialog,
                        },
                    ],
                },
            },
            {
                key: 'details',
                text: 'Details',
                'data-cy': 'assets-commandBar-details',
                disabled: (selectedAssets === null || selectedAssets === void 0 ? void 0 : selectedAssets.length) !== 1 &&
                    ((_a = selectedAssets[0]) === null || _a === void 0 ? void 0 : _a.mimeType) !== assets_context_1.FOLDER_MIME_TYPE,
                iconProps: { iconName: 'Info' },
                onClick: () => setStateData('assetDetailsOpen', true),
            },
            {
                key: 'rename',
                text: 'Rename',
                'data-cy': 'assets-commandBar-rename',
                permissions: ['assets_update'],
                disabled: (selectedAssets === null || selectedAssets === void 0 ? void 0 : selectedAssets.length) !== 1,
                iconProps: { iconName: 'Edit' },
                onClick: () => setStateData('renameAssetOpen', true),
            },
            {
                key: 'download',
                text: 'Download',
                'data-cy': 'assets-commandBar-download',
                disabled: (selectedAssets === null || selectedAssets === void 0 ? void 0 : selectedAssets.length) !== 1 ||
                    (selectedAssets[0] &&
                        selectedAssets[0].mimeType === assets_context_1.FOLDER_MIME_TYPE),
                iconProps: { iconName: 'Download' },
                onClick: () => window
                    .open(`/api/assets/${selectedAssets[0].id}?attachment=true`, '_blank')
                    .focus(),
            },
            {
                key: 'delete',
                text: 'Delete',
                'data-cy': 'assets-commandBar-delete',
                disabled: (selectedAssets === null || selectedAssets === void 0 ? void 0 : selectedAssets.length) === 0,
                iconProps: { iconName: 'Delete' },
                permissions: ['assets_delete'],
                onClick: () => setStateData('deleteAssetsOpen', true),
            },
            {
                key: 'copy',
                text: 'Copy URL',
                'data-cy': 'assets-commandBar-copy',
                disabled: (selectedAssets === null || selectedAssets === void 0 ? void 0 : selectedAssets.length) !== 1 ||
                    (selectedAssets[0] &&
                        selectedAssets[0].mimeType === assets_context_1.FOLDER_MIME_TYPE),
                iconProps: { iconName: 'Copy' },
                onClick: () => {
                    var _a;
                    (0, utility_1.copyToClipboard)(`${window.location.origin}/api/uploads/${(_a = selectedAssets[0]) === null || _a === void 0 ? void 0 : _a.npath}`);
                    openSnackbar({
                        message: 'Successfully copied URL to clipboard!',
                        messageBarType: react_1.MessageBarType.success,
                        duration: 1000,
                    });
                },
            },
            {
                key: 'refresh',
                text: 'Refresh',
                'data-cy': 'assets-commandBar-refresh',
                iconProps: { iconName: 'Refresh' },
                onClick: () => {
                    getAssets.execute(params);
                },
            },
        ]).filter(({ key }) => visibleColumns.includes(key));
    }, [selectedAssets, getAssets, params, stateData, visibleColumns]);
    const commandFarItems = (0, react_2.useMemo)(() => [
        {
            key: 'view',
            iconOnly: true,
            'data-cy': 'assets-commandBar-view',
            iconProps: { iconName: view === 'tiles' ? 'Tiles' : 'List' },
            subMenuProps: {
                items: [
                    {
                        key: 'tiles',
                        text: 'Tiles',
                        'data-cy': 'assets-commandBar-view-tiles',
                        iconProps: { iconName: 'Tiles' },
                        onClick: () => setView('tiles'),
                    },
                    {
                        key: 'list',
                        text: 'List',
                        'data-cy': 'assets-commandBar-view-list',
                        iconProps: { iconName: 'List' },
                        onClick: () => setView('list'),
                    },
                ],
            },
        },
        {
            key: 'search',
            'data-cy': 'assets-commandBar-search',
            onRenderIcon: () => (react_2.default.createElement(react_1.SearchBox, { placeholder: "Search assets...", onChange: (event, newValue) => {
                    debounced(newValue);
                } })),
        },
    ].filter(({ key }) => visibleColumns.includes(key)), [view, visibleColumns, debounced]);
    return (react_2.default.createElement(react_2.default.Fragment, null,
        react_2.default.createElement(react_1.CommandBar, Object.assign({ items: commandItems, farItems: commandFarItems, style: { borderBottom: `1px solid ${react_1.NeutralColors.gray30}` }, "data-cy": "assets-commandBar" }, props)),
        react_2.default.createElement(asset_progress_indicator_1.default, null)));
};
exports.default = AssetsCommandBar;
