"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const rhf_components_1 = require("../../../components/rhf-components");
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const assets_context_1 = require("../context/assets.context");
const AssetsCreateFolderDialog = () => {
    const { stateData, setStateData, createFolder, params } = (0, assets_context_1.useAssets)();
    const { control, reset, handleSubmit } = (0, react_hook_form_1.useForm)({
        defaultValues: {
            name: '',
        },
    });
    (0, react_2.useEffect)(() => {
        if (stateData === null || stateData === void 0 ? void 0 : stateData.newFolderOpen) {
            reset();
            createFolder.reset();
        }
    }, [stateData === null || stateData === void 0 ? void 0 : stateData.newFolderOpen]);
    (0, react_2.useEffect)(() => {
        if (createFolder === null || createFolder === void 0 ? void 0 : createFolder.result) {
            setStateData('newFolderOpen', false);
        }
    }, [createFolder === null || createFolder === void 0 ? void 0 : createFolder.result]);
    const submit = handleSubmit((data) => {
        createFolder.execute(Object.assign(Object.assign({}, (data || {})), { parentId: params === null || params === void 0 ? void 0 : params.parentId }));
    });
    return (react_2.default.createElement(react_1.Dialog, { hidden: !(stateData === null || stateData === void 0 ? void 0 : stateData.newFolderOpen), onDismiss: () => setStateData('newFolderOpen', false), dialogContentProps: {
            type: react_1.DialogType.normal,
            title: 'New Folder',
        }, modalProps: {
            styles: { main: { maxWidth: 450 } },
        } },
        (createFolder === null || createFolder === void 0 ? void 0 : createFolder.error) && (react_2.default.createElement(react_1.MessageBar, { messageBarType: react_1.MessageBarType.error, isMultiline: false, onDismiss: () => createFolder.reset(), dismissButtonAriaLabel: "Close" }, "Name already exist")),
        react_2.default.createElement("form", { onSubmit: submit },
            react_2.default.createElement(react_1.Stack, { tokens: { childrenGap: 10 } },
                react_2.default.createElement(rhf_components_1.ControlledTextField, { name: "name", control: control, "data-cy": "assets-createFolder-name", rules: {
                        required: 'Name is required',
                    }, autoComplete: "off" })),
            react_2.default.createElement(react_1.DialogFooter, null,
                react_2.default.createElement(react_1.DefaultButton, { onClick: () => setStateData('newFolderOpen', false), text: "Cancel" }),
                react_2.default.createElement(react_1.PrimaryButton, { "data-cy": "assets-createFolder-submit", type: "submit", text: "Create", disabled: createFolder === null || createFolder === void 0 ? void 0 : createFolder.loading })))));
};
exports.default = AssetsCreateFolderDialog;
