"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const assets_context_1 = require("../context/assets.context");
const AssetsDeleteDialog = () => {
    const { del, selectedAssets, stateData, setStateData } = (0, assets_context_1.useAssets)();
    (0, react_2.useEffect)(() => {
        del.reset();
    }, [stateData === null || stateData === void 0 ? void 0 : stateData.deleteAssetsOpen]);
    (0, react_2.useEffect)(() => {
        if (del === null || del === void 0 ? void 0 : del.result) {
            setStateData('deleteAssetsOpen', false);
        }
    }, [del === null || del === void 0 ? void 0 : del.result]);
    return (react_2.default.createElement(react_1.Dialog, { hidden: !(stateData === null || stateData === void 0 ? void 0 : stateData.deleteAssetsOpen), onDismiss: () => setStateData('deleteAssetsOpen', false), dialogContentProps: {
            type: react_1.DialogType.close,
            title: 'Delete?',
        }, modalProps: {
            styles: { main: { maxWidth: 450 } },
        } },
        "Are you sure you would like to send this item(s) to the recycle bin?",
        react_2.default.createElement(react_1.DialogFooter, null,
            react_2.default.createElement(react_1.DefaultButton, { onClick: () => setStateData('deleteAssetsOpen', false), text: "Cancel" }),
            react_2.default.createElement(react_1.PrimaryButton, { onClick: () => {
                    del.execute(selectedAssets.map((asset) => asset.id));
                }, text: "Delete", "data-cy": "assets-deleteConfirm", disabled: del === null || del === void 0 ? void 0 : del.loading }))));
};
exports.default = AssetsDeleteDialog;
