"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_dropzone_1 = require("react-dropzone");
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const assets_context_1 = require("../context/assets.context");
const FOLDER_MIME_TYPE = 'application/vnd.burdy.folder';
const useStyles = (0, react_2.makeStyles)((theme) => {
    const primary = (0, react_2.cssColor)(theme.palette.themePrimary);
    return {
        zone: {
            position: 'absolute',
            zIndex: 999,
            top: 0,
            left: 0,
            right: 0,
            bottom: 0,
            display: 'flex',
            justifyContent: 'center',
            alignItems: 'center',
            borderRadius: 0,
            background: `rgba(${primary.r}, ${primary.g}, ${primary.b}, 0.04)`,
            border: `2px dashed ${theme.palette.themePrimary}`,
            color: theme.palette.white,
            pointerEvents: 'none',
        },
    };
});
const AssetsDropzone = (_a) => {
    var { asset, children } = _a, props = __rest(_a, ["asset", "children"]);
    const styles = useStyles();
    const { upload, params, getAssets } = (0, assets_context_1.useAssets)();
    const [drag, setDrag] = (0, react_1.useState)(false);
    const onDrop = (0, react_1.useCallback)((acceptedFiles) => __awaiter(void 0, void 0, void 0, function* () {
        setDrag(false);
        const files = acceptedFiles.map((file) => {
            var _a;
            return ({
                file,
                data: {
                    mimeType: file.type,
                    parentId: (_a = asset === null || asset === void 0 ? void 0 : asset.id) !== null && _a !== void 0 ? _a : params === null || params === void 0 ? void 0 : params.parentId,
                },
            });
        });
        yield upload.execute(files);
    }), [params, getAssets, asset]);
    const onDragEnter = (0, react_1.useCallback)(() => {
        setDrag(true);
    }, []);
    const onDragLeave = (0, react_1.useCallback)(() => {
        setDrag(false);
    }, []);
    const isDropzone = (asset === null || asset === void 0 ? void 0 : asset.mimeType) === FOLDER_MIME_TYPE || asset === undefined;
    const dropzone = (0, react_dropzone_1.useDropzone)({
        noDragEventsBubbling: true,
        onDragEnter,
        onDragLeave,
        onDrop,
    });
    if (!isDropzone) {
        return react_1.default.createElement(react_1.default.Fragment, null, children);
    }
    return (react_1.default.createElement("div", Object.assign({}, dropzone.getRootProps(), { style: { height: '100%', position: 'relative' }, "data-name": "dropzone" }, props),
        drag && react_1.default.createElement("div", { className: styles.zone }),
        children));
};
exports.default = AssetsDropzone;
