"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const rhf_components_1 = require("../../../components/rhf-components");
const assets_context_1 = require("../context/assets.context");
const AssetsRenameDialog = () => {
    const { rename, selectedAssets, stateData, setStateData } = (0, assets_context_1.useAssets)();
    const selectedAsset = (0, react_2.useMemo)(() => {
        return selectedAssets[0];
    }, [selectedAssets]);
    const { control, handleSubmit, reset } = (0, react_hook_form_1.useForm)({});
    (0, react_2.useEffect)(() => {
        if (stateData === null || stateData === void 0 ? void 0 : stateData.renameAssetOpen) {
            reset({
                name: selectedAsset === null || selectedAsset === void 0 ? void 0 : selectedAsset.name,
            });
            rename.reset();
        }
    }, [stateData === null || stateData === void 0 ? void 0 : stateData.renameAssetOpen]);
    (0, react_2.useEffect)(() => {
        if (rename === null || rename === void 0 ? void 0 : rename.result) {
            setStateData('renameAssetOpen', false);
        }
    }, [rename === null || rename === void 0 ? void 0 : rename.result]);
    const submit = handleSubmit((data) => {
        rename.execute(selectedAsset === null || selectedAsset === void 0 ? void 0 : selectedAsset.id, data === null || data === void 0 ? void 0 : data.name);
    });
    return (react_2.default.createElement(react_1.Dialog, { hidden: !(stateData === null || stateData === void 0 ? void 0 : stateData.renameAssetOpen), onDismiss: () => setStateData('renameAssetOpen', false), dialogContentProps: {
            type: react_1.DialogType.close,
            title: 'Rename?',
        }, modalProps: {
            styles: { main: { maxWidth: 450 } },
        } },
        react_2.default.createElement("form", { onSubmit: submit },
            (rename === null || rename === void 0 ? void 0 : rename.error) && (react_2.default.createElement(react_1.MessageBar, { messageBarType: react_1.MessageBarType.error, isMultiline: false, onDismiss: () => rename.reset(), dismissButtonAriaLabel: "Close" }, "Name already exist")),
            react_2.default.createElement(react_1.Stack, { tokens: { childrenGap: 10 } },
                react_2.default.createElement(rhf_components_1.ControlledTextField, { name: "name", "data-cy": "assets-rename-name", control: control, autoFocus: true, autoComplete: "off", rules: {
                        required: 'Name is required',
                    } })),
            react_2.default.createElement(react_1.DialogFooter, null,
                react_2.default.createElement(react_1.DefaultButton, { onClick: () => setStateData('renameAssetOpen', false), text: "Cancel" }),
                react_2.default.createElement(react_1.PrimaryButton, { type: "submit", "data-cy": "assets-rename-submit", text: "Rename", disabled: rename === null || rename === void 0 ? void 0 : rename.loading })))));
};
exports.default = AssetsRenameDialog;
