"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IMAGE_MIME_TYPES = exports.FOLDER_MIME_TYPE = exports.AssetsContextProvider = exports.useAssets = void 0;
const react_async_hook_1 = require("react-async-hook");
const react_1 = __importStar(require("react"));
const axios_1 = __importDefault(require("axios"));
const uuid_1 = require("uuid");
const hooks_1 = require("../../../helpers/hooks");
const selection_1 = require("../../../helpers/selection");
const FOLDER_MIME_TYPE = 'application/vnd.burdy.folder';
exports.FOLDER_MIME_TYPE = FOLDER_MIME_TYPE;
const IMAGE_MIME_TYPES = ['image/jpeg', 'image/png', 'image/webp', 'image/gif'];
exports.IMAGE_MIME_TYPES = IMAGE_MIME_TYPES;
const AssetsContext = (0, react_1.createContext)({});
const AssetsContextProvider = ({ children }) => {
    const [selectedAssets, setSelectedAssets] = (0, react_1.useState)([]);
    const [uploads, setUploads] = (0, react_1.useState)({});
    const [params, setParams] = (0, react_1.useState)({});
    const [view, setView] = (0, hooks_1.useStorageState)('assetDefaultView', 'tiles');
    const assetSrc = (asset) => { var _a; return `/api/assets/single?npath=${(_a = asset === null || asset === void 0 ? void 0 : asset.thumbnail) !== null && _a !== void 0 ? _a : asset.npath}`; };
    const assetsState = (0, hooks_1.useModelState)([], (a, b) => {
        if ((a === null || a === void 0 ? void 0 : a.mimeType) === FOLDER_MIME_TYPE && (b === null || b === void 0 ? void 0 : b.mimeType) !== FOLDER_MIME_TYPE) {
            return -1;
        }
        if ((a === null || a === void 0 ? void 0 : a.mimeType) !== FOLDER_MIME_TYPE && (b === null || b === void 0 ? void 0 : b.mimeType) === FOLDER_MIME_TYPE) {
            return 1;
        }
        if (!(a === null || a === void 0 ? void 0 : a.name) || !(b === null || b === void 0 ? void 0 : b.name))
            return 0;
        return a.name.localeCompare(b.name);
    });
    const folderInput = (0, react_1.useRef)();
    const fileInput = (0, react_1.useRef)();
    const selection = (0, selection_1.useSelection)({
        onSelectionChanged: () => {
            setSelectedAssets(selection.getSelection());
        },
        getKey: (asset) => asset.id,
    });
    const [stateData, setStateDataImpl] = (0, react_1.useState)({});
    const setStateData = (key, value) => {
        setStateDataImpl(Object.assign(Object.assign({}, (stateData || {})), { [key]: value }));
    };
    const getAssets = (0, react_async_hook_1.useAsyncCallback)((data) => __awaiter(void 0, void 0, void 0, function* () {
        try {
            assetsState.setArrayState([]);
            const request = yield axios_1.default.get('/api/assets', {
                params: data,
            });
            assetsState.setArrayState(request.data);
            return request.data;
        }
        catch (e) {
            throw e.response.message;
        }
    }));
    const getAncestors = (0, react_async_hook_1.useAsyncCallback)((data) => __awaiter(void 0, void 0, void 0, function* () {
        try {
            const request = yield axios_1.default.get('/api/assets/ancestors', {
                params: data,
            });
            return request.data;
        }
        catch (e) {
            throw e.response.message;
        }
    }));
    const upload = (0, react_async_hook_1.useAsyncCallback)((filesWithData) => __awaiter(void 0, void 0, void 0, function* () {
        if (!Array.isArray(filesWithData)) {
            filesWithData = [filesWithData];
        }
        const promises = filesWithData.map((fileWithData) => (() => __awaiter(void 0, void 0, void 0, function* () {
            var _a, _b;
            const { file, data } = fileWithData;
            const id = (0, uuid_1.v4)();
            const formData = new FormData();
            const name = (data === null || data === void 0 ? void 0 : data.name) || ((_a = file) === null || _a === void 0 ? void 0 : _a.path) || ((_b = file) === null || _b === void 0 ? void 0 : _b.webkitRelativePath) || (file === null || file === void 0 ? void 0 : file.name) || id;
            data.name = name;
            data.duplicateName = true;
            setUploads((prevState) => (Object.assign(Object.assign({}, prevState), { [id]: {
                    name,
                    progress: 0,
                    status: 'uploading',
                } })));
            const onUploadProgress = (progressEvent) => {
                const progress = Math.round((progressEvent.loaded / progressEvent.total) * 100);
                setUploads((prevState) => (Object.assign(Object.assign({}, prevState), { [id]: Object.assign(Object.assign({}, ((prevState || {})[id] || {})), { status: 'uploading', progress }) })));
            };
            Object.keys(data !== null && data !== void 0 ? data : {}).forEach((key) => {
                if (data[key]) {
                    formData.append(key, data[key]);
                }
            });
            formData.append('file', file);
            yield axios_1.default.post('/api/assets', formData, { onUploadProgress });
            setUploads((_a) => {
                var _b = id, _ = _a[_b], state = __rest(_a, [typeof _b === "symbol" ? _b : _b + ""]);
                return state;
            });
        }))());
        yield Promise.all(promises);
        // Now lets diff the state
        const request = yield axios_1.default.get('/api/assets', { params });
        assetsState.setArrayState(request.data);
    }));
    const createFolder = (0, react_async_hook_1.useAsyncCallback)((data = {}) => __awaiter(void 0, void 0, void 0, function* () {
        var _c;
        try {
            const request = yield axios_1.default.post('/api/assets', Object.assign(Object.assign({}, data), { mimeType: FOLDER_MIME_TYPE }));
            assetsState.create([request.data]);
            return request.data;
        }
        catch (e) {
            throw (_c = e.response) === null || _c === void 0 ? void 0 : _c.data;
        }
    }));
    const del = (0, react_async_hook_1.useAsyncCallback)((ids) => __awaiter(void 0, void 0, void 0, function* () {
        var _d;
        try {
            const request = yield axios_1.default.delete('/api/assets', {
                data: ids,
            });
            assetsState.delete(ids);
            return request.data;
        }
        catch (e) {
            throw (_d = e.response) === null || _d === void 0 ? void 0 : _d.data;
        }
    }));
    const rename = (0, react_async_hook_1.useAsyncCallback)((id, name) => __awaiter(void 0, void 0, void 0, function* () {
        var _e;
        try {
            const request = yield axios_1.default.put(`/api/assets/${id}/rename`, {
                name,
            });
            assetsState.update([request.data]);
            return request.data;
        }
        catch (e) {
            throw (_e = e.response) === null || _e === void 0 ? void 0 : _e.data;
        }
    }));
    const update = (0, react_async_hook_1.useAsyncCallback)((id, { alt, copyright, tags }) => __awaiter(void 0, void 0, void 0, function* () {
        var _f;
        try {
            const request = yield axios_1.default.put(`/api/assets/${id}`, {
                alt,
                copyright,
                tags,
            });
            assetsState.update([request.data]);
            return request.data;
        }
        catch (e) {
            throw (_f = e.response) === null || _f === void 0 ? void 0 : _f.data;
        }
    }));
    const openFileDialog = (0, react_1.useCallback)(() => {
        var _a, _b;
        (_b = (_a = fileInput.current) === null || _a === void 0 ? void 0 : _a.click) === null || _b === void 0 ? void 0 : _b.call(_a);
    }, []);
    const openFolderDialog = (0, react_1.useCallback)(() => {
        var _a, _b;
        (_b = (_a = folderInput.current) === null || _a === void 0 ? void 0 : _a.click) === null || _b === void 0 ? void 0 : _b.call(_a);
    }, []);
    const handleAssetInput = (0, react_1.useCallback)((event) => __awaiter(void 0, void 0, void 0, function* () {
        var _g, _h;
        const files = (_g = event === null || event === void 0 ? void 0 : event.target) === null || _g === void 0 ? void 0 : _g.files;
        yield Promise.all(Object.values(files).map((file) => __awaiter(void 0, void 0, void 0, function* () {
            return upload.execute({
                file,
                data: {
                    mimeType: file.type,
                    parentId: params === null || params === void 0 ? void 0 : params.parentId,
                },
            });
        })));
        if (((_h = Object.keys(files)) === null || _h === void 0 ? void 0 : _h.length) > 1) {
            getAssets.execute(params);
        }
    }), [getAssets]);
    const openItem = (0, react_1.useCallback)(({ id, mimeType } = {}) => {
        if (mimeType === FOLDER_MIME_TYPE || !mimeType) {
            setParams(Object.assign(Object.assign({}, params), { parentId: id }));
            getAssets.execute(Object.assign(Object.assign({}, params), { parentId: id }));
            getAncestors.execute({
                id,
            });
        }
        else {
            selection.setAllSelected(false);
            selection.setKeySelected(id, true, false);
        }
    }, [getAssets, params]);
    (0, react_1.useEffect)(() => {
        if (Array.isArray(getAssets === null || getAssets === void 0 ? void 0 : getAssets.result)) {
            selection.setItems(getAssets === null || getAssets === void 0 ? void 0 : getAssets.result);
        }
    }, [getAssets.result]);
    return (react_1.default.createElement(AssetsContext.Provider, { value: {
            getAssets,
            selectedAssets,
            upload,
            uploads,
            del,
            createFolder,
            getAncestors,
            rename,
            update,
            params,
            setParams,
            assetsState,
            assets: assetsState.arrayState,
            stateData,
            setStateData,
            assetSrc,
            openFileDialog,
            openFolderDialog,
            selection,
            view,
            setView,
            openItem,
        } },
        react_1.default.createElement("input", { multiple: true, 
            // @ts-ignore
            directory: "", webkitdirectory: "", hidden: true, type: "file", ref: folderInput, onChange: handleAssetInput, onClick: (event) => {
                event.target.value = null;
            } }),
        react_1.default.createElement("input", { multiple: true, hidden: true, type: "file", ref: fileInput, onChange: handleAssetInput, onClick: (event) => {
                event.target.value = null;
            } }),
        children));
};
exports.AssetsContextProvider = AssetsContextProvider;
const useAssets = () => (0, react_1.useContext)(AssetsContext);
exports.useAssets = useAssets;
