"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const hoc_1 = require("../../../helpers/hoc");
const react_2 = require("@fluentui/react");
const use_debounce_1 = require("use-debounce");
const react_router_1 = require("react-router");
const query_string_1 = __importDefault(require("query-string"));
const assets_context_1 = require("../context/assets.context");
const assets_details_1 = __importDefault(require("../components/assets-details"));
const assets_create_folder_dialog_1 = __importDefault(require("../components/assets-create-folder-dialog"));
const assets_delete_dialog_1 = __importDefault(require("../components/assets-delete-dialog"));
const assets_rename_dialog_1 = __importDefault(require("../components/assets-rename-dialog"));
const assets_breadcrumb_1 = __importDefault(require("../components/assets-breadcrumb"));
const assets_command_bar_1 = __importDefault(require("../components/assets-command-bar"));
const assets_view_1 = __importDefault(require("../components/assets-view"));
const assets_dropzone_1 = __importDefault(require("../components/assets-dropzone"));
const AssetsPage = () => {
    const { getAssets, getAncestors, setParams, params } = (0, assets_context_1.useAssets)();
    const location = (0, react_router_1.useLocation)();
    const history = (0, react_router_1.useHistory)();
    (0, react_1.useEffect)(() => {
        const search = query_string_1.default.parse(location.search);
        setParams(search);
        getAssets.execute(search);
        getAncestors.execute({
            id: (search === null || search === void 0 ? void 0 : search.parentId) || null,
        });
    }, []);
    (0, react_1.useEffect)(() => {
        history.push({
            search: query_string_1.default.stringify({ parentId: params === null || params === void 0 ? void 0 : params.parentId }),
        });
    }, [params === null || params === void 0 ? void 0 : params.parentId]);
    const debounced = (0, use_debounce_1.useDebouncedCallback)((val) => __awaiter(void 0, void 0, void 0, function* () {
        setParams(Object.assign(Object.assign({}, (params || {})), { search: val, parentId: null }));
        getAssets.execute(Object.assign(Object.assign({}, (params || {})), { search: val, parentId: null }));
        getAncestors.execute();
    }), 500);
    return (react_1.default.createElement(assets_dropzone_1.default, null,
        react_1.default.createElement("div", { className: "page-wrapper" },
            react_1.default.createElement(assets_command_bar_1.default, null),
            react_1.default.createElement("div", { className: "page-content", style: { padding: '0 1rem', overflowY: 'auto' } },
                react_1.default.createElement(react_2.Stack, { horizontal: true, horizontalAlign: "space-between", verticalAlign: "center" },
                    react_1.default.createElement(react_2.StackItem, { grow: true, shrink: true },
                        react_1.default.createElement(assets_breadcrumb_1.default, null)),
                    react_1.default.createElement(react_2.StackItem, null,
                        react_1.default.createElement(react_2.SearchBox, { placeholder: "Search assets...", onChange: (_event, newValue) => {
                                debounced(newValue);
                            } }))),
                react_1.default.createElement(assets_view_1.default, null))),
        react_1.default.createElement(assets_create_folder_dialog_1.default, null),
        react_1.default.createElement(assets_delete_dialog_1.default, null),
        react_1.default.createElement(assets_rename_dialog_1.default, null),
        react_1.default.createElement(assets_details_1.default, null)));
};
exports.default = (0, hoc_1.composeWrappers)({
    assetsContext: assets_context_1.AssetsContextProvider,
})(AssetsPage);
