"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const links_1 = require("../../../components/links");
const react_1 = __importStar(require("react"));
const auth_context_1 = require("../context/auth.context");
const yup = __importStar(require("yup"));
const classnames_1 = __importDefault(require("classnames"));
const react_2 = require("@fluentui/react");
const react_router_1 = require("react-router");
const react_hook_form_1 = require("react-hook-form");
const yup_1 = require("@hookform/resolvers/yup");
const rhf_components_1 = require("../../../components/rhf-components");
const logo_svg_1 = __importDefault(require("../../../assets/logo.svg"));
const useStyles = (0, react_2.makeStyles)({
    wrapper: {
        width: 360,
        marginLeft: 'auto !important',
        marginRight: 'auto !important',
        textAlign: 'left',
        marginBottom: '2%',
    },
    container: {
        minHeight: '100vh',
        minWidth: '100vw',
        display: 'flex',
        justifyContent: 'center',
        alignItems: 'center',
        background: '#faf9f8',
    },
    card: {
        marginBottom: '2rem',
    },
    actions: {
        display: 'flex',
        flexDirection: 'column',
        justifyContent: 'center',
        alignItems: 'center',
    },
    info: {
        textAlign: 'center',
        marginBottom: '1rem !important',
    },
    button: {
        width: '100%',
    },
    alert: {
        marginBottom: '1rem !important',
        textAlign: 'center',
    },
    logo: {
        margin: '0 auto 0.5rem 0',
        display: 'block',
    },
});
const formSchema = yup.object({
    password: yup.string().min(6).required().label('Password'),
    confirmPassword: yup
        .string()
        .min(6)
        .required()
        .oneOf([yup.ref('password'), null], 'Passwords must match.')
        .label('Confirm password'),
});
const ForgotVerify = () => {
    var _a;
    const styles = useStyles();
    const { forgotVerify } = (0, auth_context_1.useAuth)();
    const { token } = (0, react_router_1.useParams)();
    const { control, handleSubmit, setValue } = (0, react_hook_form_1.useForm)({
        resolver: (0, yup_1.yupResolver)(formSchema),
        defaultValues: {
            password: '',
            confirmPassword: '',
            token,
        },
    });
    const submit = handleSubmit((data) => {
        forgotVerify.execute(data);
    });
    (0, react_1.useEffect)(() => {
        setValue('token', token);
    }, [token]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: styles.container },
            react_1.default.createElement("div", { className: (0, classnames_1.default)(styles.wrapper, 'card') },
                react_1.default.createElement("img", { src: logo_svg_1.default, width: 36, height: 36, alt: "Burdy", className: styles.logo }),
                react_1.default.createElement(react_2.Stack, { tokens: { childrenGap: 8, padding: '0 0 16px' } },
                    react_1.default.createElement(react_2.Text, { variant: "xLargePlus", block: true }, "Reset your password"),
                    react_1.default.createElement(react_2.Text, { variant: "medium", block: true }, "Enter your new password.")),
                ((_a = forgotVerify.error) === null || _a === void 0 ? void 0 : _a.message) && (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(react_2.MessageBar, { className: styles.alert, messageBarType: react_2.MessageBarType.error }, forgotVerify.error.message))),
                forgotVerify.status === 'success' ? (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(react_2.MessageBar, { className: styles.alert, messageBarType: react_2.MessageBarType.success }, "Your password has been reset."),
                    react_1.default.createElement(links_1.Link, { to: "/login" },
                        react_1.default.createElement(react_2.DefaultButton, { iconProps: { iconName: 'Back' } }, "Back to Log In")))) : (react_1.default.createElement("form", { onSubmit: submit },
                    react_1.default.createElement(react_2.Stack, { tokens: { childrenGap: 10 } },
                        react_1.default.createElement(rhf_components_1.ControlledTextField, { control: control, name: "password", type: "password", label: "Password", canRevealPassword: true, required: true }),
                        react_1.default.createElement(rhf_components_1.ControlledTextField, { control: control, name: "confirmPassword", type: "password", label: "Confirm Password", canRevealPassword: true, required: true }),
                        react_1.default.createElement(react_2.Stack, { horizontal: true, verticalAlign: "end", horizontalAlign: "space-between", padding: "16px 0 0" },
                            react_1.default.createElement(react_2.Stack.Item, { shrink: false },
                                react_1.default.createElement(links_1.Link, { to: "/" }, "Back")),
                            react_1.default.createElement(react_2.Stack.Item, { shrink: true },
                                react_1.default.createElement(react_2.PrimaryButton, { className: styles.button, type: "submit", disabled: forgotVerify.loading }, "Reset Password"))))))))));
};
exports.default = ForgotVerify;
