"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const auth_context_1 = require("../context/auth.context");
const links_1 = require("../../../components/links");
const classnames_1 = __importDefault(require("classnames"));
const react_2 = require("@fluentui/react");
const yup = __importStar(require("yup"));
const react_hook_form_1 = require("react-hook-form");
const yup_1 = require("@hookform/resolvers/yup");
const rhf_components_1 = require("../../../components/rhf-components");
const logo_svg_1 = __importDefault(require("../../../assets/logo.svg"));
const useStyles = (0, react_2.makeStyles)({
    wrapper: {
        width: 360,
        marginLeft: 'auto !important',
        marginRight: 'auto !important',
        textAlign: 'left',
        marginBottom: '2%',
    },
    container: {
        minHeight: '100vh',
        minWidth: '100vw',
        display: 'flex',
        justifyContent: 'center',
        alignItems: 'center',
        background: '#faf9f8',
    },
    card: {
        marginBottom: '2rem',
    },
    actions: {
        display: 'flex',
        flexDirection: 'column',
        justifyContent: 'center',
        alignItems: 'center',
    },
    info: {
        textAlign: 'center',
        marginBottom: '1rem !important',
    },
    button: {
        marginTop: '1rem',
        width: '100%',
    },
    alert: {
        marginBottom: '1rem !important',
        textAlign: 'center',
    },
    logo: {
        margin: '0 auto 0.5rem 0',
        display: 'block',
    },
});
const formSchema = yup.object({
    email: yup.string().email().required().label('Email'),
    password: yup.string().min(6).label('Password'),
});
const LogIn = () => {
    var _a;
    const styles = useStyles();
    const { logIn } = (0, auth_context_1.useAuth)();
    const { control, handleSubmit } = (0, react_hook_form_1.useForm)({
        resolver: (0, yup_1.yupResolver)(formSchema),
        defaultValues: {
            email: '',
            password: '',
        },
    });
    const submit = handleSubmit((data) => {
        logIn.execute(data);
    });
    (0, react_1.useEffect)(() => {
        logIn.reset();
    }, []);
    return (react_1.default.createElement("div", { className: styles.container },
        react_1.default.createElement("div", { className: (0, classnames_1.default)(styles.wrapper, 'card') },
            react_1.default.createElement("img", { src: logo_svg_1.default, width: 36, height: 36, alt: "Burdy", className: styles.logo }),
            react_1.default.createElement(react_2.Stack, { tokens: { childrenGap: 8, padding: '0 0 16px' } },
                react_1.default.createElement(react_2.Text, { variant: "xLargePlus", block: true }, "Burdy.js"),
                react_1.default.createElement(react_2.Text, { variant: "medium", block: true }, "Log in to continue.")),
            ((_a = logIn.error) === null || _a === void 0 ? void 0 : _a.message) && (react_1.default.createElement(react_2.MessageBar, { className: styles.alert, messageBarType: react_2.MessageBarType.error }, logIn.error.message)),
            react_1.default.createElement(react_2.Stack, { tokens: { childrenGap: 10 } },
                react_1.default.createElement("form", { onSubmit: submit },
                    react_1.default.createElement(rhf_components_1.ControlledTextField, { control: control, type: "email", name: "email", label: "Email", required: true, "data-cy": "login-email" }),
                    react_1.default.createElement(rhf_components_1.ControlledTextField, { control: control, name: "password", label: "Password", required: true, canRevealPassword: true, type: "password", "data-cy": "login-password" }),
                    react_1.default.createElement(react_2.Stack, { horizontal: true, verticalAlign: "end", horizontalAlign: "space-between" },
                        react_1.default.createElement(react_2.Stack.Item, { shrink: false },
                            react_1.default.createElement(links_1.Link, { to: "/forgot" }, "Can't access account?")),
                        react_1.default.createElement(react_2.Stack.Item, { shrink: true },
                            react_1.default.createElement(react_2.PrimaryButton, { className: styles.button, type: "submit", disabled: logIn.loading, "data-cy": "login-submit" }, "Log In"))))))));
};
exports.default = LogIn;
