"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const auth_context_1 = require("../context/auth.context");
const react_2 = require("@fluentui/react");
const classnames_1 = __importDefault(require("classnames"));
const yup = __importStar(require("yup"));
const react_hook_form_1 = require("react-hook-form");
const rhf_components_1 = require("../../../components/rhf-components");
const yup_1 = require("@hookform/resolvers/yup");
const validators_1 = __importDefault(require("../../../../shared/validators"));
const logo_svg_1 = __importDefault(require("../../../assets/logo.svg"));
const useStyles = (0, react_2.makeStyles)({
    wrapper: {
        width: 360,
        marginLeft: 'auto !important',
        marginRight: 'auto !important',
        textAlign: 'left',
        marginBottom: '2%'
    },
    container: {
        minHeight: '100vh',
        minWidth: '100vw',
        display: 'flex',
        justifyContent: 'center',
        alignItems: 'center',
        background: '#faf9f8'
    },
    card: {
        marginBottom: '2rem'
    },
    actions: {
        display: 'flex',
        flexDirection: 'column',
        justifyContent: 'center',
        alignItems: 'center'
    },
    info: {
        textAlign: 'center',
        marginBottom: '1rem !important'
    },
    button: {
        width: '100%'
    },
    alert: {
        marginBottom: '1rem !important',
        textAlign: 'center'
    },
    logo: {
        margin: '0 auto 0.5rem 0',
        display: 'block'
    }
});
const formSchema = yup.object({
    email: validators_1.default.email(),
    password: validators_1.default.password(),
    firstName: validators_1.default.firstName(),
    lastName: validators_1.default.lastName()
});
const Welcome = () => {
    var _a;
    const styles = useStyles();
    const { init } = (0, auth_context_1.useAuth)();
    const { control, handleSubmit } = (0, react_hook_form_1.useForm)({
        resolver: (0, yup_1.yupResolver)(formSchema),
        defaultValues: {
            email: '',
            password: '',
            firstName: '',
            lastName: ''
        }
    });
    const submit = handleSubmit((data) => {
        init.execute(data);
    });
    (0, react_1.useEffect)(() => {
        init.reset();
    }, []);
    return (react_1.default.createElement("div", { className: styles.container },
        react_1.default.createElement("div", { className: (0, classnames_1.default)(styles.wrapper, 'card') },
            react_1.default.createElement("img", { src: logo_svg_1.default, width: 36, height: 36, alt: 'Burdy', className: styles.logo }),
            react_1.default.createElement(react_2.Stack, { tokens: { childrenGap: 8, padding: '0 0 16px' } },
                react_1.default.createElement(react_2.Text, { variant: 'xLargePlus', block: true }, "Welcome"),
                react_1.default.createElement(react_2.Text, { variant: 'medium', block: true }, "Please fill out the following information to begin.")),
            ((_a = init.error) === null || _a === void 0 ? void 0 : _a.message) && (react_1.default.createElement(react_2.MessageBar, { className: styles.alert, messageBarType: react_2.MessageBarType.error }, init.error.message)),
            react_1.default.createElement("form", { onSubmit: submit },
                react_1.default.createElement(react_2.Stack, { tokens: { childrenGap: 8 } },
                    react_1.default.createElement(react_2.Stack, { tokens: { childrenGap: 8 }, horizontal: true },
                        react_1.default.createElement(react_2.Stack.Item, { style: { flexGrow: 1 } },
                            react_1.default.createElement(rhf_components_1.ControlledTextField, { control: control, name: 'firstName', type: 'text', label: 'First Name', autoComplete: 'off', required: true, "data-cy": "welcome-firstName" })),
                        react_1.default.createElement(react_2.Stack.Item, { style: { flexGrow: 1 } },
                            react_1.default.createElement(rhf_components_1.ControlledTextField, { style: { flexGrow: 1 }, control: control, name: 'lastName', type: 'text', label: 'Last Name', autoComplete: 'off', required: true, "data-cy": "welcome-lastName" }))),
                    react_1.default.createElement(rhf_components_1.ControlledTextField, { control: control, name: 'email', type: 'email', label: 'Email', required: true, "data-cy": "welcome-email" }),
                    react_1.default.createElement(rhf_components_1.ControlledTextField, { control: control, name: 'password', type: 'password', label: 'Password', canRevealPassword: true, required: true, "data-cy": "welcome-password" }),
                    react_1.default.createElement(react_2.Stack.Item, { align: 'end' },
                        react_1.default.createElement(react_2.PrimaryButton, { className: styles.button, type: 'submit', disabled: init.loading, "data-cy": "welcome-submit" }, "Get Started")))))));
};
exports.default = Welcome;
