"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const login_1 = __importDefault(require("../content/login"));
const redirect_auth_1 = __importDefault(require("../components/redirect-auth"));
const forgot_1 = __importDefault(require("../content/forgot"));
const forgot_verify_1 = __importDefault(require("../content/forgot-verify"));
const auth_context_1 = require("../context/auth.context");
const welcome_1 = __importDefault(require("../content/welcome"));
const react_router_1 = require("react-router");
const Authentication = () => {
    const { authStatus } = (0, auth_context_1.useAuth)();
    return (react_1.default.createElement(react_router_1.Switch, null,
        authStatus === 'needs-init' && [react_1.default.createElement(react_router_1.Route, { path: "/init", component: welcome_1.default, exact: true })],
        authStatus === 'unauthenticated' && [
            react_1.default.createElement(react_router_1.Route, { path: "/login", component: login_1.default, exact: true }),
            react_1.default.createElement(react_router_1.Route, { path: "/forgot", component: forgot_1.default, exact: true }),
            react_1.default.createElement(react_router_1.Route, { path: "/forgot-verify/:token", component: forgot_verify_1.default, exact: true }),
        ],
        react_1.default.createElement(react_router_1.Route, { path: "*", component: redirect_auth_1.default })));
};
exports.default = Authentication;
