"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const backup_context_1 = require("../context/backup.context");
const dialog_1 = require("../../../context/dialog");
const snackbar_1 = require("../../../context/snackbar");
const backup_import_dialog_1 = __importDefault(require("./backup-import-dialog"));
const backup_restore_dialog_1 = __importDefault(require("./backup-restore-dialog"));
const BackupCommandBar = () => {
    var _a;
    const { list, selectedBackups, remove, create, download } = (0, backup_context_1.useBackups)();
    const dialog = (0, dialog_1.useDialog)();
    const snackbar = (0, snackbar_1.useSnackbar)();
    const [openImport, setOpenImport] = (0, react_2.useState)(false);
    const [openRestore, setOpenRestore] = (0, react_2.useState)(false);
    const toolbarItems = (0, react_2.useMemo)(() => [
        {
            key: 'create-backup',
            text: 'Create Backup',
            iconProps: {
                iconName: 'Save',
            },
            onClick: () => {
                (() => __awaiter(void 0, void 0, void 0, function* () {
                    try {
                        yield dialog.confirm('Create backup', 'Are you sure you would like to proceed?');
                        yield create.execute({});
                        snackbar.openSnackbar({
                            duration: 4000,
                            messageBarType: react_1.MessageBarType.success,
                            message: 'Creating backup',
                        });
                    }
                    catch (e) {
                        snackbar.openSnackbar({
                            duration: 4000,
                            messageBarType: react_1.MessageBarType.error,
                            message: 'Failed to create backup',
                        });
                    }
                }))();
            },
        },
        {
            key: 'download',
            text: 'Download Backup',
            iconProps: {
                iconName: 'Download',
            },
            disabled: selectedBackups.length !== 1,
            onClick: () => {
                var _a;
                const selectedId = (_a = selectedBackups === null || selectedBackups === void 0 ? void 0 : selectedBackups[0]) === null || _a === void 0 ? void 0 : _a.id;
                if (!selectedId)
                    return;
                download(selectedId);
            },
        },
        {
            key: 'delete',
            text: 'Delete',
            disabled: selectedBackups.length !== 1,
            onClick: () => {
                (() => __awaiter(void 0, void 0, void 0, function* () {
                    var _a;
                    try {
                        const selectedId = (_a = selectedBackups === null || selectedBackups === void 0 ? void 0 : selectedBackups[0]) === null || _a === void 0 ? void 0 : _a.id;
                        if (!selectedId)
                            return;
                        yield dialog.confirm('Delete Backup', 'Are you sure you would like to proceed?');
                        yield remove.execute(selectedId);
                    }
                    catch (e) {
                        //
                    }
                }))();
            },
            iconProps: {
                iconName: 'Delete',
            },
        },
        {
            key: 'import',
            text: 'Import',
            onClick: () => {
                setOpenImport(true);
            },
            iconProps: {
                iconName: 'Upload',
            },
        },
        {
            key: 'restore',
            text: 'Restore',
            iconProps: { iconName: 'SaveTemplate' },
            disabled: selectedBackups.length !== 1,
            onClick: () => {
                setOpenRestore(true);
            },
        },
        {
            key: 'refresh',
            text: 'Refresh',
            iconProps: { iconName: 'Refresh' },
            onClick: () => {
                list.execute();
            },
        },
    ], [selectedBackups]);
    return (react_2.default.createElement("div", null,
        react_2.default.createElement(react_1.CommandBar, { items: toolbarItems, style: { borderBottom: `1px solid ${react_1.NeutralColors.gray30}` } }),
        react_2.default.createElement(backup_import_dialog_1.default, { isOpen: openImport, onDismiss: () => setOpenImport(false) }),
        react_2.default.createElement(backup_restore_dialog_1.default, { id: (_a = selectedBackups === null || selectedBackups === void 0 ? void 0 : selectedBackups[0]) === null || _a === void 0 ? void 0 : _a.id, isOpen: openRestore, onDismiss: () => setOpenRestore(false), onRestore: () => {
                setOpenRestore(false);
            } })));
};
exports.default = BackupCommandBar;
