"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const rhf_components_1 = require("../../../components/rhf-components");
const snackbar_1 = require("../../../context/snackbar");
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const backup_context_1 = require("../context/backup.context");
const BackupRestoreDialog = ({ id, isOpen, onDismiss, onRestore, }) => {
    var _a;
    const { openSnackbar } = (0, snackbar_1.useSnackbar)();
    const { restore } = (0, backup_context_1.useBackups)();
    const { control, handleSubmit, reset } = (0, react_hook_form_1.useForm)({
        mode: 'all',
        defaultValues: {
            force: false,
        },
    });
    (0, react_2.useEffect)(() => {
        restore.reset();
        if (isOpen) {
            reset({
                force: false,
            });
        }
    }, [isOpen]);
    (0, react_2.useEffect)(() => {
        if ((restore === null || restore === void 0 ? void 0 : restore.result) && isOpen) {
            onRestore(restore === null || restore === void 0 ? void 0 : restore.result);
            openSnackbar({
                message: 'Backup restored',
                messageBarType: react_1.MessageBarType.success,
            });
        }
    }, [restore === null || restore === void 0 ? void 0 : restore.result]);
    return (react_2.default.createElement(react_1.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_1.DialogType.close,
            title: 'Restore backup?',
        }, modalProps: {
            styles: { main: { maxWidth: 450 } },
        } },
        react_2.default.createElement(react_1.Stack, { tokens: {
                childrenGap: 8,
            } },
            react_2.default.createElement("p", null, "Are you sure you would like to proceed?"),
            ((_a = restore.error) === null || _a === void 0 ? void 0 : _a.message) && (react_2.default.createElement(react_1.MessageBar, { messageBarType: react_1.MessageBarType.error }, restore.error.message)),
            react_2.default.createElement(rhf_components_1.ControlledCheckbox, { control: control, name: "force", label: "Force (will overwrite item if exists)" })),
        react_2.default.createElement(react_1.DialogFooter, null,
            react_2.default.createElement(react_1.DefaultButton, { onClick: onDismiss, "data-cy": "dialog-cancel", text: "Cancel" }),
            react_2.default.createElement(react_1.PrimaryButton, { onClick: () => {
                    handleSubmit((data) => {
                        restore.execute(id, data === null || data === void 0 ? void 0 : data.force);
                    })();
                }, text: "Restore", disabled: restore === null || restore === void 0 ? void 0 : restore.loading, "data-cy": "dialog-confirm" }))));
};
exports.default = BackupRestoreDialog;
