"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useBackups = exports.BackupContextProvider = void 0;
const react_1 = __importStar(require("react"));
const react_async_hook_1 = require("react-async-hook");
const api_1 = __importStar(require("../../../helpers/api"));
const selection_1 = require("../../../helpers/selection");
const react_2 = require("@fluentui/react");
const hooks_1 = require("../../../helpers/hooks");
const uuid_1 = require("uuid");
const axios_1 = __importDefault(require("axios"));
const BackupContext = (0, react_1.createContext)({});
const BackupContextProvider = ({ children, selectionMode = react_2.SelectionMode.single, defaultSelectedBackups = [], }) => {
    const [selectedBackups, setSelectedBackups] = (0, react_1.useState)([]);
    const [uploads, setUploads] = (0, react_1.useState)({});
    const selection = (0, selection_1.useSelection)({
        onSelectionChanged: () => {
            setSelectedBackups(selection.getSelection());
        },
        getKey: (backup) => backup.id,
        selectionMode,
        defaultSelectedItems: defaultSelectedBackups,
    });
    const backupState = (0, hooks_1.useModelState)([], (a, b) => {
        return b.id - a.id;
    });
    (0, react_1.useEffect)(() => {
        // Refresh selection
        selection.setItems(backupState.arrayState, false);
        setSelectedBackups(selection.getSelection());
    }, [backupState.arrayState]);
    const list = (0, api_1.useApiCallback)(() => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.get('/backups');
        backupState.setArrayState(response.data);
        return response;
    }));
    const get = (0, api_1.useApiCallback)((id) => __awaiter(void 0, void 0, void 0, function* () { return api_1.default.get(`/backups/${id}`); }));
    const remove = (0, api_1.useApiCallback)((id) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.delete(`/backups/${id}`);
        backupState.delete([id]);
        return response;
    }));
    const create = (0, api_1.useApiCallback)((partial) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.post(`/backups`, partial);
        backupState.create([response.data]);
        return response;
    }));
    const download = (0, react_1.useCallback)((id) => {
        window.open(`${api_1.default.defaults.baseURL}/backups/download/${id}`, '_blank');
    }, []);
    const restore = (0, api_1.useApiCallback)((id, force = false) => __awaiter(void 0, void 0, void 0, function* () {
        return api_1.default.post(`/backups/restore`, {
            id,
            force,
        });
    }));
    const upload = (0, react_async_hook_1.useAsyncCallback)((filesWithData) => __awaiter(void 0, void 0, void 0, function* () {
        if (!Array.isArray(filesWithData)) {
            filesWithData = [filesWithData];
        }
        const promises = filesWithData.map((fileWithData) => (() => __awaiter(void 0, void 0, void 0, function* () {
            var _a, _b;
            const { file } = fileWithData;
            const id = (0, uuid_1.v4)();
            const formData = new FormData();
            const name = ((_a = file) === null || _a === void 0 ? void 0 : _a.path) || ((_b = file) === null || _b === void 0 ? void 0 : _b.webkitRelativePath) || (file === null || file === void 0 ? void 0 : file.name) || id;
            setUploads((prevState) => (Object.assign(Object.assign({}, prevState), { [id]: {
                    name,
                    progress: 0,
                    status: 'uploading',
                } })));
            const onUploadProgress = (progressEvent) => {
                const progress = Math.round((progressEvent.loaded / progressEvent.total) * 100);
                setUploads((prevState) => (Object.assign(Object.assign({}, prevState), { [id]: Object.assign(Object.assign({}, ((prevState || {})[id] || {})), { status: 'uploading', progress }) })));
            };
            formData.append('file', file);
            yield axios_1.default.post('/api/backups/import', formData, { onUploadProgress });
            setUploads((_a) => {
                var _b = id, _ = _a[_b], state = __rest(_a, [typeof _b === "symbol" ? _b : _b + ""]);
                return state;
            });
        }))());
        yield Promise.all(promises);
        // Now lets diff the state
        const response = yield axios_1.default.get('/api/backups');
        backupState.setArrayState(response.data);
        return response === null || response === void 0 ? void 0 : response.data;
    }));
    return (react_1.default.createElement(BackupContext.Provider, { value: {
            get,
            list,
            remove,
            create,
            download,
            restore,
            selectedBackups,
            selection,
            backupState,
            backups: backupState.arrayState,
            upload,
            uploads
        } }, children));
};
exports.BackupContextProvider = BackupContextProvider;
const useBackups = () => (0, react_1.useContext)(BackupContext);
exports.useBackups = useBackups;
