"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const loading_bar_1 = __importDefault(require("../../../components/loading-bar"));
const react_hook_form_1 = require("react-hook-form");
const rhf_components_1 = require("../../../components/rhf-components");
const hoc_1 = require("../../../helpers/hoc");
const content_types_context_1 = require("../context/content-types.context");
const fields_list_1 = __importDefault(require("./fields-list"));
const validators_1 = require("../../../../shared/validators");
const ContentTypeCreatePanel = ({ isOpen, defaultType, onDismiss, onCreated, }) => {
    var _a;
    const { createContentType, getComponents } = (0, content_types_context_1.useContentTypes)();
    const [field, setField] = (0, react_1.useState)({
        fields: [],
    });
    const { control, handleSubmit, reset } = (0, react_hook_form_1.useForm)({
        mode: 'all',
    });
    (0, react_1.useEffect)(() => {
        createContentType.reset();
        getComponents.reset();
        reset();
        setField({
            fields: [],
        });
    }, [isOpen]);
    (0, react_1.useEffect)(() => {
        if (createContentType === null || createContentType === void 0 ? void 0 : createContentType.result) {
            onCreated(createContentType === null || createContentType === void 0 ? void 0 : createContentType.result);
        }
    }, [createContentType === null || createContentType === void 0 ? void 0 : createContentType.result]);
    const Footer = (0, react_1.useCallback)(() => (react_1.default.createElement(react_2.Stack, { horizontal: true, tokens: { childrenGap: 10 } },
        react_1.default.createElement(react_2.PrimaryButton, { onClick: () => {
                handleSubmit((data) => {
                    var _a;
                    createContentType.execute(Object.assign(Object.assign({}, data), { fields: (_a = field === null || field === void 0 ? void 0 : field.fields) !== null && _a !== void 0 ? _a : [] }));
                })();
            }, "data-cy": "contentTypes-add-confirm" }, "Create"),
        react_1.default.createElement(react_2.DefaultButton, { onClick: onDismiss, "data-cy": "contentTypes-add-cancel" }, "Cancel"))), [field === null || field === void 0 ? void 0 : field.fields]);
    return (react_1.default.createElement(react_2.Panel, { isOpen: isOpen, headerText: "New Content Type", isFooterAtBottom: true, onRenderFooterContent: Footer, onDismiss: onDismiss, type: react_2.PanelType.medium },
        react_1.default.createElement(loading_bar_1.default, { loading: false },
            ((_a = createContentType.error) === null || _a === void 0 ? void 0 : _a.message) && (react_1.default.createElement(react_2.MessageBar, { messageBarType: react_2.MessageBarType.error }, createContentType.error.message)),
            react_1.default.createElement(react_2.Stack, { tokens: { childrenGap: 10 } },
                react_1.default.createElement(rhf_components_1.ControlledTextField, { defaultValue: "", control: control, name: "name", label: "Name", "data-cy": "contentTypes-add-name", autoFocus: true, rules: {
                        required: 'Name is required',
                        pattern: {
                            value: validators_1.slugRegex,
                            message: validators_1.slugRegexMessage,
                        },
                    } }),
                react_1.default.createElement(rhf_components_1.ControlledDropdown, { defaultValue: defaultType && defaultType !== 'all' ? defaultType : 'page', control: control, "data-cy": "contentTypes-add-type", options: [
                        {
                            key: 'page',
                            text: 'Page',
                        },
                        {
                            key: 'fragment',
                            text: 'Fragment',
                        },
                        {
                            key: 'component',
                            text: 'Component',
                        },
                        {
                            key: 'post',
                            text: 'Post',
                        },
                    ], name: "type", label: "Type" }),
                react_1.default.createElement("div", null,
                    react_1.default.createElement(react_2.Label, null, "Fields"),
                    isOpen && react_1.default.createElement(fields_list_1.default, { isRoot: true, field: field }))))));
};
exports.default = (0, hoc_1.composeWrappers)({
    contentTypesContext: content_types_context_1.ContentTypesContextProvider,
})(ContentTypeCreatePanel);
