"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const loading_bar_1 = __importDefault(require("../../../components/loading-bar"));
const react_hook_form_1 = require("react-hook-form");
const rhf_components_1 = require("../../../components/rhf-components");
const hoc_1 = require("../../../helpers/hoc");
const snackbar_1 = require("../../../context/snackbar");
const content_types_context_1 = require("../context/content-types.context");
const fields_list_1 = __importDefault(require("./fields-list"));
const validators_1 = require("../../../../shared/validators");
const ContentTypeUpdatePanel = ({ isOpen, contentTypeId, onDismiss, onUpdated, }) => {
    var _a, _b, _c;
    const { updateContentType, getContentType, getComponents } = (0, content_types_context_1.useContentTypes)();
    const { openSnackbar } = (0, snackbar_1.useSnackbar)();
    const [field, setField] = (0, react_1.useState)({
        fields: [],
    });
    const { control, handleSubmit, reset } = (0, react_hook_form_1.useForm)({
        mode: 'all',
    });
    (0, react_1.useEffect)(() => {
        if (getContentType.result) {
            setField(getContentType.result);
        }
    }, [getContentType.result]);
    (0, react_1.useEffect)(() => {
        updateContentType.reset();
        getContentType.reset();
        getComponents.reset();
        reset();
        setField({
            fields: [],
        });
    }, [isOpen]);
    (0, react_1.useEffect)(() => {
        if (contentTypeId && isOpen) {
            getContentType.execute(contentTypeId);
        }
    }, [contentTypeId, isOpen]);
    (0, react_1.useEffect)(() => {
        if ((updateContentType === null || updateContentType === void 0 ? void 0 : updateContentType.result) && isOpen) {
            onUpdated(updateContentType === null || updateContentType === void 0 ? void 0 : updateContentType.result);
            openSnackbar({
                message: 'Content typed updated',
                messageBarType: react_2.MessageBarType.success,
            });
        }
    }, [updateContentType === null || updateContentType === void 0 ? void 0 : updateContentType.result]);
    const Footer = (0, react_1.useCallback)(() => (react_1.default.createElement(react_2.Stack, { horizontal: true, tokens: { childrenGap: 10 } },
        react_1.default.createElement(react_2.PrimaryButton, { disabled: !getContentType.result ||
                getContentType.loading ||
                updateContentType.loading, onClick: () => {
                handleSubmit((data) => {
                    updateContentType.execute(contentTypeId, Object.assign(Object.assign({}, data), { fields: field === null || field === void 0 ? void 0 : field.fields }));
                })();
            }, "data-cy": "contentTypes-edit-confirm" }, "Update"),
        react_1.default.createElement(react_2.DefaultButton, { onClick: onDismiss, "data-cy": "contentTypes-edit-cancel" }, "Cancel"))), [getContentType === null || getContentType === void 0 ? void 0 : getContentType.result, field === null || field === void 0 ? void 0 : field.fields]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(react_2.Panel, { isOpen: isOpen, headerText: "Update Content Type", isFooterAtBottom: true, onRenderFooterContent: Footer, onDismiss: onDismiss, type: react_2.PanelType.medium },
            react_1.default.createElement(loading_bar_1.default, { loading: getContentType.loading },
                ((_a = updateContentType.error) === null || _a === void 0 ? void 0 : _a.message) && (react_1.default.createElement(react_2.MessageBar, { messageBarType: react_2.MessageBarType.error }, updateContentType.error.message)),
                ((_b = getContentType.error) === null || _b === void 0 ? void 0 : _b.message) && (react_1.default.createElement(react_2.MessageBar, { messageBarType: react_2.MessageBarType.error }, getContentType.error.message)),
                getContentType.result && (react_1.default.createElement(react_2.Stack, { tokens: { childrenGap: 10 } },
                    react_1.default.createElement(rhf_components_1.ControlledTextField, { defaultValue: (_c = getContentType === null || getContentType === void 0 ? void 0 : getContentType.result) === null || _c === void 0 ? void 0 : _c.name, control: control, name: "name", label: "Name", "data-cy": "contentTypes-edit-name", rules: {
                            required: 'Name is required',
                            pattern: {
                                value: validators_1.slugRegex,
                                message: validators_1.slugRegexMessage,
                            }
                        } }),
                    react_1.default.createElement("div", null,
                        react_1.default.createElement(react_2.Label, null, "Fields"),
                        isOpen && react_1.default.createElement(fields_list_1.default, { isRoot: true, field: field }))))))));
};
exports.default = (0, hoc_1.composeWrappers)({
    contentTypesContext: content_types_context_1.ContentTypesContextProvider,
})(ContentTypeUpdatePanel);
