"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const use_debounce_1 = require("use-debounce");
const content_types_context_1 = require("../context/content-types.context");
const auth_context_1 = require("../../authentication/context/auth.context");
const queryString = __importStar(require("querystring"));
const ContentTypesCommandBar = () => {
    const { selectedContentTypes, stateData, setStateData, getContentTypes, params, setParams, } = (0, content_types_context_1.useContentTypes)();
    const { filterPermissions } = (0, auth_context_1.useAuth)();
    const debounced = (0, use_debounce_1.useDebouncedCallback)((val) => __awaiter(void 0, void 0, void 0, function* () {
        setParams(Object.assign(Object.assign({}, (params || {})), { search: val }));
        getContentTypes.execute(Object.assign(Object.assign({}, (params || {})), { search: val }));
    }), 500);
    const commandItems = (0, react_2.useMemo)(() => filterPermissions([
        {
            key: 'newItem',
            text: 'New',
            'data-cy': 'contentTypes-commandBar-new',
            iconProps: { iconName: 'Add' },
            permissions: ['content_types_create'],
            onClick: () => {
                setStateData('createContentTypeOpen', true);
            },
        },
        {
            key: 'edit',
            text: 'Edit',
            'data-cy': 'contentTypes-commandBar-edit',
            disabled: (selectedContentTypes === null || selectedContentTypes === void 0 ? void 0 : selectedContentTypes.length) !== 1,
            iconProps: { iconName: 'Edit' },
            permissions: ['content_types_update'],
            onClick: () => {
                setStateData('updateContentTypeOpen', true);
            },
        },
        {
            key: 'delete',
            text: 'Delete',
            'data-cy': 'contentTypes-commandBar-delete',
            disabled: (selectedContentTypes === null || selectedContentTypes === void 0 ? void 0 : selectedContentTypes.length) === 0,
            iconProps: { iconName: 'Delete' },
            permissions: ['content_types_delete'],
            onClick: () => {
                setStateData('deleteContentTypesOpen', true);
            },
        },
        {
            key: 'import',
            text: 'Import',
            'data-cy': 'contentTypes-commandBar-import',
            iconProps: { iconName: 'Upload' },
            permissions: ['content_types_update'],
            onClick: () => {
                setStateData('importContentTypesOpen', true);
            },
        },
        {
            key: 'export',
            text: 'Export',
            'data-cy': 'contentTypes-commandBar-export',
            disabled: !((selectedContentTypes === null || selectedContentTypes === void 0 ? void 0 : selectedContentTypes.length) > 0),
            iconProps: { iconName: 'Download' },
            onClick: () => {
                window.open(`/api/content-types/export?${queryString.stringify({
                    id: selectedContentTypes === null || selectedContentTypes === void 0 ? void 0 : selectedContentTypes.map((ct) => ct === null || ct === void 0 ? void 0 : ct.id).join(','),
                })}`, '_blank');
            },
        },
        {
            key: 'refresh',
            text: 'Refresh',
            iconProps: { iconName: 'Refresh' },
            onClick: () => {
                getContentTypes.execute(params);
            },
        },
    ]), [selectedContentTypes, params, stateData]);
    const farToolbarItems = (0, react_2.useMemo)(() => [
        {
            key: 'search',
            onRenderIcon: () => (react_2.default.createElement(react_1.SearchBox, { placeholder: "Search types...", onChange: (_event, newValue) => {
                    debounced(newValue);
                } })),
        },
    ], []);
    return (react_2.default.createElement(react_1.CommandBar, { items: commandItems, farItems: farToolbarItems, style: { borderBottom: `1px solid ${react_1.NeutralColors.gray30}` } }));
};
exports.default = ContentTypesCommandBar;
