"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const rhf_components_1 = require("../../../components/rhf-components");
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const content_types_context_1 = require("../context/content-types.context");
const ContentTypesDeleteDialog = ({ isOpen, onDismiss, onDeleted, }) => {
    var _a, _b;
    const { deleteContentTypes, selectedContentTypes } = (0, content_types_context_1.useContentTypes)();
    const { control, handleSubmit, reset } = (0, react_hook_form_1.useForm)({
        mode: 'all',
    });
    (0, react_2.useEffect)(() => {
        deleteContentTypes.reset();
        reset();
    }, [isOpen]);
    (0, react_2.useEffect)(() => {
        if (deleteContentTypes === null || deleteContentTypes === void 0 ? void 0 : deleteContentTypes.result) {
            onDeleted(deleteContentTypes === null || deleteContentTypes === void 0 ? void 0 : deleteContentTypes.result);
        }
    }, [deleteContentTypes === null || deleteContentTypes === void 0 ? void 0 : deleteContentTypes.result]);
    return (react_2.default.createElement(react_1.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_1.DialogType.close,
            title: 'Delete?',
        }, modalProps: {
            styles: { main: { maxWidth: 450 } },
        } },
        react_2.default.createElement(react_1.Stack, { tokens: { childrenGap: 8 } },
            "Are you sure you would like to delete these item(s)?",
            ((_a = deleteContentTypes.error) === null || _a === void 0 ? void 0 : _a.message) && (react_2.default.createElement(react_1.MessageBar, { messageBarType: react_1.MessageBarType.error }, deleteContentTypes.error.message)),
            ((_b = deleteContentTypes.error) === null || _b === void 0 ? void 0 : _b.message) === 'posts_exist' && (react_2.default.createElement(rhf_components_1.ControlledCheckbox, { label: "Force delete (will delete all posts)", name: "force", defaultValue: false, control: control, "data-cy": "dialog-force" }))),
        react_2.default.createElement(react_1.DialogFooter, null,
            react_2.default.createElement(react_1.DefaultButton, { onClick: onDismiss, text: "Cancel", "data-cy": "dialog-cancel" }),
            react_2.default.createElement(react_1.PrimaryButton, { onClick: () => {
                    handleSubmit((data) => {
                        deleteContentTypes.execute(selectedContentTypes.map((contentType) => contentType.id), data);
                    })();
                }, text: "Delete", disabled: deleteContentTypes === null || deleteContentTypes === void 0 ? void 0 : deleteContentTypes.loading, "data-cy": "dialog-confirm" }))));
};
exports.default = ContentTypesDeleteDialog;
