"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const empty_1 = __importDefault(require("../../../components/empty"));
const auth_context_1 = require("../../authentication/context/auth.context");
const content_types_context_1 = require("../context/content-types.context");
const classNames = (0, react_2.mergeStyleSets)({
    fileIconHeaderIcon: {
        padding: 0,
        fontSize: '16px'
    },
    fileIconCell: {
        textAlign: 'center',
        selectors: {
            '&:before': {
                content: '.',
                display: 'inline-block',
                verticalAlign: 'middle',
                height: '100%',
                width: '0px',
                visibility: 'hidden'
            }
        }
    },
    link: {
        '&:hover': {
            textDecoration: 'underline !important',
            cursor: 'pointer'
        }
    }
});
const ContentTypesList = () => {
    const { getContentTypes, selection, setStateData, stateData, contentTypes } = (0, content_types_context_1.useContentTypes)();
    const { hasPermission } = (0, auth_context_1.useAuth)();
    const columns = (0, react_1.useMemo)(() => [
        {
            key: 'name',
            name: 'Name',
            fieldName: 'name',
            minWidth: 210,
            isRowHeader: true,
            isResizable: true,
            data: 'string',
            onRender: (item) => {
                return hasPermission(['content_types_update']) ? (react_1.default.createElement("span", { onClick: () => {
                        setStateData('updateContentTypeOpen', true);
                    }, className: classNames.link }, item.name)) : (react_1.default.createElement("span", null, item.name));
            },
            isPadded: true
        },
        {
            key: 'type',
            name: 'Type',
            fieldName: 'type',
            minWidth: 210,
            isRowHeader: true,
            isResizable: true,
            data: 'string',
            onRender: ({ type }) => {
                return react_1.default.createElement("span", null, type);
            },
            isPadded: true
        },
        {
            key: 'author',
            name: 'Author',
            fieldName: 'author',
            minWidth: 210,
            isResizable: true,
            isCollapsible: true,
            onRender: ({ author }) => {
                return (react_1.default.createElement("span", null, author === null || author === void 0 ? void 0 :
                    author.firstName,
                    " ", author === null || author === void 0 ? void 0 :
                    author.lastName));
            }
        },
        {
            key: 'modifiedAt',
            name: 'Date Modified',
            fieldName: 'modifiedAt',
            minWidth: 200,
            maxWidth: 200,
            isResizable: true,
            data: 'number',
            onRender: ({ updatedAt }) => {
                return (react_1.default.createElement("span", null, new Date(updatedAt).toLocaleDateString([], {
                    hour: '2-digit',
                    minute: '2-digit',
                    hour12: false
                })));
            },
            isPadded: true
        }
    ], [stateData]);
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(react_2.MarqueeSelection, { selection: selection, isDraggingConstrainedToRoot: true },
            react_1.default.createElement(react_2.ShimmeredDetailsList, { items: contentTypes !== null && contentTypes !== void 0 ? contentTypes : [], columns: columns, enableShimmer: getContentTypes === null || getContentTypes === void 0 ? void 0 : getContentTypes.loading, selectionMode: react_2.SelectionMode.multiple, setKey: 'multiple', layoutMode: react_2.DetailsListLayoutMode.justified, isHeaderVisible: true, selection: selection, selectionPreservedOnEmptyClick: true, ariaLabelForSelectionColumn: 'Toggle selection', ariaLabelForSelectAllCheckbox: 'Toggle selection for all items', checkButtonAriaLabel: 'select row' })),
        !(getContentTypes === null || getContentTypes === void 0 ? void 0 : getContentTypes.loading) && !((contentTypes === null || contentTypes === void 0 ? void 0 : contentTypes.length) > 0) && (react_1.default.createElement(empty_1.default, { title: 'No content types', image: 'contentTypes' }))));
};
exports.default = ContentTypesList;
