"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContentTypesContextProvider = exports.useContentTypes = void 0;
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const hooks_1 = require("../../../helpers/hooks");
const api_1 = __importStar(require("../../../helpers/api"));
const ContentTypesContext = (0, react_1.createContext)({});
const ContentTypesContextProvider = ({ children }) => {
    const [selectedContentTypes, setSelectedContentTypes] = (0, react_1.useState)([]);
    const [params, setParams] = (0, react_1.useState)({});
    const contentTypesState = (0, hooks_1.useModelState)([], (a, b) => {
        if (!(a === null || a === void 0 ? void 0 : a.updatedAt) || !(b === null || b === void 0 ? void 0 : b.updatedAt))
            return 0;
        return (new Date(b.updatedAt)).getTime() - (new Date(a.updatedAt)).getTime();
    });
    const [stateData, setStateDataImpl] = (0, react_1.useState)({});
    const setStateData = (key, value) => {
        setStateDataImpl(Object.assign(Object.assign({}, (stateData || {})), { [key]: value }));
    };
    const selection = (0, react_1.useMemo)(() => new react_2.Selection({
        onSelectionChanged: () => {
            setSelectedContentTypes(selection.getSelection());
        },
        getKey: (post) => post.id,
    }), []);
    const getContentTypes = (0, api_1.useApiCallback)((params) => __awaiter(void 0, void 0, void 0, function* () {
        contentTypesState.setArrayState([]);
        const response = yield api_1.default.get('/content-types', { params });
        contentTypesState.setArrayState(response === null || response === void 0 ? void 0 : response.data);
        return response;
    }));
    const getContentType = (0, api_1.useApiCallback)((id) => __awaiter(void 0, void 0, void 0, function* () { return api_1.default.get(`/content-types/${id}`); }));
    const getSingleContentType = (0, api_1.useApiCallback)((data) => __awaiter(void 0, void 0, void 0, function* () { return api_1.default.get('/content-types/single', { params: data }); }));
    const createContentType = (0, api_1.useApiCallback)((data) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.post('/content-types', data);
        contentTypesState.create([response === null || response === void 0 ? void 0 : response.data]);
        return response;
    }));
    const updateContentType = (0, api_1.useApiCallback)((id, data) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.put(`/content-types/${id}`, data);
        contentTypesState.update([response === null || response === void 0 ? void 0 : response.data]);
        return response;
    }));
    const deleteContentTypes = (0, api_1.useApiCallback)((ids, params) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.delete('/content-types', {
            data: ids,
            params,
        });
        contentTypesState.delete(ids);
        return response;
    }));
    const importContentTypes = (0, api_1.useApiCallback)((data) => __awaiter(void 0, void 0, void 0, function* () { return api_1.default.post(`/content-types/import`, data); }));
    const getComponents = (0, api_1.useApiCallback)(() => __awaiter(void 0, void 0, void 0, function* () { return api_1.default.get(`/components`); }));
    const getFields = (0, api_1.useApiCallback)(() => __awaiter(void 0, void 0, void 0, function* () { return api_1.default.get(`/fields`); }));
    const getField = (0, api_1.useApiCallback)((type) => __awaiter(void 0, void 0, void 0, function* () { return api_1.default.get(`/fields/${type}`); }));
    return (react_1.default.createElement(ContentTypesContext.Provider, { value: {
            selection,
            selectedContentTypes,
            contentTypes: contentTypesState.arrayState,
            contentTypesState,
            getContentTypes,
            getSingleContentType,
            getContentType,
            createContentType,
            updateContentType,
            deleteContentTypes,
            importContentTypes,
            getComponents,
            getFields,
            getField,
            params,
            setParams,
            stateData,
            setStateData,
        } }, children));
};
exports.ContentTypesContextProvider = ContentTypesContextProvider;
const useContentTypes = () => (0, react_1.useContext)(ContentTypesContext);
exports.useContentTypes = useContentTypes;
