"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const groups_context_1 = require("../context/groups.context");
const react_router_1 = require("react-router");
const dialog_1 = require("../../../context/dialog");
const lodash_1 = __importDefault(require("lodash"));
const GroupCommandBar = (_a) => {
    var { visibleColumns = ['add', 'edit', 'delete', 'refresh'] } = _a, props = __rest(_a, ["visibleColumns"]);
    const dialog = (0, dialog_1.useDialog)();
    const { selectedGroups, deleteMany, list } = (0, groups_context_1.useGroups)();
    const history = (0, react_router_1.useHistory)();
    const commandList = (0, react_1.useMemo)(() => [
        {
            key: 'add',
            text: 'Add a group',
            'data-cy': 'groups-commandBar-add',
            iconProps: { iconName: 'AddFriend' },
            onClick: () => {
                history.push('/settings/groups/add');
            },
        },
        {
            key: 'edit',
            text: 'Edit group',
            'data-cy': 'groups-commandBar-edit',
            iconProps: { iconName: 'Edit' },
            disabled: selectedGroups.length !== 1,
            onClick: () => {
                var _a;
                history.push(`/settings/groups/edit/${(_a = selectedGroups === null || selectedGroups === void 0 ? void 0 : selectedGroups[0]) === null || _a === void 0 ? void 0 : _a.id}`);
            },
        },
        {
            key: 'delete',
            text: 'Delete group',
            'data-cy': 'groups-commandBar-delete',
            iconProps: { iconName: 'Delete' },
            disabled: selectedGroups.length === 0 ||
                selectedGroups.some((g) => g.protected),
            onClick: () => {
                dialog
                    .confirm('Delete Groups', 'Are you sure? Some accesses might be revoked from users.')
                    .then(() => __awaiter(void 0, void 0, void 0, function* () {
                    yield deleteMany.execute(lodash_1.default.map(selectedGroups, 'id'));
                }))
                    .catch((e) => e);
            },
        },
        {
            key: 'refresh',
            text: 'Refresh',
            'data-cy': 'groups-commandBar-refresh',
            iconProps: { iconName: 'Refresh' },
            onClick: () => {
                list.execute();
            },
        },
    ].filter(({ key }) => visibleColumns.includes(key)), [selectedGroups, visibleColumns]);
    return (react_1.default.createElement(react_2.CommandBar, Object.assign({ items: commandList, style: { borderBottom: `1px solid ${react_2.NeutralColors.gray30}` } }, props)));
};
exports.default = GroupCommandBar;
