"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const groups_context_1 = require("../context/groups.context");
const react_2 = require("@fluentui/react");
const links_1 = require("../../../components/links");
const react_router_1 = require("react-router");
const GroupList = (_a) => {
    var { overrideGroups, visibleColumns } = _a, props = __rest(_a, ["overrideGroups", "visibleColumns"]);
    const { list, groups, selection } = (0, groups_context_1.useGroups)();
    const history = (0, react_router_1.useHistory)();
    const listGroups = (0, react_1.useMemo)(() => overrideGroups !== null && overrideGroups !== void 0 ? overrideGroups : groups, [overrideGroups, groups]);
    const columns = (0, react_1.useMemo)(() => [
        {
            key: 'id',
            name: 'ID',
            fieldName: 'id',
            minWidth: 24,
            maxWidth: 24,
        },
        {
            key: 'name',
            name: 'Name',
            fieldName: 'name',
            minWidth: 32,
            maxWidth: 200,
            onRender: (item) => (react_1.default.createElement(react_2.Text, { variant: "medium" },
                react_1.default.createElement(links_1.Link, { to: `/settings/groups/edit/${item.id}` }, item.name))),
        },
        {
            key: 'description',
            name: 'Description',
            fieldName: 'description',
            minWidth: 80,
        },
        {
            key: 'protected',
            name: 'Protected',
            minWidth: 80,
            maxWidth: 120,
            onRender: (item) => (item.protected ? 'Yes' : 'No'),
        },
    ], []);
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(react_2.MarqueeSelection, { selection: selection, isDraggingConstrainedToRoot: true },
            react_1.default.createElement(react_2.ShimmeredDetailsList, Object.assign({ enableShimmer: list === null || list === void 0 ? void 0 : list.loading, selection: selection, selectionMode: react_2.SelectionMode.multiple, setKey: "multiple", selectionPreservedOnEmptyClick: true, items: listGroups !== null && listGroups !== void 0 ? listGroups : [], columns: columns, onItemInvoked: (item) => history.push(`/settings/groups/edit/${item.id}`) }, props)))));
};
exports.default = GroupList;
