"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const users_context_1 = require("../../users/context/users.context");
const lodash_1 = __importDefault(require("lodash"));
const auth_context_1 = require("../../authentication/context/auth.context");
const hoc_1 = require("../../../helpers/hoc");
const user_select_panel_1 = __importDefault(require("../../users/components/user-select-panel"));
const react_hooks_1 = require("@fluentui/react-hooks");
const user_list_1 = __importDefault(require("../../users/components/user-list"));
const useStyles = (0, react_1.makeStyles)({
    commandBar: {
        marginTop: 12,
    },
});
const GroupMembers = ({ users, setUsers, close, isProtected = false, }) => {
    const styles = useStyles();
    const usersContext = (0, users_context_1.useUsers)();
    const { user: authUser } = (0, auth_context_1.useAuth)();
    const [addUserOpen, setAddUserOpen] = (0, react_2.useState)(false);
    const [addUsers, setAddUsers] = (0, react_2.useState)([]);
    const [userSearch, setUserSearch] = (0, react_2.useState)('');
    const [addUserSearch, setAddUserSearch] = (0, react_2.useState)('');
    const debouncedSearch = (0, react_hooks_1.useAsync)().debounce((search) => {
        setUserSearch(search);
    }, 150);
    const debouncedAddSearch = (0, react_hooks_1.useAsync)().debounce((search) => {
        setAddUserSearch(search);
    }, 150);
    (0, react_2.useEffect)(() => {
        usersContext.list.execute();
    }, []);
    (0, react_2.useEffect)(() => {
        setAddUsers(lodash_1.default.differenceBy(usersContext.users, users, 'id'));
    }, [usersContext.users, users]);
    const searchUsers = (0, react_2.useCallback)((users, search) => {
        const lowerCaseSearch = search.toLowerCase();
        return users.filter((user) => ((user === null || user === void 0 ? void 0 : user.firstName) || '').toLowerCase().includes(lowerCaseSearch) ||
            ((user === null || user === void 0 ? void 0 : user.lastName) || '').toLowerCase().includes(lowerCaseSearch) ||
            user.email.toLowerCase().includes(lowerCaseSearch));
    }, []);
    const commandActions = (0, react_2.useMemo)(() => [
        {
            key: 'add',
            text: 'Add members',
            iconProps: { iconName: 'Add' },
            onClick: () => setAddUserOpen(true),
        },
        {
            key: 'remove',
            text: `Remove members`,
            iconProps: { iconName: 'Delete' },
            disabled: usersContext.selectedUsers.length === 0 ||
                (isProtected &&
                    usersContext.selectedUsers.some((u) => u.id === authUser.id)),
            onClick: () => {
                setUsers(lodash_1.default.differenceBy(users, usersContext.selectedUsers, 'id'));
            },
        },
    ], [authUser, users, usersContext.selectedUsers]);
    const addUserCommandItems = (0, react_hooks_1.useConst)(() => [
        {
            key: 'search',
            onRenderIcon: () => (react_2.default.createElement(react_1.SearchBox, { placeholder: "Search users...", onChange: (event, newValue) => debouncedAddSearch(newValue) })),
        },
    ]);
    const visibleUsers = (0, react_2.useMemo)(() => searchUsers(users, userSearch), [users, userSearch]);
    const visibleAddUsers = (0, react_2.useMemo)(() => searchUsers(addUsers, addUserSearch), [addUsers, addUserSearch]);
    return (react_2.default.createElement(react_2.default.Fragment, null,
        react_2.default.createElement(user_select_panel_1.default, { suppressDefaultUpdates: true, panelProps: { title: 'Add Members' }, isOpen: addUserOpen, onBack: () => setAddUserOpen(false), onDismiss: () => close === null || close === void 0 ? void 0 : close(), onSubmit: (selectedUsers) => {
                setUsers(lodash_1.default.sortedUniqBy(lodash_1.default.sortBy([...users, ...selectedUsers], 'id'), 'id'));
                setAddUserOpen(false);
            }, listProps: {
                visibleColumns: ['avatar', 'staticDisplayName'],
                users: visibleAddUsers,
            }, commandBarProps: {
                visibleColumns: [],
                items: addUserCommandItems,
            } }),
        react_2.default.createElement(react_1.SearchBox, { placeholder: "Search members...", onChange: (event, newValue) => debouncedSearch(newValue) }),
        react_2.default.createElement(react_1.CommandBar, { className: styles.commandBar, items: commandActions, styles: { root: { padding: 0 } } }),
        react_2.default.createElement(user_list_1.default, { visibleColumns: ['avatar', 'staticDisplayName'], users: visibleUsers })));
};
exports.default = (0, hoc_1.composeWrappers)({
    usersContext: users_context_1.UsersContextProvider,
})(GroupMembers);
