"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const group_select_1 = __importDefault(require("./group-select"));
const back_panel_1 = __importDefault(require("../../../components/back-panel"));
const groups_context_1 = require("../context/groups.context");
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const hoc_1 = require("../../../helpers/hoc");
const GroupSelectPanel = (0, react_1.forwardRef)(({ panelProps = {}, listProps = { visibleColumns: ['id', 'name', 'description'] }, commandBarProps = { visibleColumns: ['refresh'] }, suppressDefaultUpdates = false, onDismiss, onSubmit, onBack, isOpen, }, ref) => {
    const groupsContext = (0, groups_context_1.useGroups)();
    const { selectedGroups } = groupsContext;
    (0, react_1.useImperativeHandle)(ref, () => ({
        groupsContext,
    }));
    const onRenderFooterContent = (0, react_1.useCallback)(() => (react_1.default.createElement(react_2.Stack, { horizontal: true, tokens: { childrenGap: 10 } },
        react_1.default.createElement(react_2.PrimaryButton, { disabled: selectedGroups.length === 0, onClick: () => onSubmit === null || onSubmit === void 0 ? void 0 : onSubmit(selectedGroups) }, "Select"),
        react_1.default.createElement(react_2.DefaultButton, { onClick: () => (onBack ? onBack === null || onBack === void 0 ? void 0 : onBack() : onDismiss === null || onDismiss === void 0 ? void 0 : onDismiss()) }, "Cancel"))), [selectedGroups, onSubmit, onDismiss]);
    return (react_1.default.createElement(back_panel_1.default, Object.assign({ title: "Select groups", isFooterAtBottom: true, onRenderFooterContent: onRenderFooterContent, onDismiss: onDismiss, onBack: onBack, type: react_2.PanelType.medium, isOpen: isOpen }, panelProps),
        react_1.default.createElement(group_select_1.default, { listProps: listProps, commandBarProps: commandBarProps, suppressDefaultUpdates: suppressDefaultUpdates, unwrap: true })));
});
exports.default = (0, hoc_1.composeWrappers)({
    groupsContext: groups_context_1.GroupsContextProvider,
})(GroupSelectPanel);
