"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useGroups = exports.GroupsContextProvider = void 0;
const react_1 = __importStar(require("react"));
const react_async_hook_1 = require("react-async-hook");
const react_2 = require("@fluentui/react");
const hooks_1 = require("../../../helpers/hooks");
const api_1 = __importStar(require("../../../helpers/api"));
const selection_1 = require("../../../helpers/selection");
const GroupsContext = (0, react_1.createContext)({});
const GroupsContextProvider = ({ children, defaultSelectedGroups = [], selectionMode = react_2.SelectionMode.multiple, }) => {
    const [selectedGroups, setSelectedGroups] = (0, react_1.useState)([]);
    const groupsModelState = (0, hooks_1.useModelState)([]);
    const selection = (0, selection_1.useSelection)({
        onSelectionChanged: () => {
            setSelectedGroups(selection.getSelection());
        },
        getKey: (group) => group.id,
        selectionMode,
        defaultSelectedItems: defaultSelectedGroups,
    });
    (0, react_1.useEffect)(() => {
        selection.setItems(groupsModelState.arrayState);
        setSelectedGroups(selection.getSelection());
    }, [groupsModelState.arrayState]);
    const get = (0, api_1.useApiCallback)((id) => __awaiter(void 0, void 0, void 0, function* () {
        return api_1.default.get(`/groups/${id}`, {
            params: {
                expand: 'users,users.meta',
            },
        });
    }));
    const list = (0, api_1.useApiCallback)(() => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.get('/groups');
        groupsModelState.setArrayState(response.data);
        return response;
    }));
    const create = (0, api_1.useApiCallback)((group) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.post(`/groups`, group);
        groupsModelState.create([response.data]);
        return response;
    }));
    const deleteOne = (0, api_1.useApiCallback)((id) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.delete(`/groups/${id}`);
        groupsModelState.delete([id]);
        return response;
    }));
    const deleteMany = (0, api_1.useApiCallback)((ids) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.delete(`/groups`, { data: { ids } });
        groupsModelState.delete(ids);
        return response;
    }));
    const update = (0, react_async_hook_1.useAsyncCallback)((group) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.put(`/groups/${group.id}`, group);
        groupsModelState.update([response.data]);
        return response;
    }));
    (0, react_1.useEffect)(() => {
        list.execute();
    }, []);
    return (react_1.default.createElement(GroupsContext.Provider, { value: {
            get,
            list,
            create,
            deleteOne,
            deleteMany,
            update,
            selection,
            selectedGroups,
            groups: groupsModelState.arrayState,
        } }, children));
};
exports.GroupsContextProvider = GroupsContextProvider;
const useGroups = () => (0, react_1.useContext)(GroupsContext);
exports.useGroups = useGroups;
