"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const permissions_context_1 = require("../context/permissions.context");
const react_2 = require("@fluentui/react");
const hoc_1 = require("../../../helpers/hoc");
const PermissionSelect = (0, react_1.forwardRef)(({}, ref) => {
    var _a;
    const permissionsContext = (0, permissions_context_1.usePermissions)();
    const { selection } = permissionsContext;
    (0, react_1.useImperativeHandle)(ref, () => ({
        permissionsContext,
    }), [permissionsContext.selectedPermissions]);
    const listGroups = (0, react_1.useMemo)(() => {
        if (!permissionsContext.list.result)
            return [];
        const groups = [];
        let childIterator = 0;
        permissionsContext.list.result.forEach((permission) => {
            groups.push({
                key: permission.id,
                name: permission.name,
                startIndex: childIterator,
                level: 0,
                count: permission.children.length,
                isCollapsed: true,
            });
            childIterator += permission.children.length;
        });
        return groups;
    }, [permissionsContext.list.result]);
    const permissionsList = (0, react_1.useMemo)(() => {
        var _a, _b, _c;
        return (_c = (_b = (_a = permissionsContext.list.result) === null || _a === void 0 ? void 0 : _a.flatMap) === null || _b === void 0 ? void 0 : _b.call(_a, ({ children }) => children)) !== null && _c !== void 0 ? _c : [];
    }, [permissionsContext.list.result]);
    const columns = (0, react_1.useMemo)(() => [
        {
            minWidth: 240,
            maxWidth: 240,
            fieldName: 'name',
            name: 'Usage',
            key: 'name',
        },
        {
            minWidth: 120,
            fieldName: 'id',
            name: 'Value',
            key: 'value',
        },
    ], []);
    return (react_1.default.createElement("div", { "data-cy": "permissions-select" },
        react_1.default.createElement(react_2.MarqueeSelection, { selection: selection, isDraggingConstrainedToRoot: true },
            react_1.default.createElement(react_2.ShimmeredDetailsList, { enableShimmer: (_a = permissionsContext.list) === null || _a === void 0 ? void 0 : _a.loading, selection: selection, selectionMode: react_2.SelectionMode.multiple, setKey: "multiple", selectionPreservedOnEmptyClick: true, groups: listGroups, groupProps: { isAllGroupsCollapsed: true }, items: permissionsList, columns: columns }))));
});
exports.default = (0, hoc_1.composeWrappers)({
    permissionsContext: permissions_context_1.PermissionsContextProvider,
})(PermissionSelect);
