"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermissionsContextProvider = exports.usePermissions = exports.PermissionsContext = void 0;
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const api_1 = __importStar(require("../../../helpers/api"));
const selection_1 = require("../../../helpers/selection");
const lodash_1 = __importDefault(require("lodash"));
exports.PermissionsContext = (0, react_2.createContext)({});
const PermissionsContextProvider = ({ children, defaultSelectedPermissions = [], selectionMode = react_1.SelectionMode.multiple, }) => {
    const [selectedPermissions, setSelectedPermissions] = (0, react_2.useState)([]);
    const selection = (0, selection_1.useSelection)({
        getKey: (permission) => permission.id,
        onSelectionChanged: () => {
            setSelectedPermissions(selection.getSelection());
        },
        defaultSelectedItems: defaultSelectedPermissions,
        selectionMode,
    });
    const list = (0, api_1.useApiCallback)(() => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.get('/permissions');
        selection.setItems(lodash_1.default.flatten(lodash_1.default.map(response.data, 'children')));
        return response;
    }));
    return (react_2.default.createElement(exports.PermissionsContext.Provider, { value: {
            list,
            selection,
            selectedPermissions,
        } }, children));
};
exports.PermissionsContextProvider = PermissionsContextProvider;
const usePermissions = () => (0, react_2.useContext)(exports.PermissionsContext);
exports.usePermissions = usePermissions;
