"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const rhf_components_1 = require("../../../components/rhf-components");
const content_types_context_1 = require("../../content-types/context/content-types.context");
const posts_context_1 = require("../context/posts.context");
const hoc_1 = require("../../../helpers/hoc");
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const slugify_1 = __importDefault(require("slugify"));
const validators_1 = require("../../../../shared/validators");
const SelectParentImpl = ({ control }) => {
    const { getPosts } = (0, posts_context_1.usePosts)();
    const pages = (0, react_2.useMemo)(() => {
        return [
            {
                key: null,
                text: '-- None --',
            },
            ...((getPosts === null || getPosts === void 0 ? void 0 : getPosts.result) || []).map((page) => ({
                key: page.id,
                text: `${page.name} (${page.slug})`,
            })),
        ];
    }, [getPosts === null || getPosts === void 0 ? void 0 : getPosts.result]);
    (0, react_2.useEffect)(() => {
        getPosts.execute({
            type: 'page,folder,fragment',
        });
    }, []);
    return (react_2.default.createElement(rhf_components_1.ControlledDropdown, { disabled: getPosts === null || getPosts === void 0 ? void 0 : getPosts.loading, name: "parentId", label: "Parent", placeHolder: "Select parent", control: control, defaultValue: null, options: pages }));
};
const SelectParent = (0, hoc_1.composeWrappers)({
    postsContext: posts_context_1.PostsContextProvider,
})(SelectParentImpl);
const FragmentCreateDialog = ({ isOpen, defaultValues, onDismiss, onCreated, }) => {
    var _a, _b;
    const { createPost } = (0, posts_context_1.usePosts)();
    const { getContentTypes } = (0, content_types_context_1.useContentTypes)();
    const { control, handleSubmit, reset, formState, watch, setValue } = (0, react_hook_form_1.useForm)({
        mode: 'all',
    });
    (0, react_2.useEffect)(() => {
        var _a;
        if (!((_a = formState === null || formState === void 0 ? void 0 : formState.dirtyFields) === null || _a === void 0 ? void 0 : _a.slug) && watch('name')) {
            const parsed = (0, slugify_1.default)(watch('name'), {
                replacement: '-',
                remove: undefined,
                lower: true,
            });
            setValue('slug', parsed);
        }
    }, [watch('name')]);
    (0, react_2.useEffect)(() => {
        createPost.reset();
        reset(defaultValues);
        if (isOpen) {
            getContentTypes.execute({
                type: 'fragment',
            });
        }
    }, [isOpen]);
    (0, react_2.useEffect)(() => {
        if (isOpen && (createPost === null || createPost === void 0 ? void 0 : createPost.result)) {
            onCreated(createPost === null || createPost === void 0 ? void 0 : createPost.result);
        }
    }, [createPost === null || createPost === void 0 ? void 0 : createPost.result]);
    const submit = handleSubmit((data) => {
        createPost.execute(Object.assign(Object.assign({}, data), { type: 'fragment' }));
    });
    return (react_2.default.createElement(react_1.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_1.DialogType.close,
            title: 'Create fragment',
        }, modalProps: {
            styles: { main: { maxWidth: 500 } },
        } },
        react_2.default.createElement("form", { onSubmit: submit },
            react_2.default.createElement(react_1.Stack, { tokens: {
                    childrenGap: 8,
                } },
                ((_a = createPost.error) === null || _a === void 0 ? void 0 : _a.message) && (react_2.default.createElement(react_1.MessageBar, { messageBarType: react_1.MessageBarType.error }, createPost.error.message)),
                react_2.default.createElement(rhf_components_1.ControlledTextField, { rules: {
                        required: 'Name is required',
                    }, name: "name", label: "Name", control: control }),
                react_2.default.createElement(rhf_components_1.ControlledTextField, { name: "slug", label: "Slug", control: control, rules: {
                        required: 'Slug is required',
                        pattern: {
                            value: validators_1.slugRegex,
                            message: validators_1.slugRegexMessage,
                        }
                    } }),
                react_2.default.createElement(rhf_components_1.ControlledDropdown, { disabled: getContentTypes === null || getContentTypes === void 0 ? void 0 : getContentTypes.loading, name: "contentTypeId", label: "Content Type", control: control, rules: {
                        required: 'Content type is required',
                    }, placeHolder: "Select Content Type", options: ((_b = getContentTypes === null || getContentTypes === void 0 ? void 0 : getContentTypes.result) !== null && _b !== void 0 ? _b : []).map((contentType) => ({
                        key: contentType.id,
                        text: contentType.name,
                    })) }),
                react_2.default.createElement(SelectParent, { control: control })),
            react_2.default.createElement(react_1.DialogFooter, null,
                react_2.default.createElement(react_1.DefaultButton, { onClick: onDismiss, text: "Cancel" }),
                react_2.default.createElement(react_1.PrimaryButton, { type: "submit", text: "Create", disabled: (createPost === null || createPost === void 0 ? void 0 : createPost.loading) || (getContentTypes === null || getContentTypes === void 0 ? void 0 : getContentTypes.loading) })))));
};
exports.default = (0, hoc_1.composeWrappers)({
    contentTypesContext: content_types_context_1.ContentTypesContextProvider,
})(FragmentCreateDialog);
