"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const rhf_components_1 = require("../../../components/rhf-components");
const snackbar_1 = require("../../../context/snackbar");
const posts_context_1 = require("../context/posts.context");
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const PostPublishDialog = ({ isOpen, onDismiss, onUpdated, title, posts, disableRecursive }) => {
    var _a;
    const { publishPosts } = (0, posts_context_1.usePosts)();
    const { openSnackbar } = (0, snackbar_1.useSnackbar)();
    const { control, handleSubmit, reset } = (0, react_hook_form_1.useForm)({
        mode: 'all',
        defaultValues: {
            recursive: false
        }
    });
    const [scheduleEnabled, setScheduleEnabled] = (0, react_2.useState)(false);
    (0, react_2.useEffect)(() => {
        publishPosts.reset();
        if (isOpen) {
            setScheduleEnabled(false);
            reset({
                recursive: false
            });
        }
    }, [isOpen]);
    (0, react_2.useEffect)(() => {
        if ((publishPosts === null || publishPosts === void 0 ? void 0 : publishPosts.result) && isOpen) {
            onUpdated(publishPosts === null || publishPosts === void 0 ? void 0 : publishPosts.result);
            openSnackbar({
                message: 'Post(s) published',
                messageBarType: react_1.MessageBarType.success
            });
        }
    }, [publishPosts === null || publishPosts === void 0 ? void 0 : publishPosts.result]);
    return (react_2.default.createElement(react_1.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_1.DialogType.close,
            title: title || 'Publish post(s)'
        }, modalProps: {
            styles: { main: { maxWidth: 450 } }
        } },
        react_2.default.createElement(react_1.Stack, { tokens: {
                childrenGap: 8
            } },
            ((_a = publishPosts.error) === null || _a === void 0 ? void 0 : _a.message) && (react_2.default.createElement(react_1.MessageBar, { messageBarType: react_1.MessageBarType.error }, publishPosts.error.message)),
            !disableRecursive && react_2.default.createElement(rhf_components_1.ControlledCheckbox, { control: control, name: 'recursive', label: 'Include children' }),
            react_2.default.createElement(react_1.Checkbox, { onChange: (e, val) => {
                    setScheduleEnabled(val);
                }, checked: scheduleEnabled, name: 'schedule', label: 'Schedule at date' }),
            scheduleEnabled && (react_2.default.createElement(rhf_components_1.ControlledDatePicker, { control: control, label: 'Published from', name: 'publishedFrom' })),
            scheduleEnabled && (react_2.default.createElement(rhf_components_1.ControlledDatePicker, { control: control, label: 'Published until', name: 'publishedUntil' }))),
        react_2.default.createElement(react_1.DialogFooter, null,
            react_2.default.createElement(react_1.DefaultButton, { onClick: onDismiss, "data-cy": "dialog-cancel", text: 'Cancel' }),
            react_2.default.createElement(react_1.PrimaryButton, { onClick: () => {
                    handleSubmit((data) => {
                        publishPosts.execute(Object.assign(Object.assign({}, (data || {})), { publish: true, ids: posts.map(post => post.id) }));
                    })();
                }, text: 'Publish', disabled: publishPosts === null || publishPosts === void 0 ? void 0 : publishPosts.loading, "data-cy": "dialog-confirm" }))));
};
exports.default = PostPublishDialog;
