"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const rhf_components_1 = require("../../../components/rhf-components");
const snackbar_1 = require("../../../context/snackbar");
const posts_context_1 = require("../context/posts.context");
const tags_picker_control_1 = __importDefault(require("../../tags/components/tags-picker-control"));
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const validators_1 = require("../../../../shared/validators");
const PostSettingsDialog = ({ isOpen, onDismiss, onUpdated, post, }) => {
    var _a;
    const { updatePost } = (0, posts_context_1.usePosts)();
    const { openSnackbar } = (0, snackbar_1.useSnackbar)();
    const { control, handleSubmit, reset } = (0, react_hook_form_1.useForm)({
        mode: 'all',
    });
    (0, react_2.useEffect)(() => {
        updatePost.reset();
        if (isOpen) {
            reset({
                name: post === null || post === void 0 ? void 0 : post.name,
                slug: post === null || post === void 0 ? void 0 : post.slug,
                tags: post === null || post === void 0 ? void 0 : post.tags,
            });
        }
    }, [isOpen]);
    (0, react_2.useEffect)(() => {
        if ((updatePost === null || updatePost === void 0 ? void 0 : updatePost.result) && isOpen) {
            onUpdated(updatePost === null || updatePost === void 0 ? void 0 : updatePost.result);
            openSnackbar({
                message: 'Post updated',
                messageBarType: react_1.MessageBarType.success,
            });
        }
    }, [updatePost === null || updatePost === void 0 ? void 0 : updatePost.result]);
    const submit = handleSubmit((data) => {
        updatePost.execute(post === null || post === void 0 ? void 0 : post.id, data);
    });
    return (react_2.default.createElement(react_1.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_1.DialogType.close,
            title: 'Update post',
        }, modalProps: {
            styles: { main: { maxWidth: 450 } },
        } },
        react_2.default.createElement("form", { onSubmit: submit },
            react_2.default.createElement(react_1.Stack, { tokens: {
                    childrenGap: 8,
                } },
                ((_a = updatePost.error) === null || _a === void 0 ? void 0 : _a.message) && (react_2.default.createElement(react_1.MessageBar, { messageBarType: react_1.MessageBarType.error }, updatePost.error.message)),
                react_2.default.createElement(rhf_components_1.ControlledTextField, { rules: {
                        required: 'Name is required',
                    }, name: "name", label: "Name", control: control }),
                react_2.default.createElement(rhf_components_1.ControlledTextField, { name: "slug", label: "Slug", control: control, rules: {
                        required: 'Slug is required',
                        pattern: {
                            value: validators_1.slugRegex,
                            message: validators_1.slugRegexMessage,
                        }
                    } }),
                react_2.default.createElement(tags_picker_control_1.default, { label: "Tags", name: "tags", control: control })),
            react_2.default.createElement(react_1.DialogFooter, null,
                react_2.default.createElement(react_1.DefaultButton, { onClick: onDismiss, text: "Cancel" }),
                react_2.default.createElement(react_1.PrimaryButton, { type: "submit", text: "Update", disabled: updatePost === null || updatePost === void 0 ? void 0 : updatePost.loading })))));
};
exports.default = PostSettingsDialog;
