"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const posts_context_1 = require("../context/posts.context");
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const PostVersionsRestoreDialog = ({ isOpen, post, onDismiss, onRestored, }) => {
    const { restoreVersion, selectedPosts } = (0, posts_context_1.usePosts)();
    (0, react_2.useEffect)(() => {
        restoreVersion.reset();
    }, [isOpen]);
    (0, react_2.useEffect)(() => {
        if (restoreVersion === null || restoreVersion === void 0 ? void 0 : restoreVersion.result) {
            onRestored();
        }
    }, [restoreVersion === null || restoreVersion === void 0 ? void 0 : restoreVersion.result]);
    return (react_2.default.createElement(react_1.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_1.DialogType.close,
            title: 'Restore?',
        }, modalProps: {
            styles: { main: { maxWidth: 450 } },
        } },
        "Are you sure you would like to restore selected version?",
        react_2.default.createElement(react_1.DialogFooter, null,
            react_2.default.createElement(react_1.DefaultButton, { onClick: onDismiss, text: "Cancel" }),
            react_2.default.createElement(react_1.PrimaryButton, { onClick: () => {
                    var _a, _b;
                    restoreVersion.execute((post === null || post === void 0 ? void 0 : post.id) || ((_a = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _a === void 0 ? void 0 : _a.parentId), (post === null || post === void 0 ? void 0 : post.versionId) || ((_b = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _b === void 0 ? void 0 : _b.id));
                }, text: "Restore", disabled: restoreVersion === null || restoreVersion === void 0 ? void 0 : restoreVersion.loading }))));
};
exports.default = PostVersionsRestoreDialog;
