"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const react_router_1 = require("react-router");
const use_debounce_1 = require("use-debounce");
const auth_context_1 = require("../../authentication/context/auth.context");
const posts_context_1 = require("../context/posts.context");
const utility_1 = require("../../../helpers/utility");
const snackbar_1 = require("../../../context/snackbar");
const hooks_1 = require("../../../helpers/hooks");
const PostsCommandBar = () => {
    const history = (0, react_router_1.useHistory)();
    const { filterPermissions } = (0, auth_context_1.useAuth)();
    const snackbar = (0, snackbar_1.useSnackbar)();
    const { selectedPosts, getPosts, params, setParams, stateData, setStateData, additionalData, } = (0, posts_context_1.usePosts)();
    const allowedPaths = (0, hooks_1.useAllowedPaths)();
    const debounced = (0, use_debounce_1.useDebouncedCallback)((val) => __awaiter(void 0, void 0, void 0, function* () {
        setParams(Object.assign(Object.assign({}, (params || {})), { search: val }));
        getPosts.execute(Object.assign(Object.assign({}, params), { search: val }));
    }), 500);
    const commandItems = (0, react_2.useMemo)(() => {
        var _a, _b;
        const commandBarItems = [];
        if (additionalData === null || additionalData === void 0 ? void 0 : additionalData.parentId) {
            commandBarItems.push({
                key: 'back',
                text: 'Back',
                iconProps: { iconName: 'Back' },
                onClick: () => {
                    history.push(`/sites?id=${additionalData === null || additionalData === void 0 ? void 0 : additionalData.parentId}`);
                }
            });
        }
        commandBarItems.push(...filterPermissions([
            {
                key: 'newItem',
                text: 'New',
                'data-cy': 'post-commandBar-new',
                iconProps: { iconName: 'Add' },
                permissions: ['sites_create'],
                onClick: () => {
                    setStateData('createPostOpen', true);
                },
            },
            (0, utility_1.testPaths)(allowedPaths, (_a = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _a === void 0 ? void 0 : _a.slugPath) ? {
                key: 'edit',
                text: 'Edit',
                disabled: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) !== 1,
                iconProps: { iconName: 'Edit' },
                split: true,
                permissions: ['sites_update'],
                subMenuProps: {
                    items: [
                        {
                            key: 'preview',
                            text: 'Preview',
                            onClick: () => {
                                var _a;
                                history.push(`/sites/editor/${(_a = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _a === void 0 ? void 0 : _a.id}?editor=preview`);
                            },
                        },
                    ],
                },
                onClick: () => {
                    var _a;
                    history.push(`/sites/editor/${(_a = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _a === void 0 ? void 0 : _a.id}`);
                },
            } : {
                key: 'edit',
                text: 'Edit',
                disabled: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) !== 1,
                iconProps: { iconName: 'Edit' },
                permissions: ['sites_update'],
                onClick: () => {
                    var _a;
                    history.push(`/sites/editor/${(_a = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _a === void 0 ? void 0 : _a.id}`);
                },
            },
            {
                key: 'settings',
                text: 'Settings',
                'data-cy': 'post-commandBar-settings',
                disabled: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) !== 1 || ((_b = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _b === void 0 ? void 0 : _b.type) === 'site',
                iconProps: { iconName: 'Settings' },
                permissions: ['sites_update'],
                onClick: () => {
                    setStateData('updatePostOpen', true);
                },
            },
            {
                key: 'copyItem',
                text: 'Duplicate',
                'data-cy': 'post-commandBar-duplicate',
                disabled: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) !== 1,
                iconProps: { iconName: 'Copy' },
                permissions: ['sites_create'],
                onClick: () => {
                    setStateData('copyPostsOpen', true);
                },
            },
            {
                key: 'delete',
                text: 'Delete',
                'data-cy': 'post-commandBar-delete',
                disabled: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) === 0,
                iconProps: { iconName: 'Delete' },
                permissions: ['sites_delete'],
                onClick: () => {
                    setStateData('deletePostsOpen', true);
                },
            },
            {
                key: 'publish',
                text: 'Publish',
                'data-cy': 'post-commandBar-publish',
                disabled: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) === 0,
                iconProps: { iconName: 'WebPublish' },
                permissions: ['sites_publish'],
                onClick: () => {
                    setStateData('publishPostOpen', true);
                },
            },
            {
                key: 'unpublish',
                text: 'Unpublish',
                'data-cy': 'post-commandBar-unpublish',
                disabled: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) === 0,
                iconProps: { iconName: 'UnpublishContent' },
                permissions: ['sites_publish'],
                onClick: () => {
                    setStateData('unpublishPostOpen', true);
                },
            },
            {
                key: 'copyUrl',
                text: 'Copy API URL',
                iconProps: { iconName: 'ClipboardList' },
                disabled: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) === 0,
                onClick: () => {
                    const [selectedPost] = selectedPosts;
                    (0, utility_1.copyToClipboard)(`${window.location.origin}/api/content/${selectedPost.slugPath}`);
                    snackbar.openSnackbar({
                        message: 'Successfully copied URL to clipboard!',
                        messageBarType: react_1.MessageBarType.success,
                        duration: 1000,
                    });
                },
            },
            {
                key: 'refresh',
                text: 'Refresh',
                'data-cy': 'post-commandBar-refresh',
                iconProps: { iconName: 'Refresh' },
                onClick: () => {
                    getPosts.execute(params);
                },
            },
        ]));
        return commandBarItems;
    }, [selectedPosts, params, stateData, additionalData]);
    const farToolbarItems = (0, react_2.useMemo)(() => [
        {
            key: 'search',
            onRenderIcon: () => (react_2.default.createElement(react_1.SearchBox, { placeholder: "Search posts...", onChange: (event, newValue) => {
                    debounced(newValue);
                } })),
        },
    ], []);
    return (react_2.default.createElement(react_1.CommandBar, { items: commandItems, style: { borderBottom: `1px solid ${react_1.NeutralColors.gray30}` }, farItems: farToolbarItems }));
};
exports.default = PostsCommandBar;
