"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const posts_context_1 = require("../context/posts.context");
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const PostsDeleteDialog = ({ isOpen, onDismiss, onDeleted, }) => {
    var _a;
    const { deletePosts, selectedPosts, getOneContentType } = (0, posts_context_1.usePosts)();
    (0, react_2.useEffect)(() => {
        deletePosts.reset();
    }, [isOpen]);
    (0, react_2.useEffect)(() => {
        if (deletePosts === null || deletePosts === void 0 ? void 0 : deletePosts.result) {
            onDeleted();
        }
    }, [deletePosts === null || deletePosts === void 0 ? void 0 : deletePosts.result]);
    return (react_2.default.createElement(react_1.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_1.DialogType.close,
            title: 'Delete?',
        }, modalProps: {
            styles: { main: { maxWidth: 450 } },
        } },
        `Are you sure you would like to delete selected ${(_a = getOneContentType === null || getOneContentType === void 0 ? void 0 : getOneContentType.result) === null || _a === void 0 ? void 0 : _a.name}?`,
        react_2.default.createElement(react_1.DialogFooter, null,
            react_2.default.createElement(react_1.DefaultButton, { onClick: onDismiss, "data-cy": "dialog-cancel", text: "Cancel" }),
            react_2.default.createElement(react_1.PrimaryButton, { "data-cy": "dialog-confirm", onClick: () => {
                    deletePosts.execute(selectedPosts.map((post) => post.id));
                }, text: "Delete", disabled: deletePosts === null || deletePosts === void 0 ? void 0 : deletePosts.loading }))));
};
exports.default = PostsDeleteDialog;
