"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const hoc_1 = require("../../../helpers/hoc");
const posts_context_1 = require("../context/posts.context");
const use_debounce_1 = require("use-debounce");
const PostsSelectPanel = ({ isOpen, onDismiss, onSubmit, selectionMode, params, }) => {
    const { getPosts, params: searchParams, setParams, selectedPosts, selection, } = (0, posts_context_1.usePosts)();
    const debounced = (0, use_debounce_1.useDebouncedCallback)((val) => __awaiter(void 0, void 0, void 0, function* () {
        setParams(Object.assign(Object.assign({}, (searchParams || {})), { search: val }));
        getPosts.execute(Object.assign(Object.assign({}, (searchParams || {})), { search: val }));
    }), 500);
    (0, react_1.useEffect)(() => {
        if (isOpen) {
            setParams(params);
            getPosts.execute(params);
        }
    }, [isOpen]);
    const Footer = (0, react_1.useCallback)(() => (react_1.default.createElement(react_2.Stack, { horizontal: true, tokens: { childrenGap: 10 } },
        react_1.default.createElement(react_2.PrimaryButton, { disabled: !((selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) > 0), onClick: () => {
                onSubmit(selectedPosts);
            } }, "Select"),
        react_1.default.createElement(react_2.DefaultButton, { onClick: onDismiss }, "Cancel"))), [isOpen, selectedPosts]);
    const columns = (0, react_1.useMemo)(() => [
        {
            key: 'name',
            name: 'Name',
            fieldName: 'name',
            minWidth: 100,
            isPadded: true,
        },
        {
            key: 'slugPath',
            name: 'Path',
            fieldName: 'slugPath',
            minWidth: 200,
            isPadded: true,
        },
        {
            key: 'contentType',
            name: 'Content Type',
            onRender: ({ contentType }) => react_1.default.createElement("div", null, contentType === null || contentType === void 0 ? void 0 : contentType.name),
            minWidth: 100,
            data: 'string',
            isPadded: true,
        },
    ], []);
    return (react_1.default.createElement(react_2.Panel, { isOpen: isOpen, headerText: "Select posts", isFooterAtBottom: true, onRenderFooterContent: Footer, onDismiss: onDismiss, type: react_2.PanelType.medium },
        react_1.default.createElement(react_2.SearchBox, { placeholder: "Search posts...", onChange: (_event, newValue) => {
                debounced(newValue);
            } }),
        react_1.default.createElement(react_2.ShimmeredDetailsList, { setKey: "items", items: (getPosts === null || getPosts === void 0 ? void 0 : getPosts.result) || [], columns: columns, selectionMode: selectionMode, selection: selection, enableShimmer: getPosts.loading, ariaLabelForShimmer: "Posts are being fetched", ariaLabelForGrid: "Item details" })));
};
exports.default = (0, hoc_1.composeWrappers)({
    postsContext: posts_context_1.PostsContextProvider,
})(PostsSelectPanel);
