"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const hoc_1 = require("../../../helpers/hoc");
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const use_debounce_1 = require("use-debounce");
const posts_context_1 = require("../context/posts.context");
const columns_1 = __importDefault(require("../../../components/columns"));
const sites_list_1 = __importDefault(require("./sites-list"));
const SitesSelectDialog = ({ isOpen, post, onDismiss, onSelected }) => {
    var _a, _b;
    const { getPosts, postsState, selectedPosts, params, setParams, selection, posts } = (0, posts_context_1.usePosts)();
    (0, react_2.useEffect)(() => {
        postsState.setArrayState([]);
        getPosts.reset();
        setParams({
            search: ''
        });
        if (isOpen) {
            getPosts.execute({
                type: 'folder,page,fragment'
            });
        }
    }, [isOpen]);
    const debounced = (0, use_debounce_1.useDebouncedCallback)((val) => __awaiter(void 0, void 0, void 0, function* () {
        setParams({
            search: val
        });
        getPosts.execute({
            type: 'folder,page,fragment',
            search: val
        });
    }), 500);
    const farToolbarItems = (0, react_2.useMemo)(() => [
        {
            key: 'search',
            onRenderIcon: () => (react_2.default.createElement(react_1.SearchBox, { placeholder: 'Search posts...', onChange: (_event, newValue) => {
                    debounced(newValue);
                } }))
        }
    ], []);
    return (react_2.default.createElement(react_1.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_1.DialogType.close,
            title: 'Select items'
        }, maxWidth: '90vw' },
        react_2.default.createElement("div", { style: {
                height: 400,
                maxHeight: '80vh',
                width: 800,
                maxWidth: '80vw',
                overflow: 'auto'
            } },
            react_2.default.createElement(react_1.CommandBar, { items: [], style: { borderBottom: `1px solid ${react_1.NeutralColors.gray30}` }, farItems: farToolbarItems }),
            react_2.default.createElement("div", { style: { height: 'calc(100% - 45px)', display: 'flex', flexDirection: 'row' } },
                react_2.default.createElement("div", { style: { flex: 1, overflow: 'auto' } },
                    !((_a = params === null || params === void 0 ? void 0 : params.search) === null || _a === void 0 ? void 0 : _a.length) && react_2.default.createElement(columns_1.default, { loading: getPosts === null || getPosts === void 0 ? void 0 : getPosts.loading, selection: selection, sort: (a, b) => {
                            if (!(a === null || a === void 0 ? void 0 : a.updatedAt) || !(b === null || b === void 0 ? void 0 : b.updatedAt))
                                return 0;
                            return (new Date(b.updatedAt)).getTime() - (new Date(a.updatedAt)).getTime();
                        }, defaultSelected: [parseInt(`${post === null || post === void 0 ? void 0 : post.parentId}`, 10)], items: (posts || []).map((item) => {
                            let iconName;
                            switch (item.type) {
                                case 'folder':
                                    iconName = 'FolderHorizontal';
                                    break;
                                case 'fragment':
                                    iconName = 'WebAppBuilderFragment';
                                    break;
                                case 'hierarchical_post':
                                    iconName = 'ArrangeBringToFront';
                                    break;
                                default:
                                    iconName = 'Page';
                                    break;
                            }
                            return Object.assign(Object.assign({}, item), { title: item === null || item === void 0 ? void 0 : item.name, helper: item === null || item === void 0 ? void 0 : item.slug, key: item.id, iconProps: {
                                    iconName
                                } });
                        }) }),
                    ((_b = params === null || params === void 0 ? void 0 : params.search) === null || _b === void 0 ? void 0 : _b.length) > 0 && react_2.default.createElement(sites_list_1.default, null)))),
        react_2.default.createElement(react_1.DialogFooter, null,
            react_2.default.createElement(react_1.DefaultButton, { onClick: onDismiss, text: 'Cancel' }),
            react_2.default.createElement(react_1.PrimaryButton, { onClick: () => {
                    onSelected(selectedPosts);
                }, text: 'Select', disabled: (getPosts === null || getPosts === void 0 ? void 0 : getPosts.loading) || (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) > 1 }))));
};
exports.default = (0, hoc_1.composeWrappers)({
    postsContext: posts_context_1.PostsContextProvider
})(SitesSelectDialog);
