"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const heading_1 = __importDefault(require("../../../components/heading"));
const hoc_1 = require("../../../helpers/hoc");
const react_1 = __importStar(require("react"));
const react_router_1 = require("react-router");
const posts_command_bar_1 = __importDefault(require("../components/posts-command-bar"));
const posts_delete_dialog_1 = __importDefault(require("../components/posts-delete-dialog"));
const posts_list_1 = __importDefault(require("../components/posts-list"));
const post_create_dialog_1 = __importDefault(require("../components/post-create-dialog"));
const posts_context_1 = require("../context/posts.context");
const post_settings_dialog_1 = __importDefault(require("../components/post-settings-dialog"));
const post_duplicate_dialog_1 = __importDefault(require("../components/post-duplicate-dialog"));
const post_publish_dialog_1 = __importDefault(require("../components/post-publish-dialog"));
const post_unpublish_dialog_1 = __importDefault(require("../components/post-unpublish-dialog"));
const PostContainerPage = () => {
    var _a;
    const params = (0, react_router_1.useParams)();
    const _b = (0, posts_context_1.usePosts)(), { getPost, getPosts, getOneContentType, selectedPosts, params: searchParams, setParams, stateData, setStateData } = _b, postsState = __rest(_b, ["getPost", "getPosts", "getOneContentType", "selectedPosts", "params", "setParams", "stateData", "setStateData"]);
    (0, react_1.useEffect)(() => {
        (() => __awaiter(void 0, void 0, void 0, function* () {
            const parentId = params === null || params === void 0 ? void 0 : params.postId;
            postsState.setAdditionalData({ parentId });
            setParams(Object.assign(Object.assign({}, (searchParams || {})), { type: 'post', parentId }));
            getPosts.execute({
                type: 'post',
                parentId,
            });
            const parent = yield getPost.execute(params === null || params === void 0 ? void 0 : params.postId);
            const postContentTypeId = parseInt(parent.meta.postContentTypeId, 10);
            getOneContentType.execute(postContentTypeId);
        }))();
    }, [params === null || params === void 0 ? void 0 : params.parentId]);
    return (react_1.default.createElement("div", { className: "page-wrapper" },
        react_1.default.createElement(posts_command_bar_1.default, null),
        react_1.default.createElement("div", { className: "page-content page-content-scroll", style: { padding: '0 1rem' } },
            react_1.default.createElement(heading_1.default, { loading: getOneContentType.loading, title: (_a = getOneContentType === null || getOneContentType === void 0 ? void 0 : getOneContentType.result) === null || _a === void 0 ? void 0 : _a.name }),
            react_1.default.createElement(posts_list_1.default, null)),
        react_1.default.createElement(post_create_dialog_1.default, { isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.createPostOpen, onCreated: () => {
                setStateData('createPostOpen', false);
            }, onDismiss: () => setStateData('createPostOpen', false) }),
        react_1.default.createElement(posts_delete_dialog_1.default, { isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.deletePostsOpen, onDeleted: () => {
                setStateData('deletePostsOpen', false);
            }, onDismiss: () => setStateData('deletePostsOpen', false) }),
        react_1.default.createElement(post_settings_dialog_1.default, { onDismiss: () => setStateData('updatePostOpen', false), onUpdated: () => {
                setStateData('updatePostOpen', false);
            }, isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.updatePostOpen, post: selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0] }),
        react_1.default.createElement(post_duplicate_dialog_1.default, { onDismiss: () => setStateData('copyPostsOpen', false), onCreated: () => {
                setStateData('copyPostsOpen', false);
            }, isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.copyPostsOpen, post: selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0] }),
        react_1.default.createElement(post_publish_dialog_1.default, { onDismiss: () => setStateData('publishPostOpen', false), onUpdated: () => {
                setStateData('publishPostOpen', false);
                getPosts.execute(params);
            }, disableRecursive: true, isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.publishPostOpen, posts: selectedPosts }),
        react_1.default.createElement(post_unpublish_dialog_1.default, { onDismiss: () => setStateData('unpublishPostOpen', false), onUpdated: () => {
                setStateData('unpublishPostOpen', false);
                getPosts.execute(params);
            }, disableRecursive: true, isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.unpublishPostOpen, posts: selectedPosts })));
};
exports.default = (0, hoc_1.composeWrappers)({
    postsContext: posts_context_1.PostsContextProvider,
})(PostContainerPage);
