"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const heading_1 = __importDefault(require("../../../components/heading"));
const hoc_1 = require("../../../helpers/hoc");
const react_1 = __importStar(require("react"));
const columns_1 = __importDefault(require("../../../components/columns"));
const react_2 = require("@fluentui/react");
const query_string_1 = __importDefault(require("query-string"));
const react_router_1 = require("react-router");
const posts_context_1 = require("../context/posts.context");
const page_create_dialog_1 = __importDefault(require("../components/page-create-dialog"));
const folder_create_dialog_1 = __importDefault(require("../components/folder-create-dialog"));
const fragment_create_dialog_1 = __importDefault(require("../components/fragment-create-dialog"));
const post_details_1 = __importDefault(require("../components/post-details"));
const sites_command_bar_1 = __importDefault(require("../components/sites-command-bar"));
const sites_list_1 = __importDefault(require("../components/sites-list"));
const sites_delete_dialog_1 = __importDefault(require("../components/sites-delete-dialog"));
const post_settings_dialog_1 = __importDefault(require("../components/post-settings-dialog"));
const sites_copy_dialog_1 = __importDefault(require("../components/sites-copy-dialog"));
const post_publish_dialog_1 = __importDefault(require("../components/post-publish-dialog"));
const post_unpublish_dialog_1 = __importDefault(require("../components/post-unpublish-dialog"));
const hierarchical_post_create_dialog_1 = __importDefault(require("../components/hierarchical-post-create-dialog"));
const theme = (0, react_2.getTheme)();
const styles = (0, react_2.mergeStyleSets)({
    mainWrapper: {
        display: 'flex',
        flexFlow: 'row nowrap',
        alignItems: 'flex-start',
        width: '100%',
        height: '100%',
        boxSizing: 'border-box',
        overflow: 'hidden',
    },
    content: {
        flexGrow: 1,
        height: '100%',
        overflowY: 'auto',
        position: 'relative',
        padding: '0 24px',
    },
    side: {
        maxWidth: 270,
        minWidth: 270,
        flexGrow: 1,
        height: '100%',
        overflowY: 'auto',
        boxShadow: theme.effects.elevation16,
    },
    cardHeading: {
        padding: '0 14px',
        boxShadow: theme.effects.elevation4,
        display: 'flex',
        position: 'relative',
        height: 44,
        alignItems: 'center',
    },
});
const SitesPage = () => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    const { getPosts, posts, params, selection, selectedPosts, stateData, setStateData, } = (0, posts_context_1.usePosts)();
    const [selectedPost, setSelectedPost] = (0, react_1.useState)();
    const history = (0, react_router_1.useHistory)();
    const location = (0, react_router_1.useLocation)();
    (0, react_1.useEffect)(() => {
        getPosts.execute({
            type: 'page,folder,fragment,hierarchical_post',
        });
        const search = query_string_1.default.parse(location.search);
        setSelectedPost(search === null || search === void 0 ? void 0 : search.id);
    }, []);
    (0, react_1.useEffect)(() => {
        var _a, _b;
        if ((selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) > 1) {
            history.push({
                search: query_string_1.default.stringify({ id: (_a = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _a === void 0 ? void 0 : _a.parentId }),
            });
        }
        else if ((selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) === 1) {
            history.push({
                search: query_string_1.default.stringify({ id: (_b = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _b === void 0 ? void 0 : _b.id }),
            });
        }
    }, [selectedPosts]);
    return (react_1.default.createElement("div", { className: "page-wrapper" },
        react_1.default.createElement(sites_command_bar_1.default, null),
        react_1.default.createElement("div", { className: "page-content page-content-scroll", style: {
                display: 'flex',
                flexDirection: 'column',
                height: 'calc(100% - 45px)',
            } },
            react_1.default.createElement("div", { className: styles.mainWrapper },
                react_1.default.createElement("div", { className: styles.content },
                    react_1.default.createElement(heading_1.default, { title: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) === 1
                            ? `Sites: ${(_a = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _a === void 0 ? void 0 : _a.slugPath}`
                            : 'Sites' }),
                    react_1.default.createElement("div", { style: { flex: 1, height: 'calc(100% - 60px)' } },
                        !((_b = params === null || params === void 0 ? void 0 : params.search) === null || _b === void 0 ? void 0 : _b.length) && (react_1.default.createElement(columns_1.default, { loading: getPosts === null || getPosts === void 0 ? void 0 : getPosts.loading, defaultSelected: [parseInt(selectedPost, 10)], selection: selection, sort: (a, b) => {
                                if (!(a === null || a === void 0 ? void 0 : a.updatedAt) || !(b === null || b === void 0 ? void 0 : b.updatedAt))
                                    return 0;
                                return (new Date(b.updatedAt)).getTime() - (new Date(a.updatedAt)).getTime();
                            }, items: (posts || []).map((item) => {
                                let iconName;
                                switch (item.type) {
                                    case 'folder':
                                        iconName = 'FolderHorizontal';
                                        break;
                                    case 'fragment':
                                        iconName = 'WebAppBuilderFragment';
                                        break;
                                    case 'hierarchical_post':
                                        iconName = 'ArrangeBringToFront';
                                        break;
                                    default:
                                        iconName = 'Page';
                                        break;
                                }
                                return Object.assign(Object.assign({}, item), { actionType: 'sites', title: item === null || item === void 0 ? void 0 : item.name, helper: item === null || item === void 0 ? void 0 : item.slug, key: item.id, opacity: (item === null || item === void 0 ? void 0 : item.status) === 'published' ? 1 : 0.45, iconProps: {
                                        iconName,
                                    } });
                            }) })),
                        ((_c = params === null || params === void 0 ? void 0 : params.search) === null || _c === void 0 ? void 0 : _c.length) > 0 && react_1.default.createElement(sites_list_1.default, null))),
                react_1.default.createElement("div", { className: styles.side },
                    react_1.default.createElement("div", { className: styles.cardHeading }, getPosts.loading ? (react_1.default.createElement(react_2.Shimmer, { width: 50, shimmerElements: [
                            { type: react_2.ShimmerElementType.line, height: 8 },
                        ], style: {} })) : ((selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) === 1 && 'Details')),
                    react_1.default.createElement("div", { style: { padding: 24 } }, (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) === 1 && (react_1.default.createElement(post_details_1.default, { loading: getPosts.loading, post: selectedPosts[0] })))))),
        react_1.default.createElement(page_create_dialog_1.default, { isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.createPageOpen, defaultValues: {
                parentId: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) === 1 ? (_d = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _d === void 0 ? void 0 : _d.id : undefined,
                contentType: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) === 1
                    ? (_e = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _e === void 0 ? void 0 : _e.contentTypeId
                    : undefined,
            }, onCreated: () => {
                setStateData('createPageOpen', false);
            }, onDismiss: () => setStateData('createPageOpen', false) }),
        react_1.default.createElement(fragment_create_dialog_1.default, { isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.createFragmentOpen, defaultValues: {
                parentId: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) === 1 ? (_f = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _f === void 0 ? void 0 : _f.id : undefined,
                contentType: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) === 1
                    ? (_g = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _g === void 0 ? void 0 : _g.contentTypeId
                    : undefined,
            }, onCreated: () => {
                setStateData('createFragmentOpen', false);
            }, onDismiss: () => setStateData('createFragmentOpen', false) }),
        react_1.default.createElement(folder_create_dialog_1.default, { isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.createFolderOpen, defaultValues: {
                parentId: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) === 1 ? (_h = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _h === void 0 ? void 0 : _h.id : undefined,
            }, onCreated: () => {
                setStateData('createFolderOpen', false);
            }, onDismiss: () => setStateData('createFolderOpen', false) }),
        react_1.default.createElement(hierarchical_post_create_dialog_1.default, { isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.createPostContainerOpen, defaultValues: {
                parentId: (selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts.length) === 1 ? (_j = selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0]) === null || _j === void 0 ? void 0 : _j.id : undefined,
            }, onCreated: () => {
                setStateData('createPostContainerOpen', false);
            }, onDismiss: () => {
                setStateData('createPostContainerOpen', false);
            } }),
        react_1.default.createElement(sites_delete_dialog_1.default, { isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.deletePostsOpen, onDeleted: () => {
                setStateData('deletePostsOpen', false);
            }, onDismiss: () => setStateData('deletePostsOpen', false) }),
        react_1.default.createElement(post_settings_dialog_1.default, { onDismiss: () => setStateData('updatePostOpen', false), onUpdated: () => {
                setStateData('updatePostOpen', false);
                getPosts.execute(Object.assign({ type: 'page,folder,fragment,hierarchical_post' }, (params || {})));
            }, isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.updatePostOpen, post: selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0] }),
        react_1.default.createElement(sites_copy_dialog_1.default, { onDismiss: () => setStateData('copyPostsOpen', false), onCreated: () => {
                setStateData('copyPostsOpen', false);
                getPosts.execute(Object.assign({ type: 'page,folder,fragment,hierarchical_post' }, (params || {})));
            }, isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.copyPostsOpen, post: selectedPosts === null || selectedPosts === void 0 ? void 0 : selectedPosts[0] }),
        react_1.default.createElement(post_publish_dialog_1.default, { onDismiss: () => setStateData('publishPostOpen', false), onUpdated: () => {
                setStateData('publishPostOpen', false);
                getPosts.execute(Object.assign({ type: 'page,folder,fragment,hierarchical_post' }, (params || {})));
            }, isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.publishPostOpen, posts: selectedPosts }),
        react_1.default.createElement(post_unpublish_dialog_1.default, { onDismiss: () => setStateData('unpublishPostOpen', false), onUpdated: () => {
                setStateData('unpublishPostOpen', false);
                getPosts.execute(Object.assign({ type: 'page,folder,fragment,hierarchical_post' }, (params || {})));
            }, isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.unpublishPostOpen, posts: selectedPosts })));
};
exports.default = (0, hoc_1.composeWrappers)({
    postsContext: posts_context_1.PostsContextProvider,
})(SitesPage);
