"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const groups_tab_1 = __importDefault(require("../tabs/groups.tab"));
const react_router_1 = require("react-router");
const general_tab_1 = __importDefault(require("../tabs/general.tab"));
const hooks_1 = __importDefault(require("../../../../shared/features/hooks"));
const auth_context_1 = require("../../authentication/context/auth.context");
const error_boundary_1 = __importDefault(require("../../../components/error-boundary"));
const backup_tab_1 = __importDefault(require("../tabs/backup.tab"));
const api_tab_1 = __importDefault(require("../tabs/api.tab"));
const preview_tab_1 = __importDefault(require("../tabs/preview.tab"));
const Settings = () => {
    var _a;
    const history = (0, react_router_1.useHistory)();
    const { params } = (0, react_router_1.useRouteMatch)('/settings/:id?');
    const { filterPermissions } = (0, auth_context_1.useAuth)();
    const items = (0, react_2.useMemo)(() => {
        const predefined = [
            {
                key: 'general',
                name: 'General',
                permissions: ['settings'],
                component: general_tab_1.default
            },
            {
                key: 'backups',
                name: 'Backups',
                permissions: ['all'],
                component: backup_tab_1.default,
            },
            {
                key: 'groups',
                name: 'Groups',
                permissions: ['users_administration'],
                component: groups_tab_1.default
            },
            {
                key: 'api',
                name: 'Api & Security',
                permissions: ['all'],
                component: api_tab_1.default
            },
            {
                key: 'preview-editor',
                name: 'Preview Editor',
                permissions: ['all'],
                component: preview_tab_1.default
            }
        ];
        return filterPermissions(hooks_1.default.applySyncFilters('admin/settings/tabs', predefined));
    }, []);
    return (react_2.default.createElement("div", { style: { padding: '1rem 2rem' } },
        react_2.default.createElement(react_1.Pivot, { "aria-label": 'Settings pivot', selectedKey: (_a = params === null || params === void 0 ? void 0 : params.id) !== null && _a !== void 0 ? _a : 'general', onLinkClick: (item) => history.push(`/settings/${item.props.itemKey}`) }, items.map((item) => (react_2.default.createElement(react_1.PivotItem, { key: item.key, headerText: item.name, itemKey: item.key },
            react_2.default.createElement(error_boundary_1.default, { message: `Page ${item.name} errored. Please check console for more details.` }, (item === null || item === void 0 ? void 0 : item.component) && react_2.default.createElement(item.component, null))))))));
};
exports.default = Settings;
