"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const group_list_1 = __importDefault(require("../../groups/components/group-list"));
const group_command_bar_1 = __importDefault(require("../../groups/components/group-command-bar"));
const heading_1 = __importDefault(require("../../../components/heading"));
const group_add_1 = __importDefault(require("../../groups/components/group-add"));
const permissions_context_1 = require("../../permissions/context/permissions.context");
const group_edit_1 = __importDefault(require("../../groups/components/group-edit"));
const react_router_1 = require("react-router");
const hoc_1 = require("../../../helpers/hoc");
const groups_context_1 = require("../../groups/context/groups.context");
const GroupSettings = () => {
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(heading_1.default, { title: "Groups" }, "Manage your group settings. Protected groups are provided by the system and cannot be edited."),
        react_1.default.createElement("div", null,
            react_1.default.createElement(group_command_bar_1.default, null),
            react_1.default.createElement(group_list_1.default, null),
            react_1.default.createElement(permissions_context_1.PermissionsContextProvider, null,
                react_1.default.createElement(react_router_1.Route, { path: "/settings/groups/add", component: group_add_1.default }),
                react_1.default.createElement(react_router_1.Route, { path: "/settings/groups/edit/:id", component: group_edit_1.default })))));
};
exports.default = (0, hoc_1.composeWrappers)({
    groupsContext: groups_context_1.GroupsContextProvider,
})(GroupSettings);
