"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const rhf_components_1 = require("../../../components/rhf-components");
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const tags_context_1 = require("../context/tags.context");
const slugify_1 = __importDefault(require("slugify"));
const validators_1 = require("../../../../shared/validators");
const TagCreateDialog = ({ isOpen, defaultValues, onDismiss, onCreated, }) => {
    var _a, _b;
    const { createTag, selectedTags } = (0, tags_context_1.useTags)();
    const { control, handleSubmit, reset, formState, watch, setValue } = (0, react_hook_form_1.useForm)({
        mode: 'all',
    });
    (0, react_2.useEffect)(() => {
        var _a;
        if (!((_a = formState === null || formState === void 0 ? void 0 : formState.dirtyFields) === null || _a === void 0 ? void 0 : _a.slug) && watch('name')) {
            const parsed = (0, slugify_1.default)(watch('name'), {
                replacement: '-',
                remove: undefined,
                lower: true,
            });
            setValue('slug', parsed);
        }
    }, [watch('name')]);
    (0, react_2.useEffect)(() => {
        createTag.reset();
        reset(defaultValues);
    }, [isOpen]);
    (0, react_2.useEffect)(() => {
        if (createTag === null || createTag === void 0 ? void 0 : createTag.result) {
            onCreated(createTag === null || createTag === void 0 ? void 0 : createTag.result);
        }
    }, [createTag === null || createTag === void 0 ? void 0 : createTag.result]);
    const submit = handleSubmit((data) => {
        var _a;
        createTag.execute(Object.assign(Object.assign({}, data), { parentId: (_a = selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags[0]) === null || _a === void 0 ? void 0 : _a.id }));
    });
    return (react_2.default.createElement(react_1.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_1.DialogType.close,
            title: !((_a = selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags[0]) === null || _a === void 0 ? void 0 : _a.id) ? 'Create namespace' : 'Create tag',
        }, modalProps: {
            styles: { main: { maxWidth: 500 } },
        } },
        react_2.default.createElement("form", { onSubmit: submit },
            react_2.default.createElement(react_1.Stack, { tokens: {
                    childrenGap: 8,
                } },
                ((_b = createTag.error) === null || _b === void 0 ? void 0 : _b.message) && (react_2.default.createElement(react_1.MessageBar, { messageBarType: react_1.MessageBarType.error }, createTag.error.message)),
                react_2.default.createElement(rhf_components_1.ControlledTextField, { rules: {
                        required: 'Name is required',
                    }, name: "name", label: "Name", control: control, "data-cy": "tags-create-name", autoFocus: true, autoComplete: "off" }),
                react_2.default.createElement(rhf_components_1.ControlledTextField, { name: "slug", label: "Slug", control: control, rules: {
                        required: 'Slug is required',
                        pattern: {
                            value: validators_1.slugRegex,
                            message: validators_1.slugRegexMessage,
                        }
                    }, "data-cy": "tags-create-slug" })),
            react_2.default.createElement(react_1.DialogFooter, null,
                react_2.default.createElement(react_1.DefaultButton, { onClick: onDismiss, text: "Cancel" }),
                react_2.default.createElement(react_1.PrimaryButton, { type: "submit", text: "Create", disabled: createTag === null || createTag === void 0 ? void 0 : createTag.loading, "data-cy": "tags-create-submit" })))));
};
exports.default = TagCreateDialog;
