"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importDefault(require("react"));
const styles = (0, react_1.mergeStyleSets)({
    itemHeading: {
        fontWeight: '600',
    },
    ellipsis: {
        whiteSpace: 'nowrap',
        overflow: 'hidden',
        textOverflow: 'ellipsis',
    },
    contentType: {
        textDecoration: 'underline',
        '&:hover': {
            cursor: 'pointer',
        },
    },
    shimmer: {
        width: '100%',
    },
});
const TagDetails = ({ tag, loading }) => {
    var _a, _b;
    const shimmerList = [1, 0.8, 0.6, 0.4];
    return (react_2.default.createElement(react_2.default.Fragment, null,
        loading && (react_2.default.createElement(react_1.Stack, { tokens: { childrenGap: 10 } }, shimmerList.map((item) => (react_2.default.createElement(react_1.Stack, null,
            react_2.default.createElement(react_1.Shimmer, { width: "100%", shimmerElements: [
                    { type: react_1.ShimmerElementType.line, height: 12 },
                ], className: styles.shimmer, style: {
                    marginBottom: 8,
                    opacity: item,
                } }),
            react_2.default.createElement(react_1.Shimmer, { width: "100%", shimmerElements: [
                    { type: react_1.ShimmerElementType.line, height: 12 },
                ], className: styles.shimmer, style: {
                    marginBottom: 6,
                    opacity: item,
                } })))))),
        !loading && (react_2.default.createElement(react_1.Stack, { tokens: { childrenGap: 10 } },
            react_2.default.createElement(react_1.Stack, null,
                react_2.default.createElement(react_1.Text, { className: styles.itemHeading, variant: "medium", block: true }, "Name"),
                react_2.default.createElement(react_1.Text, { variant: "medium", block: true, "data-cy": "tags-details-name" }, tag === null || tag === void 0 ? void 0 : tag.name)),
            react_2.default.createElement(react_1.Stack, null,
                react_2.default.createElement(react_1.Text, { className: styles.itemHeading, variant: "medium" }, "Slug"),
                react_2.default.createElement(react_1.Text, { variant: "medium", block: true, "data-cy": "tags-details-slug" }, tag === null || tag === void 0 ? void 0 : tag.slug)),
            react_2.default.createElement(react_1.Stack, null,
                react_2.default.createElement(react_1.Text, { className: styles.itemHeading, variant: "medium", block: true }, "Last Update"),
                react_2.default.createElement(react_1.Text, { variant: "medium", className: styles.ellipsis, block: true }, (tag === null || tag === void 0 ? void 0 : tag.updatedAt) &&
                    new Date(tag === null || tag === void 0 ? void 0 : tag.updatedAt).toLocaleDateString([], {
                        hour: '2-digit',
                        minute: '2-digit',
                        hour12: false,
                    }))),
            react_2.default.createElement(react_1.Stack, null,
                react_2.default.createElement(react_1.Text, { className: styles.itemHeading, variant: "medium", block: true }, "Updated by"),
                react_2.default.createElement(react_1.Text, { variant: "medium", block: true, className: styles.ellipsis, "data-cy": "tags-details-author" }, (_a = tag === null || tag === void 0 ? void 0 : tag.author) === null || _a === void 0 ? void 0 :
                    _a.firstName,
                    " ", (_b = tag === null || tag === void 0 ? void 0 : tag.author) === null || _b === void 0 ? void 0 :
                    _b.lastName))))));
};
exports.default = TagDetails;
