"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const rhf_components_1 = require("../../../components/rhf-components");
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const tags_context_1 = require("../context/tags.context");
const validators_1 = require("../../../../shared/validators");
const TagUpdateDialog = ({ isOpen, onDismiss, onUpdated, }) => {
    var _a, _b;
    const { updateTag, selectedTags } = (0, tags_context_1.useTags)();
    const { control, handleSubmit, reset } = (0, react_hook_form_1.useForm)({
        mode: 'all',
    });
    (0, react_2.useEffect)(() => {
        var _a, _b;
        if (isOpen) {
            updateTag.reset();
            reset({
                slug: (_a = selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags[0]) === null || _a === void 0 ? void 0 : _a.slug,
                name: (_b = selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags[0]) === null || _b === void 0 ? void 0 : _b.name,
            });
        }
    }, [isOpen]);
    (0, react_2.useEffect)(() => {
        if (updateTag === null || updateTag === void 0 ? void 0 : updateTag.result) {
            onUpdated(updateTag === null || updateTag === void 0 ? void 0 : updateTag.result);
        }
    }, [updateTag === null || updateTag === void 0 ? void 0 : updateTag.result]);
    const submit = handleSubmit((data) => {
        var _a;
        updateTag.execute((_a = selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags[0]) === null || _a === void 0 ? void 0 : _a.id, data);
    });
    return (react_2.default.createElement(react_1.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_1.DialogType.close,
            title: `Update ${(_a = selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags[0]) === null || _a === void 0 ? void 0 : _a.name}`,
        }, modalProps: {
            styles: { main: { maxWidth: 500 } },
        } },
        react_2.default.createElement("form", { onSubmit: submit },
            react_2.default.createElement(react_1.Stack, { tokens: {
                    childrenGap: 8,
                } },
                ((_b = updateTag.error) === null || _b === void 0 ? void 0 : _b.message) && (react_2.default.createElement(react_1.MessageBar, { messageBarType: react_1.MessageBarType.error }, updateTag.error.message)),
                react_2.default.createElement(rhf_components_1.ControlledTextField, { rules: {
                        required: 'Name is required',
                    }, name: "name", label: "Name", control: control, "data-cy": "tags-update-name", autoFocus: true }),
                react_2.default.createElement(rhf_components_1.ControlledTextField, { name: "slug", label: "Slug", control: control, rules: {
                        required: 'Slug is required',
                        pattern: {
                            value: validators_1.slugRegex,
                            message: validators_1.slugRegexMessage,
                        }
                    }, "data-cy": "tags-update-slug" })),
            react_2.default.createElement(react_1.DialogFooter, null,
                react_2.default.createElement(react_1.DefaultButton, { onClick: onDismiss, text: "Cancel" }),
                react_2.default.createElement(react_1.PrimaryButton, { type: "submit", text: "Update", disabled: updateTag === null || updateTag === void 0 ? void 0 : updateTag.loading, "data-cy": "tags-update-submit" })))));
};
exports.default = TagUpdateDialog;
