"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const columns_1 = __importDefault(require("../../../components/columns"));
const react_1 = __importDefault(require("react"));
const tags_context_1 = require("../context/tags.context");
const TagsColumns = ({ selectedTags }) => {
    const { getTags, tags, selection } = (0, tags_context_1.useTags)();
    return (react_1.default.createElement(columns_1.default, { defaultSelected: selectedTags, loading: getTags === null || getTags === void 0 ? void 0 : getTags.loading, selection: selection, sort: (a, b) => {
            if (!(a === null || a === void 0 ? void 0 : a.updatedAt) || !(b === null || b === void 0 ? void 0 : b.updatedAt))
                return 0;
            return (new Date(b.updatedAt)).getTime() - (new Date(a.updatedAt)).getTime();
        }, items: (tags || []).map((item) => (Object.assign(Object.assign({}, item), { title: item === null || item === void 0 ? void 0 : item.name, helper: item === null || item === void 0 ? void 0 : item.slug, key: item.id, iconProps: {
                iconName: 'Tag',
            } }))) }));
};
exports.default = TagsColumns;
