"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const use_debounce_1 = require("use-debounce");
const tags_context_1 = require("../context/tags.context");
const auth_context_1 = require("../../authentication/context/auth.context");
const TagsCommandBar = () => {
    const { selectedTags, getTags, params, setParams, stateData, setStateData, } = (0, tags_context_1.useTags)();
    const { filterPermissions } = (0, auth_context_1.useAuth)();
    const debounced = (0, use_debounce_1.useDebouncedCallback)((val) => __awaiter(void 0, void 0, void 0, function* () {
        setParams({
            search: val,
        });
        getTags.execute({
            search: val,
        });
    }), 500);
    const commandItems = (0, react_2.useMemo)(() => filterPermissions([
        {
            key: 'newItem',
            text: 'New',
            'data-cy': 'tags-commandBar-new',
            iconProps: { iconName: 'Add' },
            permissions: ['tags_create'],
            onClick: () => {
                setStateData('createTagOpen', true);
            },
        },
        {
            key: 'update',
            text: 'Update',
            'data-cy': 'tags-commandBar-update',
            disabled: (selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags.length) !== 1,
            iconProps: { iconName: 'Edit' },
            permissions: ['tags_update'],
            onClick: () => {
                setStateData('updateTagOpen', true);
            },
        },
        {
            key: 'delete',
            text: 'Delete',
            'data-cy': 'tags-commandBar-delete',
            disabled: (selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags.length) === 0,
            iconProps: { iconName: 'Delete' },
            permissions: ['tags_delete'],
            onClick: () => {
                setStateData('deleteTagsOpen', true);
            },
        },
        {
            key: 'refresh',
            text: 'Refresh',
            'data-cy': 'tags-commandBar-refresh',
            iconProps: { iconName: 'Refresh' },
            onClick: () => {
                getTags.execute(params);
            },
        },
    ]), [selectedTags, params, stateData]);
    const farToolbarItems = (0, react_2.useMemo)(() => [
        {
            key: 'search',
            onRenderIcon: () => (react_2.default.createElement(react_1.SearchBox, { placeholder: "Search tags...", onChange: (event, newValue) => {
                    debounced(newValue);
                } })),
        },
    ], []);
    return (react_2.default.createElement(react_1.CommandBar, { items: commandItems, style: { borderBottom: `1px solid ${react_1.NeutralColors.gray30}` }, farItems: farToolbarItems }));
};
exports.default = TagsCommandBar;
