"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const tags_context_1 = require("../context/tags.context");
const TagsDeleteDialog = ({ isOpen, onDismiss, onDeleted, }) => {
    const { deleteTags, selectedTags } = (0, tags_context_1.useTags)();
    (0, react_2.useEffect)(() => {
        deleteTags.reset();
    }, [isOpen]);
    (0, react_2.useEffect)(() => {
        if (deleteTags === null || deleteTags === void 0 ? void 0 : deleteTags.result) {
            onDeleted(deleteTags === null || deleteTags === void 0 ? void 0 : deleteTags.result);
        }
    }, [deleteTags === null || deleteTags === void 0 ? void 0 : deleteTags.result]);
    return (react_2.default.createElement(react_1.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_1.DialogType.close,
            title: 'Delete?',
        }, modalProps: {
            styles: { main: { maxWidth: 450 } },
        } },
        "Are you sure you would like to delete selected tags?",
        react_2.default.createElement(react_1.DialogFooter, null,
            react_2.default.createElement(react_1.DefaultButton, { "data-cy": "dialog-cancel", onClick: onDismiss, text: "Cancel" }),
            react_2.default.createElement(react_1.PrimaryButton, { onClick: () => {
                    deleteTags.execute(selectedTags.map((tag) => tag.id));
                }, text: "Delete", "data-cy": "dialog-confirm", disabled: deleteTags === null || deleteTags === void 0 ? void 0 : deleteTags.loading }))));
};
exports.default = TagsDeleteDialog;
