"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const empty_1 = __importDefault(require("../../../components/empty"));
const tags_context_1 = require("../context/tags.context");
const TagsList = () => {
    var _a;
    const { getTags, tags, selection, params } = (0, tags_context_1.useTags)();
    const columns = (0, react_1.useMemo)(() => [
        {
            key: 'name',
            name: 'Name',
            fieldName: 'name',
            minWidth: 210,
            isResizable: true,
            isRowHeader: true,
            data: 'string',
            onRender: (item) => {
                return react_1.default.createElement("span", null, item.name);
            },
            isPadded: true,
        },
        {
            key: 'path',
            name: 'Path',
            fieldName: 'path',
            minWidth: 210,
            isResizable: true,
            isRowHeader: true,
            data: 'string',
            onRender: (item) => {
                return react_1.default.createElement("span", null, item.slugPath);
            },
            isPadded: true,
        },
        {
            key: 'author',
            name: 'Author',
            fieldName: 'author',
            minWidth: 210,
            isResizable: true,
            isCollapsible: true,
            onRender: ({ author }) => {
                var _a;
                const obj = {};
                ((_a = author === null || author === void 0 ? void 0 : author.meta) !== null && _a !== void 0 ? _a : []).forEach((meta) => {
                    obj[meta === null || meta === void 0 ? void 0 : meta.key] = meta === null || meta === void 0 ? void 0 : meta.value;
                });
                return (react_1.default.createElement("span", null, obj === null || obj === void 0 ? void 0 :
                    obj.firstName,
                    " ", obj === null || obj === void 0 ? void 0 :
                    obj.lastName));
            },
        },
        {
            key: 'modifiedAt',
            name: 'Date Modified',
            fieldName: 'modifiedAt',
            minWidth: 100,
            maxWidth: 100,
            isResizable: true,
            data: 'number',
            onRender: ({ updatedAt }) => {
                return (react_1.default.createElement("span", null, new Date(updatedAt).toLocaleDateString([], {
                    hour: '2-digit',
                    minute: '2-digit',
                    hour12: false,
                })));
            },
            isPadded: true,
        },
    ], []);
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(react_2.MarqueeSelection, { selection: selection, isDraggingConstrainedToRoot: true },
            react_1.default.createElement(react_2.ShimmeredDetailsList, { items: tags || [], columns: columns, enableShimmer: getTags === null || getTags === void 0 ? void 0 : getTags.loading, selectionMode: react_2.SelectionMode.multiple, setKey: "multiple", layoutMode: react_2.DetailsListLayoutMode.justified, isHeaderVisible: true, selection: selection, selectionPreservedOnEmptyClick: true, ariaLabelForSelectionColumn: "Toggle selection", ariaLabelForSelectAllCheckbox: "Toggle selection for all items", checkButtonAriaLabel: "select row" })),
        !(getTags === null || getTags === void 0 ? void 0 : getTags.loading) &&
            (!tags || (tags === null || tags === void 0 ? void 0 : tags.length) === 0) &&
            (((_a = params === null || params === void 0 ? void 0 : params.search) === null || _a === void 0 ? void 0 : _a.length) > 0 ? (react_1.default.createElement(empty_1.default, { title: "No tags match search criteria" })) : (react_1.default.createElement(empty_1.default, { title: "No tags", image: "tags" })))));
};
exports.default = TagsList;
