"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const tags_context_1 = require("../context/tags.context");
const tags_picker_dialog_1 = __importDefault(require("./tags-picker-dialog"));
const pickerSuggestionsProps = {
    suggestionsHeaderText: 'Suggested tags',
    noResultsFoundText: 'No color tags found',
};
const TagsPickerControl = ({ control, label, name, }) => {
    const picker = react_2.default.useRef(null);
    const [tagsPickerOpened, setTagsPickerOpened] = (0, react_2.useState)(false);
    const { getTags, tags } = (0, tags_context_1.useTags)();
    (0, react_2.useEffect)(() => {
        getTags.execute();
    }, []);
    const getTextFromItem = (item) => `${item === null || item === void 0 ? void 0 : item.name} (${item === null || item === void 0 ? void 0 : item.slug})`;
    const listContainsTagList = (tag) => {
        if ((tags === null || tags === void 0 ? void 0 : tags.length) > 0) {
            return tags === null || tags === void 0 ? void 0 : tags.some((compareTag) => compareTag.id === tag.id);
        }
        return false;
    };
    const notInCurrentValues = (tag, values) => {
        return !values.find((val) => (val === null || val === void 0 ? void 0 : val.id) == (tag === null || tag === void 0 ? void 0 : tag.id));
    };
    const filterSelectedTags = (values) => (filterText) => {
        return filterText
            ? tags === null || tags === void 0 ? void 0 : tags.filter((tag) => {
                return (tag.parentId !== null &&
                    notInCurrentValues(tag, values) &&
                    (tag.name.toLowerCase().indexOf(filterText.toLowerCase()) > -1 ||
                        tag.slug.toLowerCase().indexOf(filterText.toLowerCase()) > -1));
            })
            : [];
    };
    const onItemSelected = (values) => (item) => {
        if (picker.current &&
            listContainsTagList(item) &&
            notInCurrentValues(item, values)) {
            return item;
        }
        return null;
    };
    return (react_2.default.createElement(react_2.default.Fragment, null,
        react_2.default.createElement(react_hook_form_1.Controller, { name: name, control: control, defaultValue: [], render: ({ field: { onChange, value } }) => (react_2.default.createElement("div", null,
                react_2.default.createElement("div", { style: {
                        display: 'flex',
                        justifyContent: 'space-between',
                        alignItems: 'center',
                    } },
                    react_2.default.createElement(react_1.Label, null, label),
                    react_2.default.createElement(react_1.ActionButton, { text: "Tag Selector", onClick: () => {
                            setTagsPickerOpened(true);
                        } })),
                react_2.default.createElement(react_1.TagPicker, { styles: {
                        root: {
                            marginTop: '0 !important',
                        },
                    }, onChange: (items) => {
                        onChange(items);
                    }, selectedItems: value, removeButtonAriaLabel: "Remove", selectionAriaLabel: "Selected tags", componentRef: picker, onResolveSuggestions: filterSelectedTags(value), onItemSelected: onItemSelected(value), getTextFromItem: getTextFromItem, pickerSuggestionsProps: pickerSuggestionsProps, disabled: false }),
                react_2.default.createElement(tags_picker_dialog_1.default, { onDismiss: () => setTagsPickerOpened(false), isOpen: tagsPickerOpened, disableNamespace: true, onSelected: (data) => {
                        const toAdd = (data || []).filter((item) => !(value || []).some((val) => (val === null || val === void 0 ? void 0 : val.id) == (item === null || item === void 0 ? void 0 : item.id)));
                        onChange([...(value || []), ...toAdd]);
                        getTags.execute();
                        setTagsPickerOpened(false);
                    } }))) })));
};
exports.default = (0, tags_context_1.withTagsContext)(TagsPickerControl);
