"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@fluentui/react");
const react_2 = __importStar(require("react"));
const use_debounce_1 = require("use-debounce");
const auth_context_1 = require("../../authentication/context/auth.context");
const tags_context_1 = require("../context/tags.context");
const tag_create_dialog_1 = __importDefault(require("./tag-create-dialog"));
const tags_columns_1 = __importDefault(require("./tags-columns"));
const tags_list_1 = __importDefault(require("./tags-list"));
const TagsPickerDialog = ({ isOpen, onDismiss, onSelected, disableNamespace, }) => {
    var _a, _b;
    const { getTags, tagsState, selectedTags, params, setParams, stateData, setStateData, } = (0, tags_context_1.useTags)();
    const { filterPermissions } = (0, auth_context_1.useAuth)();
    (0, react_2.useEffect)(() => {
        tagsState.setArrayState([]);
        getTags.reset();
        if (isOpen) {
            getTags.execute();
        }
    }, [isOpen]);
    const debounced = (0, use_debounce_1.useDebouncedCallback)((val) => __awaiter(void 0, void 0, void 0, function* () {
        setParams({
            search: val,
        });
        getTags.execute({
            search: val,
        });
    }), 500);
    const commandItems = (0, react_2.useMemo)(() => filterPermissions([
        {
            key: 'newItem',
            text: 'New',
            iconProps: { iconName: 'Add' },
            permissions: ['tags_create'],
            onClick: () => {
                setStateData('createTagOpen', true);
            },
        },
    ]), [selectedTags, params, stateData]);
    const farToolbarItems = (0, react_2.useMemo)(() => [
        {
            key: 'search',
            onRenderIcon: () => (react_2.default.createElement(react_1.SearchBox, { placeholder: "Search tags...", onChange: (_event, newValue) => {
                    debounced(newValue);
                } })),
        },
    ], []);
    return (react_2.default.createElement(react_1.Dialog, { hidden: !isOpen, onDismiss: onDismiss, dialogContentProps: {
            type: react_1.DialogType.close,
            title: 'Select tags',
        }, maxWidth: "90vw" },
        react_2.default.createElement("div", { style: {
                height: 400,
                maxHeight: '80vh',
                width: 800,
                maxWidth: '80vw',
                overflow: 'auto',
            } },
            react_2.default.createElement(react_1.CommandBar, { items: commandItems, style: { borderBottom: `1px solid ${react_1.NeutralColors.gray30}` }, farItems: farToolbarItems }),
            react_2.default.createElement("div", { style: { height: 'calc(100% - 45px)' } },
                !((_a = params === null || params === void 0 ? void 0 : params.search) === null || _a === void 0 ? void 0 : _a.length) && react_2.default.createElement(tags_columns_1.default, null),
                ((_b = params === null || params === void 0 ? void 0 : params.search) === null || _b === void 0 ? void 0 : _b.length) > 0 && react_2.default.createElement(tags_list_1.default, null))),
        react_2.default.createElement(tag_create_dialog_1.default, { isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.createTagOpen, onCreated: (tag) => {
                setStateData('createTagOpen', false);
                tagsState.create([tag]);
            }, onDismiss: () => setStateData('createTagOpen', false) }),
        react_2.default.createElement(react_1.DialogFooter, null,
            react_2.default.createElement(react_1.DefaultButton, { onClick: onDismiss, text: "Cancel" }),
            react_2.default.createElement(react_1.PrimaryButton, { onClick: () => {
                    if (onSelected) {
                        onSelected(selectedTags);
                    }
                }, text: "Select", disabled: (getTags === null || getTags === void 0 ? void 0 : getTags.loading) ||
                    (disableNamespace && (selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags.some((tag) => !tag.parentId))) }))));
};
exports.default = (0, tags_context_1.withTagsContext)(TagsPickerDialog);
