import React from 'react';
import { UseAsyncReturn } from 'react-async-hook';
import { Selection } from '@fluentui/react';
import { ITag } from '@shared/interfaces/model';
import { ModelState } from '@admin/helpers/hooks';
interface ITagsContext {
    selection: Selection<ITag>;
    getTags: UseAsyncReturn<ITag[], [params?: any]>;
    deleteTags: UseAsyncReturn<number[], [ids: any[]]>;
    createTag: UseAsyncReturn<ITag, [data?: any]>;
    updateTag: UseAsyncReturn<ITag, [id: number, data?: any]>;
    params: any;
    setParams: (params: any) => void;
    selectedTags: ITag[];
    tags: ITag[];
    tagsState: ModelState<ITag>;
    stateData: any;
    setStateData: (key: string, val: any) => void;
}
declare const TagsContextProvider: ({ children }: {
    children: any;
}) => JSX.Element;
declare const useTags: () => ITagsContext;
declare const withTagsContext: <T extends object>(Component: React.FC<T>) => (props: T) => JSX.Element;
export { useTags, TagsContextProvider, withTagsContext };
