"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withTagsContext = exports.TagsContextProvider = exports.useTags = void 0;
const react_1 = __importStar(require("react"));
const react_async_hook_1 = require("react-async-hook");
const react_2 = require("@fluentui/react");
const hoc_1 = require("../../../helpers/hoc");
const hooks_1 = require("../../../helpers/hooks");
const api_1 = __importStar(require("../../../helpers/api"));
const TagsContext = (0, react_1.createContext)({});
const TagsContextProvider = ({ children }) => {
    const [selectedTags, setSelectedTags] = (0, react_1.useState)([]);
    const tagsState = (0, hooks_1.useModelState)([], (a, b) => {
        if (!(a === null || a === void 0 ? void 0 : a.updatedAt) || !(b === null || b === void 0 ? void 0 : b.updatedAt))
            return 0;
        return (new Date(b.updatedAt)).getTime() - (new Date(a.updatedAt)).getTime();
    });
    const [params, setParams] = (0, react_1.useState)({});
    const [stateData, setStateDataImpl] = (0, react_1.useState)({});
    const setStateData = (key, value) => {
        setStateDataImpl(Object.assign(Object.assign({}, (stateData || {})), { [key]: value }));
    };
    const selection = (0, react_1.useMemo)(() => new react_2.Selection({
        onSelectionChanged: () => {
            setSelectedTags(selection.getSelection());
        },
        getKey: (tag) => tag.id,
    }), []);
    const getTags = (0, api_1.useApiCallback)((params) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.get('/tags', {
            params,
        });
        tagsState.setArrayState(response.data);
        return response;
    }));
    const createTag = (0, api_1.useApiCallback)((data) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.post('/tags', data);
        tagsState.create([response.data]);
        return response;
    }));
    const updateTag = (0, api_1.useApiCallback)((id, data) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.put(`/tags/${id}`, data);
        tagsState.update([response.data]);
        return response;
    }));
    const deleteTags = (0, react_async_hook_1.useAsyncCallback)((ids) => __awaiter(void 0, void 0, void 0, function* () {
        try {
            yield api_1.default.delete('/tags', { data: ids });
            tagsState.delete(ids);
            return ids;
        }
        catch (e) {
            throw e.response.data;
        }
    }));
    return (react_1.default.createElement(TagsContext.Provider, { value: {
            selection,
            selectedTags,
            getTags,
            createTag,
            deleteTags,
            updateTag,
            tags: tagsState.arrayState,
            tagsState,
            params,
            setParams,
            stateData,
            setStateData,
        } }, children));
};
exports.TagsContextProvider = TagsContextProvider;
const useTags = () => (0, react_1.useContext)(TagsContext);
exports.useTags = useTags;
const withTagsContext = (0, hoc_1.withWrapper)(TagsContextProvider);
exports.withTagsContext = withTagsContext;
