"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const heading_1 = __importDefault(require("../../../components/heading"));
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const query_string_1 = __importDefault(require("query-string"));
const react_router_1 = require("react-router");
const tags_context_1 = require("../context/tags.context");
const tags_command_bar_1 = __importDefault(require("../components/tags-command-bar"));
const tags_columns_1 = __importDefault(require("../components/tags-columns"));
const tags_list_1 = __importDefault(require("../components/tags-list"));
const tag_details_1 = __importDefault(require("../components/tag-details"));
const tag_create_dialog_1 = __importDefault(require("../components/tag-create-dialog"));
const tags_delete_dialog_1 = __importDefault(require("../components/tags-delete-dialog"));
const tag_update_dialog_1 = __importDefault(require("../components/tag-update-dialog"));
const theme = (0, react_2.getTheme)();
const styles = (0, react_2.mergeStyleSets)({
    mainWrapper: {
        display: 'flex',
        flexFlow: 'row nowrap',
        alignItems: 'flex-start',
        width: '100%',
        height: '100%',
        boxSizing: 'border-box',
        overflow: 'hidden',
    },
    content: {
        flexGrow: 1,
        height: '100%',
        overflowY: 'auto',
        position: 'relative',
        padding: '0 24px',
    },
    side: {
        maxWidth: 270,
        minWidth: 270,
        flexGrow: 1,
        height: '100%',
        overflowY: 'auto',
        boxShadow: theme.effects.elevation16,
    },
    cardHeading: {
        padding: '0 14px',
        boxShadow: theme.effects.elevation4,
        display: 'flex',
        position: 'relative',
        height: 44,
        alignItems: 'center',
    },
});
const TagsPage = () => {
    var _a, _b, _c;
    const { getTags, tagsState, params, selectedTags, stateData, setStateData } = (0, tags_context_1.useTags)();
    const [, setSelectedTag] = (0, react_1.useState)();
    const history = (0, react_router_1.useHistory)();
    const location = (0, react_router_1.useLocation)();
    (0, react_1.useEffect)(() => {
        getTags.execute();
        const search = query_string_1.default.parse(location.search);
        setSelectedTag(search === null || search === void 0 ? void 0 : search.id);
    }, []);
    (0, react_1.useEffect)(() => {
        var _a, _b;
        if ((selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags.length) > 1) {
            history.push({
                search: query_string_1.default.stringify({ id: (_a = selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags[0]) === null || _a === void 0 ? void 0 : _a.parentId }),
            });
        }
        else {
            history.push({
                search: query_string_1.default.stringify({ id: (_b = selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags[0]) === null || _b === void 0 ? void 0 : _b.id }),
            });
        }
    }, [selectedTags]);
    return (react_1.default.createElement("div", { className: "page-wrapper" },
        react_1.default.createElement(tags_command_bar_1.default, null),
        react_1.default.createElement("div", { className: "page-content page-content-scroll", style: {
                display: 'flex',
                flexDirection: 'column',
                height: 'calc(100% - 45px)',
            } },
            react_1.default.createElement("div", { className: styles.mainWrapper },
                react_1.default.createElement("div", { className: styles.content },
                    react_1.default.createElement(heading_1.default, { title: (selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags.length) === 1
                            ? `Tags: ${(_a = selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags[0]) === null || _a === void 0 ? void 0 : _a.slugPath}`
                            : 'Tags' }),
                    react_1.default.createElement("div", { style: { flex: 1, height: 'calc(100% - 60px)' } },
                        !((_b = params === null || params === void 0 ? void 0 : params.search) === null || _b === void 0 ? void 0 : _b.length) && react_1.default.createElement(tags_columns_1.default, null),
                        ((_c = params === null || params === void 0 ? void 0 : params.search) === null || _c === void 0 ? void 0 : _c.length) > 0 && react_1.default.createElement(tags_list_1.default, null))),
                react_1.default.createElement("div", { className: styles.side },
                    react_1.default.createElement("div", { className: styles.cardHeading }, getTags.loading ? (react_1.default.createElement(react_2.Shimmer, { width: 50, shimmerElements: [
                            { type: react_2.ShimmerElementType.line, height: 8 },
                        ], style: {} })) : ((selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags.length) === 1 && 'Details')),
                    react_1.default.createElement("div", { style: { padding: 24 } }, (selectedTags === null || selectedTags === void 0 ? void 0 : selectedTags.length) === 1 && (react_1.default.createElement(tag_details_1.default, { loading: getTags.loading, tag: selectedTags[0] })))))),
        react_1.default.createElement(tag_create_dialog_1.default, { isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.createTagOpen, onCreated: (tag) => {
                tagsState.create([tag]);
                setStateData('createTagOpen', false);
            }, onDismiss: () => setStateData('createTagOpen', false) }),
        react_1.default.createElement(tag_update_dialog_1.default, { isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.updateTagOpen, onUpdated: () => {
                getTags.execute();
                setStateData('updateTagOpen', false);
            }, onDismiss: () => setStateData('updateTagOpen', false) }),
        react_1.default.createElement(tags_delete_dialog_1.default, { isOpen: stateData === null || stateData === void 0 ? void 0 : stateData.deleteTagsOpen, onDeleted: (ids) => {
                tagsState.delete(ids);
                setStateData('deleteTagsOpen', false);
            }, onDismiss: () => setStateData('deleteTagsOpen', false) })));
};
exports.default = (0, tags_context_1.withTagsContext)(TagsPage);
