"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const react_router_1 = require("react-router");
const users_context_1 = require("../context/users.context");
const auth_context_1 = require("../../authentication/context/auth.context");
const dialog_1 = require("../../../context/dialog");
const model_1 = require("../../../../shared/interfaces/model");
const react_hooks_1 = require("@fluentui/react-hooks");
const UserCommandBar = (_a) => {
    var { visibleColumns = [
        'add',
        'edit',
        'activate',
        'deactivate',
        'delete',
        'refresh',
        'search',
    ] } = _a, props = __rest(_a, ["visibleColumns"]);
    const history = (0, react_router_1.useHistory)();
    const dialog = (0, dialog_1.useDialog)();
    const { updateMany, selectedUsers, deleteMany, list, setListParams, listParams, } = (0, users_context_1.useUsers)();
    const { user, filterPermissions } = (0, auth_context_1.useAuth)();
    const debouncedSearch = (0, react_hooks_1.useAsync)().debounce((search) => {
        setListParams(Object.assign(Object.assign({}, listParams), { search }));
    }, 300);
    const toolbarItems = (0, react_1.useMemo)(() => filterPermissions([
        {
            key: 'add',
            text: 'Add',
            permissions: ['users_administration'],
            'data-cy': 'users-commandBar-add',
            iconProps: {
                iconName: 'Add',
            },
            onClick: () => history.push('/users/add'),
        },
        {
            key: 'edit',
            text: 'Edit',
            'data-cy': 'users-commandBar-edit',
            iconProps: {
                iconName: 'Edit',
            },
            disabled: selectedUsers.length !== 1,
            onClick: () => {
                const [selectedUser] = selectedUsers;
                history.push(`/users/edit/${selectedUser.id}`);
            },
        },
        {
            key: 'activate',
            text: 'Activate',
            permissions: ['users_administration'],
            'data-cy': 'users-commandBar-activate',
            disabled: selectedUsers.length === 0 ||
                !selectedUsers.some((u) => u.status === 'disabled') ||
                selectedUsers.some((u) => u.id === user.id),
            onClick: () => __awaiter(void 0, void 0, void 0, function* () {
                try {
                    yield dialog.confirm('Activate Users', 'Are you sure you would like to proceed?');
                    yield updateMany.execute(selectedUsers.map(({ id }) => ({
                        id,
                        status: model_1.UserStatus.ACTIVE,
                    })));
                }
                catch (e) {
                    //
                }
            }),
            iconProps: {
                iconName: 'UserFollowed',
            },
        },
        {
            key: 'deactivate',
            text: 'Deactivate',
            permissions: ['users_administration'],
            'data-cy': 'users-commandBar-deactivate',
            disabled: selectedUsers.length === 0 ||
                !selectedUsers.some((u) => u.status === 'active') ||
                selectedUsers.some((u) => u.id === user.id),
            onClick: () => __awaiter(void 0, void 0, void 0, function* () {
                try {
                    dialog.confirm('Deactivate Users', 'Are you sure you would like to proceed?');
                    yield updateMany.execute(selectedUsers.map(({ id }) => ({
                        id,
                        status: model_1.UserStatus.DISABLED,
                    })));
                }
                catch (e) {
                    //
                }
            }),
            iconProps: {
                iconName: 'UserRemove',
            },
        },
        {
            key: 'delete',
            text: 'Delete',
            permissions: ['users_administration'],
            'data-cy': 'users-commandBar-delete',
            disabled: selectedUsers.length === 0 ||
                selectedUsers.some((u) => u.id === user.id),
            onClick: () => __awaiter(void 0, void 0, void 0, function* () {
                try {
                    yield dialog.confirm('Delete Users', 'Are you sure you would like to proceed?');
                    yield deleteMany.execute(selectedUsers.map(({ id }) => id));
                }
                catch (e) {
                    //
                }
            }),
            iconProps: {
                iconName: 'Delete',
            },
        },
        {
            key: 'refresh',
            text: 'Refresh',
            'data-cy': 'users-commandBar-refresh',
            iconProps: { iconName: 'Refresh' },
            onClick: () => {
                list.execute();
            },
        },
    ].filter(({ key }) => visibleColumns.includes(key))), [selectedUsers, user, visibleColumns]);
    const farToolbarItems = (0, react_1.useMemo)(() => filterPermissions([
        {
            key: 'search',
            permissions: ['users_administration'],
            'data-cy': 'users-commandBar-search',
            onRenderIcon: () => (react_1.default.createElement(react_2.SearchBox, { placeholder: "Search users...", onChange: (event, newValue) => debouncedSearch(newValue) })),
        },
    ].filter(({ key }) => visibleColumns.includes(key))), [visibleColumns]);
    return (react_1.default.createElement(react_2.CommandBar, Object.assign({ items: toolbarItems, farItems: farToolbarItems, style: { borderBottom: `1px solid ${react_2.NeutralColors.gray30}` } }, props)));
};
exports.default = UserCommandBar;
