"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const users_context_1 = require("../context/users.context");
const misc_1 = require("../../../helpers/misc");
const react_router_1 = require("react-router");
const links_1 = require("../../../components/links");
const useStyles = (0, react_2.makeStyles)({
    userList: {
        ':global(.ms-DetailsRow-fields)': {
            alignItems: 'center !important',
        },
        ':global(.ms-DetailsRow-check)': {
            height: '100% !important',
        },
    },
});
const UserList = (_a) => {
    var { visibleColumns = ['avatar', 'displayName', 'groups', 'status', 'createdAt'], users = undefined } = _a, props = __rest(_a, ["visibleColumns", "users"]);
    const styles = useStyles();
    const { list, selection, users: contextUsers } = (0, users_context_1.useUsers)();
    const history = (0, react_router_1.useHistory)();
    const listUsers = (0, react_1.useMemo)(() => users !== null && users !== void 0 ? users : contextUsers, [users, contextUsers]);
    const availableColumns = (0, react_1.useMemo)(() => [
        {
            key: 'avatar',
            name: 'Avatar',
            isIconOnly: true,
            iconName: 'Contact',
            minWidth: 32,
            maxWidth: 32,
            onRender: (userModel) => (react_1.default.createElement(react_2.Persona, { text: (0, misc_1.userPersonaText)(userModel), size: react_2.PersonaSize.size32 })),
            styles: {
                cellTitle: {
                    justifyContent: 'center',
                },
            },
        },
        {
            key: 'displayName',
            name: 'Display Name',
            minWidth: 200,
            maxWidth: 260,
            onRender: (userModel) => {
                var _a, _b;
                return (react_1.default.createElement(links_1.Link, { to: `/users/edit/${userModel.id}` },
                    react_1.default.createElement(react_2.Stack, null,
                        react_1.default.createElement(react_2.Stack.Item, null,
                            react_1.default.createElement(react_2.Text, null, (_a = userModel === null || userModel === void 0 ? void 0 : userModel.firstName) !== null && _a !== void 0 ? _a : '',
                                " ", (_b = userModel === null || userModel === void 0 ? void 0 : userModel.lastName) !== null && _b !== void 0 ? _b : '')),
                        react_1.default.createElement(react_2.Stack.Item, null,
                            react_1.default.createElement(react_2.Text, { style: { opacity: 0.9 }, variant: "small" }, userModel.email)))));
            },
        },
        {
            key: 'staticDisplayName',
            name: 'Display Name',
            minWidth: 200,
            maxWidth: 260,
            onRender: (userModel) => {
                var _a, _b;
                return (react_1.default.createElement(react_2.Stack, null,
                    react_1.default.createElement(react_2.Stack.Item, null,
                        react_1.default.createElement(react_2.Text, null, (_a = userModel === null || userModel === void 0 ? void 0 : userModel.firstName) !== null && _a !== void 0 ? _a : '',
                            " ", (_b = userModel === null || userModel === void 0 ? void 0 : userModel.lastName) !== null && _b !== void 0 ? _b : '')),
                    react_1.default.createElement(react_2.Stack.Item, null,
                        react_1.default.createElement(react_2.Text, { style: { opacity: 0.9 }, variant: "small" }, userModel.email))));
            },
        },
        {
            key: 'groups',
            fieldName: 'groups',
            name: 'Groups',
            minWidth: 80,
            onRender: ({ groups }) => (react_1.default.createElement("div", null, groups.map((group) => group.name).join(', '))),
        },
        {
            key: 'status',
            fieldName: 'status',
            name: 'Status',
            minWidth: 0,
        },
        {
            key: 'createdAt',
            fieldName: 'createdAt',
            name: 'Created At',
            minWidth: 200,
            onRender: ({ createdAt }) => (react_1.default.createElement("div", null, (0, misc_1.formatDate)(createdAt))),
        },
    ], []);
    const columns = (0, react_1.useMemo)(() => availableColumns.filter(({ key }) => visibleColumns.includes(key)), [visibleColumns]);
    return (react_1.default.createElement("div", { className: styles.userList },
        react_1.default.createElement(react_2.MarqueeSelection, { selection: selection, isDraggingConstrainedToRoot: true },
            react_1.default.createElement(react_2.ShimmeredDetailsList, Object.assign({ enableShimmer: list === null || list === void 0 ? void 0 : list.loading, selection: selection, selectionMode: selection.mode, setKey: "multiple", selectionPreservedOnEmptyClick: true, onItemInvoked: (item) => {
                    history.push(`/users/edit/${item.id}`);
                }, items: listUsers !== null && listUsers !== void 0 ? listUsers : [], columns: columns }, props)))));
};
exports.default = UserList;
