"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const users_context_1 = require("../context/users.context");
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const back_panel_1 = __importDefault(require("../../../components/back-panel"));
const hoc_1 = require("../../../helpers/hoc");
const user_select_1 = __importDefault(require("./user-select"));
const UserSelectPanel = (0, react_1.forwardRef)(({ panelProps = {}, listProps = { visibleColumns: ['avatar', 'staticDisplayName'] }, commandBarProps = { visibleColumns: ['search', 'refresh'] }, suppressDefaultUpdates = false, onDismiss, onSubmit, onBack, isOpen, }, ref) => {
    const usersContext = (0, users_context_1.useUsers)();
    const { selectedUsers } = usersContext;
    (0, react_1.useImperativeHandle)(ref, () => ({
        usersContext,
    }));
    const onRenderFooterContent = (0, react_1.useCallback)(() => (react_1.default.createElement(react_2.Stack, { horizontal: true, tokens: { childrenGap: 10 } },
        react_1.default.createElement(react_2.PrimaryButton, { disabled: selectedUsers.length === 0, onClick: () => onSubmit === null || onSubmit === void 0 ? void 0 : onSubmit(selectedUsers) }, "Select"),
        react_1.default.createElement(react_2.DefaultButton, { onClick: () => (onBack ? onBack === null || onBack === void 0 ? void 0 : onBack() : onDismiss === null || onDismiss === void 0 ? void 0 : onDismiss()) }, "Cancel"))), [selectedUsers, onSubmit, onDismiss, onBack]);
    return (react_1.default.createElement(back_panel_1.default, Object.assign({ title: "Select users", isFooterAtBottom: true, onRenderFooterContent: onRenderFooterContent, onDismiss: onDismiss, onBack: onBack, type: react_2.PanelType.medium, isOpen: isOpen }, panelProps),
        react_1.default.createElement(user_select_1.default, { listProps: listProps, commandBarProps: commandBarProps, suppressDefaultUpdates: suppressDefaultUpdates, unwrap: true })));
});
exports.default = (0, hoc_1.composeWrappers)({
    usersContext: users_context_1.UsersContextProvider,
})(UserSelectPanel);
