"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UsersContextProvider = exports.withUsers = exports.useUsers = exports.UsersContext = void 0;
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const api_1 = __importStar(require("../../../helpers/api"));
const hooks_1 = require("../../../helpers/hooks");
const hoc_1 = require("../../../helpers/hoc");
const selection_1 = require("../../../helpers/selection");
exports.UsersContext = (0, react_1.createContext)({});
const UsersContextProvider = ({ children, defaultSelectedUsers = [], selectionMode = react_2.SelectionMode.multiple, }) => {
    const [selectedUsers, setSelectedUsers] = (0, react_1.useState)([]);
    const [listParams, setListParams] = (0, react_1.useState)({});
    const usersState = (0, hooks_1.useModelState)([]);
    const selection = (0, selection_1.useSelection)({
        onSelectionChanged: () => {
            setSelectedUsers(selection.getSelection());
        },
        getKey: (user) => user.id,
        selectionMode,
        defaultSelectedItems: defaultSelectedUsers,
    });
    (0, react_1.useEffect)(() => {
        // Refresh selection
        selection.setItems(usersState.arrayState, false);
        setSelectedUsers(selection.getSelection());
    }, [usersState.arrayState]);
    const list = (0, api_1.useApiCallback)(() => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.get('/users', {
            params: Object.assign({ expand: 'meta,groups' }, listParams),
        });
        usersState.setArrayState(response.data);
        return response;
    }));
    const get = (0, api_1.useApiCallback)((id) => __awaiter(void 0, void 0, void 0, function* () { return api_1.default.get(`/users/${id}`, { params: { expand: 'meta,groups' } }); }));
    const create = (0, api_1.useApiCallback)((params) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.post('/users', params);
        usersState.create([response.data]);
        return response;
    }));
    const deleteMany = (0, api_1.useApiCallback)((ids) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.delete('/users', { data: { ids } });
        usersState.delete(ids);
        return response;
    }));
    const update = (0, api_1.useApiCallback)((id, params) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.put(`/users/${id}`, params);
        usersState.update([response.data]);
        return response;
    }));
    const updateMany = (0, api_1.useApiCallback)((data) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield api_1.default.put('/users', data);
        usersState.update(response.data);
        return response;
    }));
    const resetPassword = (0, api_1.useApiCallback)((data) => __awaiter(void 0, void 0, void 0, function* () { return api_1.default.post(`/users/reset-password/${data.id}`, data); }));
    return (react_1.default.createElement(exports.UsersContext.Provider, { value: {
            list,
            get,
            create,
            deleteMany,
            selectedUsers,
            selection,
            update,
            updateMany,
            resetPassword,
            users: usersState.arrayState,
            usersState,
            listParams,
            setListParams,
        } }, children));
};
exports.UsersContextProvider = UsersContextProvider;
const useUsers = () => (0, react_1.useContext)(exports.UsersContext);
exports.useUsers = useUsers;
const withUsers = (0, hoc_1.withWrapper)(UsersContextProvider);
exports.withUsers = withUsers;
