"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withGroupsContext = exports.composeWrappers = exports.withWrapper = void 0;
const react_1 = __importStar(require("react"));
const groups_context_1 = require("../features/groups/context/groups.context");
const lodash_1 = __importDefault(require("lodash"));
function withWrapper(Wrapper, defaultWrapperProps = {}) {
    return function (Component) {
        return (props) => (react_1.default.createElement(Wrapper, Object.assign({}, defaultWrapperProps),
            react_1.default.createElement(Component, Object.assign({}, props))));
    };
}
exports.withWrapper = withWrapper;
function composeWrappers(wrappers) {
    return function (Component) {
        return (0, react_1.forwardRef)((_a, ref) => {
            var { unwrap = false } = _a, allProps = __rest(_a, ["unwrap"]);
            const keys = Object.keys(wrappers).filter((k) => { var _a; return !((_a = allProps[k]) === null || _a === void 0 ? void 0 : _a.disable); });
            const props = lodash_1.default.omit(allProps, keys);
            const restProps = lodash_1.default.pick(allProps, keys);
            if (unwrap || keys.length === 0) {
                return react_1.default.createElement(Component, Object.assign({}, props, { ref: ref }));
            }
            return (react_1.default.createElement(react_1.default.Fragment, null, keys.reduceRight((children, currentKey) => {
                var _a;
                const CurrentWrapper = wrappers[currentKey];
                const currentWrapperProps = (_a = restProps === null || restProps === void 0 ? void 0 : restProps[currentKey]) !== null && _a !== void 0 ? _a : {};
                return (react_1.default.createElement(CurrentWrapper, Object.assign({}, currentWrapperProps), children));
            }, react_1.default.createElement(Component, Object.assign({}, props, { ref: ref })))));
        });
    };
}
exports.composeWrappers = composeWrappers;
const withGroupsContext = withWrapper(groups_context_1.GroupsContextProvider);
exports.withGroupsContext = withGroupsContext;
