"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatDate = exports.convertModelArrayToObject = exports.userPersonaText = exports.userMeta = void 0;
const date_fns_1 = require("date-fns");
const userMeta = (user, key) => { var _a, _b; return (_b = (_a = user === null || user === void 0 ? void 0 : user.meta) === null || _a === void 0 ? void 0 : _a.find((meta) => meta.key === key)) === null || _b === void 0 ? void 0 : _b.value; };
exports.userMeta = userMeta;
const userPersonaText = (user) => {
    var _a, _b;
    const firstName = (_a = user === null || user === void 0 ? void 0 : user.firstName) !== null && _a !== void 0 ? _a : '';
    const lastName = (_b = user === null || user === void 0 ? void 0 : user.lastName) !== null && _b !== void 0 ? _b : '';
    const displayName = `${firstName} ${lastName}`;
    return !displayName.trim() ? user.email : displayName;
};
exports.userPersonaText = userPersonaText;
const convertModelArrayToObject = (model, key = 'id') => {
    const object = {};
    model.forEach((o) => {
        object[o[key]] = o;
    });
    return object;
};
exports.convertModelArrayToObject = convertModelArrayToObject;
const formatDate = (date) => {
    if (!date)
        return undefined;
    if (typeof date === 'string')
        date = new Date(date);
    return (0, date_fns_1.format)(date, 'yyyy.MM.dd hh:mm');
};
exports.formatDate = formatDate;
