"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("../util/env.util");
const database_driver_1 = require("../../server/drivers/database.driver");
const server_1 = require("../../shared/features/server");
const hooks_1 = __importDefault(require("../../shared/features/hooks"));
const express_1 = __importDefault(require("express"));
const path_util_1 = __importDefault(require("../util/path.util"));
const mail_driver_1 = require("../../server/drivers/mail.driver");
// Safe to compile as it won't import webpack
(() => __awaiter(void 0, void 0, void 0, function* () {
    hooks_1.default.addAction('server/init', (app) => __awaiter(void 0, void 0, void 0, function* () {
        app.use('/admin', express_1.default.static(path_util_1.default.build('admin')));
        app.get('/admin/*', (req, res) => {
            res.sendFile(path_util_1.default.build('admin', 'index.html'));
        });
    }), { id: 'core/runWebpack' });
    require('../../index');
    yield Promise.all([(0, database_driver_1.connectDatabaseDriver)(), (0, mail_driver_1.connectMailDriver)()]);
    yield (0, server_1.launch)();
}))();
