"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const content_type_util_1 = require("../util/content-type.util");
const exportContentTypes = () => __awaiter(void 0, void 0, void 0, function* () {
    const components = [];
    REQUIRE_STATEMENTS.forEach(requireStatement => {
        try {
            components.push(requireStatement.require());
        }
        catch (e) {
            console.error('Failed to load ', requireStatement.file, '. Skipping...');
            console.log(e);
        }
    });
    const contentTypes = (0, content_type_util_1.joinContentTypes)(components);
    yield (0, content_type_util_1.writeContentTypes)(contentTypes);
});
(() => __awaiter(void 0, void 0, void 0, function* () {
    switch (COMMAND) {
        case 'export':
        default:
            return exportContentTypes();
    }
}))();
