"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("../util/env.util");
const hooks_1 = __importDefault(require("../../shared/features/hooks"));
const typeorm_1 = require("typeorm");
const database_util_1 = require("../util/database.util");
(() => __awaiter(void 0, void 0, void 0, function* () {
    require('../../index');
    const entities = yield hooks_1.default.applyFilters('db/models', []);
    const connectionManager = (0, typeorm_1.getConnectionManager)();
    const originalCreate = connectionManager.create;
    connectionManager.create = function (options) {
        const databaseType = (0, database_util_1.getDatabaseType)(options.type);
        return originalCreate.call(this, Object.assign(Object.assign({}, options), { entities, type: databaseType }));
    };
    require('typeorm/cli');
}))();
