"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const env_1 = __importDefault(require("../../env"));
const PathUtil = {
    exists: (path) => fs_extra_1.default.existsSync(path),
    root: (...args) => path_1.default.join(env_1.default.rootDir, ...args),
    admin: (...args) => process.env.ADMIN_PATH
        ? path_1.default.join(process.env.ADMIN_PATH, ...args)
        : PathUtil.root('admin', ...args),
    processRoot: (...args) => path_1.default.join(process.cwd(), ...args),
    burdyRoot: (...args) => PathUtil.processRoot('burdy', ...args),
    cache: (...args) => PathUtil.burdyRoot('.cache', ...args),
    projectRoot: (...args) => PathUtil.processRoot('project', ...args),
    build: (...args) => PathUtil.burdyRoot('build', ...args),
    devBuild: (...args) => PathUtil.burdyRoot('.dev-build', ...args),
    database: (...args) => PathUtil.burdyRoot('.database', ...args),
    plugins: (...args) => PathUtil.burdyRoot('plugins', ...args),
};
exports.default = PathUtil;
