"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.compareSync = exports.hashSync = exports.compare = exports.hash = void 0;
const bcrypt_1 = __importDefault(require("bcrypt"));
const defer_promise_1 = __importDefault(require("defer-promise"));
const roundsDef = 10;
const hash = (string, rounds) => __awaiter(void 0, void 0, void 0, function* () {
    const deferred = (0, defer_promise_1.default)();
    bcrypt_1.default.hash(string, rounds || roundsDef, (err, hashString) => {
        if (err)
            return deferred.reject(err);
        return deferred.resolve(hashString);
    });
    return deferred.promise;
});
exports.hash = hash;
const hashSync = (string, rounds) => {
    return bcrypt_1.default.hashSync(string, rounds || roundsDef);
};
exports.hashSync = hashSync;
const compare = (string, hashString) => __awaiter(void 0, void 0, void 0, function* () {
    const deferred = (0, defer_promise_1.default)();
    bcrypt_1.default.compare(string, hashString, (err, result) => {
        if (err) {
            deferred.resolve(false);
        }
        else {
            deferred.resolve(Boolean(result));
        }
    });
    return deferred.promise;
});
exports.compare = compare;
const compareSync = (string, hashString) => bcrypt_1.default.compareSync(string, hashString);
exports.compareSync = compareSync;
