"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const auth_middleware_1 = __importDefault(require("../middleware/auth.middleware"));
const async_middleware_1 = __importDefault(require("../middleware/async.middleware"));
const orm_helpers_1 = require("../common/orm-helpers");
const typeorm_1 = require("typeorm");
const access_token_1 = __importDefault(require("../models/access-token"));
const nanoid_1 = require("nanoid");
const app = (0, express_1.default)();
app.get('/access-tokens', (0, auth_middleware_1.default)(['all']), (0, async_middleware_1.default)((req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const accessTokenRepository = (0, orm_helpers_1.getEnhancedRepository)(access_token_1.default);
    const accessTokens = yield accessTokenRepository.find();
    res.send(accessTokens);
})));
app.post('/access-tokens', (0, auth_middleware_1.default)(['all']), (0, async_middleware_1.default)((req, res) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    const accessTokenRepository = (0, orm_helpers_1.getEnhancedRepository)(access_token_1.default);
    const accessToken = yield accessTokenRepository.save({
        name: (_a = req === null || req === void 0 ? void 0 : req.body) === null || _a === void 0 ? void 0 : _a.name,
        token: (0, nanoid_1.nanoid)()
    });
    res.send(accessToken);
})));
app.delete('/access-tokens', (0, auth_middleware_1.default)(['all']), (0, async_middleware_1.default)((req, res) => __awaiter(void 0, void 0, void 0, function* () {
    var _b;
    const ids = (_b = req === null || req === void 0 ? void 0 : req.body) !== null && _b !== void 0 ? _b : [];
    if (!ids || (ids === null || ids === void 0 ? void 0 : ids.length) === 0)
        return res.send([]);
    const accessTokenRepository = (0, orm_helpers_1.getEnhancedRepository)(access_token_1.default);
    const deleted = yield accessTokenRepository.delete({
        id: (0, typeorm_1.In)(ids)
    });
    return res.send(deleted);
})));
exports.default = app;
