"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const async_middleware_1 = __importDefault(require("../middleware/async.middleware"));
const permissions_1 = require("../../shared/features/permissions");
const app = (0, express_1.default)();
app.get('/permissions', (0, async_middleware_1.default)((req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const permissions = yield (0, permissions_1.getPermissions)();
    res.send(permissions);
})));
exports.default = app;
