"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const async_middleware_1 = __importDefault(require("../middleware/async.middleware"));
const typeorm_1 = require("typeorm");
const site_settings_model_1 = __importDefault(require("../models/site-settings.model"));
const auth_middleware_1 = __importDefault(require("../middleware/auth.middleware"));
const app = (0, express_1.default)();
app.get('/settings', (0, auth_middleware_1.default)(), (0, async_middleware_1.default)((req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const settingsRepository = (0, typeorm_1.getRepository)(site_settings_model_1.default);
    const settings = yield settingsRepository.find();
    res.send(settings);
})));
app.post('/settings', (0, auth_middleware_1.default)(), (0, async_middleware_1.default)((req, res) => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b, _c, _d;
    const settingsRepository = (0, typeorm_1.getRepository)(site_settings_model_1.default);
    let settings = yield settingsRepository.findOne({
        where: {
            key: (_a = req === null || req === void 0 ? void 0 : req.body) === null || _a === void 0 ? void 0 : _a.key
        }
    });
    if (settings) {
        settings.value = (_b = req === null || req === void 0 ? void 0 : req.body) === null || _b === void 0 ? void 0 : _b.value;
        yield settingsRepository.save(settings);
    }
    else {
        settings = yield settingsRepository.save({
            key: (_c = req === null || req === void 0 ? void 0 : req.body) === null || _c === void 0 ? void 0 : _c.key,
            value: (_d = req === null || req === void 0 ? void 0 : req.body) === null || _d === void 0 ? void 0 : _d.value
        });
    }
    res.send(settings);
})));
exports.default = app;
