"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const hooks_1 = __importDefault(require("../../shared/features/hooks"));
const cookie_parser_1 = __importDefault(require("cookie-parser"));
const server_controller_1 = __importDefault(require("../controllers/server.controller"));
const user_controller_1 = __importDefault(require("../controllers/user.controller"));
const group_controller_1 = __importDefault(require("../controllers/group.controller"));
const permission_controller_1 = __importDefault(require("../controllers/permission.controller"));
const asset_controller_1 = __importDefault(require("../controllers/asset.controller"));
const post_controller_1 = __importDefault(require("../controllers/post.controller"));
const settings_controller_1 = __importDefault(require("../controllers/settings.controller"));
const content_type_controller_1 = __importDefault(require("../controllers/content-type.controller"));
const tag_controller_1 = __importDefault(require("../controllers/tag.controller"));
const public_controller_1 = __importDefault(require("../controllers/public.controller"));
const backup_controller_1 = __importDefault(require("../controllers/backup.controller"));
const access_token_controller_1 = __importDefault(require("../controllers/access-token.controller"));
hooks_1.default.addAction('api/init', (app) => __awaiter(void 0, void 0, void 0, function* () {
    app.use((req, res, next) => {
        const origin = req.get('origin');
        res.header('Access-Control-Allow-Origin', origin || '*');
        res.header('Access-Control-Allow-Headers', 'content-type, auth-token');
        res.header('Access-Control-Expose-Headers', 'content-type, auth-token');
        res.header('Access-Control-Allow-Credentials', 'true');
        res.header('Access-Control-Allow-Methods', 'GET,PUT,POST,DELETE,PATCH');
        next();
    });
    app.use((0, cookie_parser_1.default)(process.env.SIGNED_COOKIE));
    app.use(express_1.default.json({ limit: process.env.REQ_LIMIT }));
    app.use(express_1.default.urlencoded({ limit: process.env.REQ_LIMIT, extended: true }));
    app.use(public_controller_1.default);
    app.use(content_type_controller_1.default);
    app.use(asset_controller_1.default);
    app.use(post_controller_1.default);
    app.use(permission_controller_1.default);
    app.use(server_controller_1.default);
    app.use(user_controller_1.default);
    app.use(group_controller_1.default);
    app.use(settings_controller_1.default);
    app.use(tag_controller_1.default);
    app.use(backup_controller_1.default);
    app.use(access_token_controller_1.default);
}), { id: 'core/controllers' });
