"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const hooks_1 = __importDefault(require("../../shared/features/hooks"));
const site_settings_model_1 = __importDefault(require("../models/site-settings.model"));
const group_model_1 = __importDefault(require("../models/group.model"));
const orm_helpers_1 = require("../common/orm-helpers");
hooks_1.default.addAction('core/init', () => __awaiter(void 0, void 0, void 0, function* () {
    const siteRepository = (0, orm_helpers_1.getEnhancedRepository)(site_settings_model_1.default);
    try {
        yield siteRepository.findOneOrFail({ where: { key: 'firstInit' } });
    }
    catch (e) {
        yield hooks_1.default.doAction('core/firstInit');
        yield siteRepository.insert({ key: 'firstInit', value: true });
    }
}), { id: 'core/init.checkIfFirst' });
hooks_1.default.addAction('core/firstInit', () => __awaiter(void 0, void 0, void 0, function* () {
    try {
        const groupRepository = (0, orm_helpers_1.getEnhancedRepository)(group_model_1.default);
        yield groupRepository.insert([
            {
                name: 'Admin',
                permissions: ['all'],
                description: 'Role that enables access to every resource. Protected and therefore, cannot be edited.',
                protected: true,
            },
            {
                name: 'User',
                permissions: [],
                description: 'Role which allows customers to have access to basic resources (such as authentication).',
                protected: false,
            },
        ]);
    }
    catch (e) {
        console.log('Error initializing default entries.');
    }
}), { id: 'core/firstInit.createGroups' });
