"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const hooks_1 = __importDefault(require("../../shared/features/hooks"));
const asset_model_1 = __importDefault(require("../models/asset.model"));
const asset_meta_model_1 = __importDefault(require("../models/asset-meta.model"));
const content_type_model_1 = __importDefault(require("../models/content-type.model"));
const group_model_1 = __importDefault(require("../models/group.model"));
const post_model_1 = __importDefault(require("../models/post.model"));
const post_meta_model_1 = __importDefault(require("../models/post-meta.model"));
const site_settings_model_1 = __importDefault(require("../models/site-settings.model"));
const tag_model_1 = __importDefault(require("../models/tag.model"));
const tag_meta_model_1 = __importDefault(require("../models/tag-meta.model"));
const user_model_1 = __importDefault(require("../models/user.model"));
const user_meta_model_1 = __importDefault(require("../models/user-meta.model"));
const user_session_model_1 = __importDefault(require("../models/user-session.model"));
const user_token_model_1 = __importDefault(require("../models/user-token.model"));
const backup_model_1 = __importDefault(require("../models/backup.model"));
const access_token_1 = __importDefault(require("../models/access-token"));
hooks_1.default.addFilter('db/models', (args) => __awaiter(void 0, void 0, void 0, function* () {
    return [
        access_token_1.default,
        asset_model_1.default,
        asset_meta_model_1.default,
        backup_model_1.default,
        content_type_model_1.default,
        group_model_1.default,
        post_model_1.default,
        post_meta_model_1.default,
        site_settings_model_1.default,
        tag_model_1.default,
        tag_meta_model_1.default,
        user_model_1.default,
        user_meta_model_1.default,
        user_session_model_1.default,
        user_token_model_1.default,
        ...args
    ];
}));
