"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = __importDefault(require("../../shared/features/logger"));
const asyncMiddleware = (fn) => (req, res, next) => {
    const data = {
        url: req.originalUrl,
        method: req.method,
    };
    if (req.params) {
        data.params = req.params;
    }
    if (req.body) {
        data.body = req.body;
    }
    if (req.query) {
        data.query = req.query;
    }
    logger_1.default.debug({
        type: 'BURDY_RQ',
        data,
    });
    Promise.resolve(fn(req, res, next)).catch(next);
};
exports.default = asyncMiddleware;
