"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const base_error_1 = __importDefault(require("../errors/base-error"));
const yup_1 = require("yup");
const typeorm_1 = require("typeorm");
const errorMiddleware = (err, req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
    if (err instanceof base_error_1.default) {
        return res.status(err.getStatusCode()).send(err.toJson());
    }
    if (err instanceof yup_1.ValidationError) {
        res.status(400).send(err);
    }
    if (err instanceof typeorm_1.FindRelationsNotFoundError) {
        res.status(400).send(err.message);
    }
    console.log(err); // TODO log
    return res.status(500).send();
});
exports.default = errorMiddleware;
