/**
 * Models are backend blabla
 *
 * @packageDocumentation
 * @module Models
 * @preferred
 */
import { BaseEntity } from 'typeorm';
import AssetMeta from '@server/models/asset-meta.model';
import { IAsset } from '@shared/interfaces/model';
import User from './user.model';
import Tag from './tag.model';
export default class Asset extends BaseEntity implements IAsset {
    id: number;
    name: string;
    provider?: string;
    document?: string;
    mimeType?: string;
    contentLength?: number;
    createdAt: Date;
    updatedAt: Date;
    parent?: Asset;
    parentId?: number;
    author: User;
    children?: Asset[];
    meta?: AssetMeta[];
    npath?: string;
    thumbnail?: string;
    tags: Tag[];
    static getAncestorsList(entity: Asset): Asset[];
}
