"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Models are backend blabla
 *
 * @packageDocumentation
 * @module Models
 * @preferred
 */
const typeorm_1 = require("typeorm");
const asset_meta_model_1 = __importDefault(require("./asset-meta.model"));
const user_model_1 = __importDefault(require("./user.model"));
const tag_model_1 = __importDefault(require("./tag.model"));
let Asset = class Asset extends typeorm_1.BaseEntity {
    static getAncestorsList(entity) {
        if (!(entity === null || entity === void 0 ? void 0 : entity.id)) {
            return [];
        }
        let result = [];
        result.push(entity);
        if (entity.parent) {
            result = [...result, ...this.getAncestorsList(entity.parent)];
        }
        return result;
    }
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('increment'),
    __metadata("design:type", Number)
], Asset.prototype, "id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    (0, typeorm_1.Index)(),
    __metadata("design:type", String)
], Asset.prototype, "name", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], Asset.prototype, "provider", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], Asset.prototype, "document", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], Asset.prototype, "mimeType", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], Asset.prototype, "contentLength", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)(),
    __metadata("design:type", Date)
], Asset.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)(),
    __metadata("design:type", Date)
], Asset.prototype, "updatedAt", void 0);
__decorate([
    (0, typeorm_1.TreeParent)({
        onDelete: 'CASCADE'
    }),
    __metadata("design:type", Asset)
], Asset.prototype, "parent", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], Asset.prototype, "parentId", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => user_model_1.default, {
        onDelete: 'SET NULL',
        nullable: true
    }),
    __metadata("design:type", user_model_1.default)
], Asset.prototype, "author", void 0);
__decorate([
    (0, typeorm_1.TreeChildren)({ cascade: ['insert', 'remove', 'update'] }),
    __metadata("design:type", Array)
], Asset.prototype, "children", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => asset_meta_model_1.default, (assetMeta) => assetMeta.asset, {
        cascade: ['insert', 'remove', 'update'],
        eager: true,
    }),
    __metadata("design:type", Array)
], Asset.prototype, "meta", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true, unique: true }),
    __metadata("design:type", String)
], Asset.prototype, "npath", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true, insert: false, update: false, select: false }),
    __metadata("design:type", String)
], Asset.prototype, "thumbnail", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => tag_model_1.default),
    (0, typeorm_1.JoinTable)(),
    __metadata("design:type", Array)
], Asset.prototype, "tags", void 0);
Asset = __decorate([
    (0, typeorm_1.Entity)(),
    (0, typeorm_1.Tree)('materialized-path')
], Asset);
exports.default = Asset;
