import { BaseEntity } from 'typeorm';
import { IContentType, IPost, IPostMeta } from '@shared/interfaces/model';
import User from './user.model';
import Tag from './tag.model';
export default class Post extends BaseEntity implements IPost {
    id: number;
    name: string;
    slug: string;
    slugPath: string;
    type: string;
    contentTypeId?: number;
    contentType?: IContentType;
    content: any;
    createdAt: Date;
    updatedAt: Date;
    status?: string;
    publishedAt?: Date;
    publishedFrom?: Date;
    publishedUntil?: Date;
    author: User;
    parent?: IPost;
    parentId?: number;
    children?: IPost[];
    meta: IPostMeta[];
    tags: Tag[];
    static getAncestorsList(entity: IPost): IPost[];
}
