"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const typeorm_1 = require("typeorm");
const post_meta_model_1 = __importDefault(require("./post-meta.model"));
const user_model_1 = __importDefault(require("./user.model"));
const content_type_model_1 = __importDefault(require("./content-type.model"));
const tag_model_1 = __importDefault(require("./tag.model"));
let Post = class Post extends typeorm_1.BaseEntity {
    static getAncestorsList(entity) {
        if (!(entity === null || entity === void 0 ? void 0 : entity.id)) {
            return [];
        }
        let result = [];
        result.push(entity);
        if (entity.parent) {
            result = [...result, ...this.getAncestorsList(entity.parent)];
        }
        return result;
    }
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('increment'),
    __metadata("design:type", Number)
], Post.prototype, "id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Post.prototype, "name", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Post.prototype, "slug", void 0);
__decorate([
    (0, typeorm_1.Column)({ unique: true }),
    __metadata("design:type", String)
], Post.prototype, "slugPath", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Post.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], Post.prototype, "contentTypeId", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => content_type_model_1.default, (contentType) => contentType.posts, {
        onDelete: 'CASCADE',
        onUpdate: 'CASCADE'
    }),
    __metadata("design:type", Object)
], Post.prototype, "contentType", void 0);
__decorate([
    (0, typeorm_1.Column)('text', { nullable: true }),
    __metadata("design:type", Object)
], Post.prototype, "content", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)(),
    __metadata("design:type", Date)
], Post.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)(),
    __metadata("design:type", Date)
], Post.prototype, "updatedAt", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true, default: 'draft' }),
    __metadata("design:type", String)
], Post.prototype, "status", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Date)
], Post.prototype, "publishedAt", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Date)
], Post.prototype, "publishedFrom", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Date)
], Post.prototype, "publishedUntil", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => user_model_1.default, {
        onDelete: 'SET NULL',
        nullable: true
    }),
    __metadata("design:type", user_model_1.default)
], Post.prototype, "author", void 0);
__decorate([
    (0, typeorm_1.TreeParent)({
        onDelete: 'CASCADE'
    }),
    __metadata("design:type", Object)
], Post.prototype, "parent", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], Post.prototype, "parentId", void 0);
__decorate([
    (0, typeorm_1.TreeChildren)({ cascade: ['insert', 'remove', 'update'] }),
    __metadata("design:type", Array)
], Post.prototype, "children", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => post_meta_model_1.default, (postMeta) => postMeta.post, {
        cascade: ['insert', 'remove', 'update']
    }),
    __metadata("design:type", Array)
], Post.prototype, "meta", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => tag_model_1.default),
    (0, typeorm_1.JoinTable)(),
    __metadata("design:type", Array)
], Post.prototype, "tags", void 0);
Post = __decorate([
    (0, typeorm_1.Entity)(),
    (0, typeorm_1.Tree)('materialized-path')
], Post);
exports.default = Post;
