import { BaseEntity } from 'typeorm';
import type { ITag, ITagMeta } from '@shared/interfaces/model';
import User from './user.model';
export default class Tag extends BaseEntity implements ITag {
    id: number;
    name: string;
    slug: string;
    slugPath?: string;
    createdAt: Date;
    updatedAt: Date;
    parent?: ITag;
    parentId?: number;
    children?: Tag[];
    meta: ITagMeta[];
    author: User;
    static getAncestorsList(entity: ITag): ITag[];
}
