"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const winston_1 = __importStar(require("winston"));
const winston_daily_rotate_file_1 = __importDefault(require("winston-daily-rotate-file"));
const path_1 = __importDefault(require("path"));
const path_util_1 = __importDefault(require("../../scripts/util/path.util"));
const logLevel = process.env.LOG_LEVEL || 'info';
const logPath = process.env.LOG_PATH
    ? path_1.default.resolve(process.env.LOG_PATH)
    : path_util_1.default.burdyRoot('logs');
const transportProps = {
    zippedArchiver: true,
    maxSize: process.env.LOG_SIZE || '20m',
    maxFiles: process.env.LOG_FILES || '14d',
};
const dailyRotateTransport = new winston_daily_rotate_file_1.default(Object.assign({ filename: path_1.default.join(`${logPath}`, 'burdy-%DATE%.log') }, transportProps));
const errorRotateTransport = new winston_daily_rotate_file_1.default(Object.assign({ filename: path_1.default.join(`${logPath}`, 'burdy-error-%DATE%.log') }, transportProps));
const logger = winston_1.default.createLogger({
    level: logLevel,
    format: winston_1.format.combine(winston_1.format.timestamp(), winston_1.format.json()),
    transports: [dailyRotateTransport],
    exceptionHandlers: [errorRotateTransport],
});
if (process.env.NODE_ENV !== 'production') {
    logger.add(new winston_1.default.transports.Console({
        format: winston_1.format.json(),
    }));
}
exports.default = logger;
