"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.slugRegexMessage = exports.slugRegex = void 0;
const yup = __importStar(require("yup"));
const Validators = {
    firstName: () => yup.string().min(2).required().label('First name'),
    lastName: () => yup.string().min(2).required().label('Last name'),
    email: () => yup.string().email().required().label('Email'),
    password: () => yup.string().min(6).required().label('Password'),
    imageSize: () => yup.object().shape({
        key: yup.string().required().min(2).label('Key'),
        width: yup.number().when('height', {
            is: (height) => !height || height.length === 0,
            then: yup.number().integer().required(),
            otherwise: yup.number().integer()
        }).label('Width'),
        height: yup.number().when('width', {
            is: (width) => !width || width.length === 0,
            then: yup.number().integer().required(),
            otherwise: yup.number().integer()
        }).label('Height'),
        quality: yup.number().integer().min(10).max(100).required().label('Quality'),
        resize: yup.string().oneOf(['cover', 'contain', 'fill', 'inside', 'outside']).label('Resize'),
    }, ['width', 'height'])
};
exports.slugRegex = /^[a-z0-9]+(?:(-|_)[a-z0-9]+)*$/;
exports.slugRegexMessage = 'invalid_pattern';
exports.default = Validators;
