declare const adminDefaultWebpack: {
    mode: string;
    bail: boolean;
    performance: {
        hints: boolean;
    };
    devtool: string | boolean;
    entry: string;
    target: string;
    stats: {
        logging: string;
        all: boolean;
    };
    devServer: {
        hot: boolean;
    };
    output: {
        path: string;
        publicPath: string;
        filename: string;
        chunkFilename: string;
    };
    optimization: {
        minimize: boolean;
        minimizer: any[];
        runtimeChunk: boolean;
    };
    module: {
        rules: ({
            test: RegExp;
            exclude: RegExp;
            use: {
                loader: string;
                options: {
                    cacheDirectory: boolean;
                    cacheCompression: boolean;
                    sourceType: string;
                    presets: (string | (string | {
                        modules: string;
                    })[])[];
                    plugins: ((string | {
                        root: string[];
                        alias: {
                            '@admin': string;
                            '@drivers': string;
                            '@features': string;
                            '@interfaces': string;
                            '@listeners': string;
                            '@models': string;
                            '@scripts': string;
                            '@server': string;
                            '@shared': string;
                        };
                    })[] | (string | {
                        helpers: boolean;
                        regenerator: boolean;
                    })[])[];
                };
            }[];
            loader?: undefined;
            options?: undefined;
        } | {
            test: RegExp;
            exclude: RegExp[];
            use: string[];
            loader?: undefined;
            options?: undefined;
        } | {
            test: RegExp;
            use: (string | {
                loader: string;
                options: {
                    modules: boolean;
                    additionalData?: undefined;
                };
            } | {
                loader: string;
                options: {
                    additionalData: string;
                    modules?: undefined;
                };
            })[];
            exclude?: undefined;
            loader?: undefined;
            options?: undefined;
        } | {
            test: RegExp;
            use: string;
            exclude?: undefined;
            loader?: undefined;
            options?: undefined;
        } | {
            test: RegExp[];
            loader: string;
            options: {
                limit: number;
            };
            exclude?: undefined;
            use?: undefined;
        } | {
            test: RegExp;
            loader: string;
            options: {
                limit: number;
            };
            exclude?: undefined;
            use?: undefined;
        })[];
    };
    resolve: {
        symlinks: boolean;
        extensions: string[];
        mainFields: string[];
        fallback: {};
    };
    plugins: any[];
};
export default adminDefaultWebpack;
